SystemOrganization addCategory: #'ActiveContext-Core'!
SystemOrganization addCategory: #'ActiveContext-Utils'!
SystemOrganization addCategory: #'ActiveContext-Tests'!
SystemOrganization addCategory: #'ActiveContext-Kernel'!

Trait named: #TClassResolution
	uses: {}
	category: 'ActiveContext-Core'!

!TClassResolution methodsFor: 'as yet unclassified' stamp: 'ewe 9/26/2012 14:41'!
replaceClassResolution: aVariableNode

"| newName newCls | "

"Transcript show: aVariableNode name; cr. "

"(aVariableNode name = 'Array') ifTrue: [ newName := 'Array2' ].
(aVariableNode name = 'HashedCollection') ifTrue: [ newName := 'HashedCollection2' ].
(aVariableNode name = 'Dictionary') ifTrue: [ newName := 'Dictionary2' ].
(aVariableNode name = 'IdentityDictionary') ifTrue: [ newName := 'IdentityDictionary2' ].
(aVariableNode name = 'Set') ifTrue: [ newName := 'Set2' ].
(aVariableNode name = 'LookupKey') ifTrue: [ newName := 'LookupKey2' ].
(aVariableNode name = 'Association') ifTrue: [ newName := 'Association2' ].
(aVariableNode name = 'OrderedCollection') ifTrue: [ newName := 'OrderedCollection2' ]."

"(aVariableNode name = 'Array2') ifTrue: [ newName := 'Array22' ].
(aVariableNode name = 'HashedCollection2') ifTrue: [ newName := 'HashedCollection22' ].
(aVariableNode name = 'Dictionary2') ifTrue: [ newName := 'Dictionary22' ].
(aVariableNode name = 'IdentityDictionary2') ifTrue: [ newName := 'IdentityDictionary22' ].
(aVariableNode name = 'Set2') ifTrue: [ newName := 'Set22' ].
(aVariableNode name = 'LookupKey2') ifTrue: [ newName := 'LookupKey22' ].
(aVariableNode name = 'Association2') ifTrue: [ newName := 'Association22' ].
(aVariableNode name = 'OrderedCollection2') ifTrue: [ newName := 'OrderedCollection22' ]."

"newName:= (aVariableNode name , '2').
newCls := Smalltalk at: newName asSymbol ifAbsent: [ nil ]."

"newName isNil ifFalse: [
		aVariableNode token value: newName. 
].
^ super replaceClassResolution: aVariableNode ."


		| m rec args c lit  cls |
				
				rec := RBVariableNode named: 'self'.
				rec parent: aVariableNode parent.
				
				lit := RBLiteralNode value: (aVariableNode  name).
				lit parent: aVariableNode parent.
					
				args := Array new: 1..
				args at: 1 put: lit.
				
				m := RBMessageNode 
							receiver: rec
							selector: #ctxClass:
							arguments: args.
				m parent: aVariableNode parent.
				
				aVariableNode replaceWith: m.
				
				self visitNode: m.! !

Trait named: #TOptimizedAccessors
	uses: {}
	category: 'ActiveContext-Core'!

!TOptimizedAccessors methodsFor: 'as yet unclassified' stamp: 'ewe 11/2/2012 15:45'!
replaceClassVarRead: aVariableNode

		| m rec args c readSelector  t cls |
				
				rec := RBVariableNode named: 'self'.
				rec parent: aVariableNode parent.
					
				readSelector := 	#ctxRead , aVariableNode name .
							
				cls := RBMessageNode 
					receiver: rec
					selector: #class
					arguments: #().
						
				m := RBMessageNode 
					receiver: cls
					selector: readSelector 
					arguments: #().
					
				m parent: aVariableNode parent.
				
				aVariableNode replaceWith: m.
				
				^self visitNode: m.! !

!TOptimizedAccessors methodsFor: 'as yet unclassified' stamp: 'ewe 11/2/2012 15:44'!
replaceClassVarWrite: anAssignmentNode

		| m rec args c writeSelector lit2 cls |
				
				rec := RBVariableNode named: 'self'.
				rec parent: anAssignmentNode parent.
				
				writeSelector := #ctxWrite , anAssignmentNode variable name , ':' asSymbol .
				
				args := Array new: 1.
				args at: 1 put: (anAssignmentNode value).
				
				cls := RBMessageNode 
					receiver: rec
					selector: #class
					arguments: #().
						
				m := RBMessageNode 
					receiver: cls
					selector: writeSelector 
					arguments: args.
					
				m parent: anAssignmentNode parent.
				
				anAssignmentNode replaceWith: m.
				
				self visitNode: m.! !

!TOptimizedAccessors methodsFor: 'as yet unclassified' stamp: 'ewe 10/31/2012 06:42'!
replaceInstVarRead: aVariableNode

		| m rec args c readSelector  t |
				
				rec := RBVariableNode named: 'self'.
				rec parent: aVariableNode parent.
					
				readSelector := 	#ctxRead , aVariableNode name .
									
				m := RBMessageNode 
							receiver: rec
							selector: readSelector 
							arguments: #().
				m parent: aVariableNode parent.
				
				aVariableNode replaceWith: m.
				
				^self visitNode: m.! !

!TOptimizedAccessors methodsFor: 'as yet unclassified' stamp: 'ewe 9/26/2012 14:42'!
replaceInstVarWrite: anAssignmentNode

		| m rec args c writeSelector lit2 |
				
				rec := RBVariableNode named: 'self'.
				rec parent: anAssignmentNode parent.
				
				writeSelector := #ctxWrite , anAssignmentNode variable name , ':' asSymbol .
				
				args := Array new: 1.
				args at: 1 put: (anAssignmentNode value).
				
				m := RBMessageNode 
							receiver: rec
							selector: writeSelector 
							arguments: args.
				m parent: anAssignmentNode parent.
				
				anAssignmentNode replaceWith: m.
				
				self visitNode: m.! !

Trait named: #TRegularAccessors
	uses: {}
	category: 'ActiveContext-Core'!

!TRegularAccessors methodsFor: 'as yet unclassified' stamp: 'ewe 9/26/2012 14:41'!
replaceClassVarRead: aVariableNode

		| m cls rec args c lit  t |
				
				
				rec := RBVariableNode named: 'self'.
				rec parent: aVariableNode parent.
						
				lit := RBLiteralNode value: (aVariableNode  name).
				lit parent: aVariableNode parent.
				
				
				args := Array new: 1.
				args at: 1 put: (lit).
				
				cls := RBMessageNode 
							receiver: rec
							selector: #class
							arguments: #().
							
				m := RBMessageNode 
							receiver: cls
							selector: #ctxRead:
							arguments: args.
				m parent: aVariableNode parent.
				
				aVariableNode replaceWith: m.
				
				self visitNode: m.! !

!TRegularAccessors methodsFor: 'as yet unclassified' stamp: 'ewe 9/26/2012 14:41'!
replaceClassVarWrite: anAssignmentNode

		| m cls rec args c lit lit2 |
				
				rec := RBVariableNode named: 'self'.
				rec parent: anAssignmentNode parent.
				
				lit := RBLiteralNode value: (anAssignmentNode variable name).
				lit parent: anAssignmentNode parent.
				
				args := Array new: 2.
				args at: 1 put: ( lit ).
				args at: 2 put: (anAssignmentNode value).
				
				cls := RBMessageNode 
					receiver: rec
					selector: #class
					arguments: #().
						
				m := RBMessageNode 
					receiver: cls
					selector: #ctxWrite:value:
					arguments: args.
					
				m parent: anAssignmentNode parent.
				
				anAssignmentNode replaceWith: m.
				
				self visitNode: m.! !

!TRegularAccessors methodsFor: 'as yet unclassified' stamp: 'ewe 9/26/2012 14:41'!
replaceInstVarRead: aVariableNode

		| m rec args c lit  t |
				
				
				rec := RBVariableNode named: 'self'.
				rec parent: aVariableNode parent.
						
				lit := RBLiteralNode value: (aVariableNode  name).
				lit parent: aVariableNode parent.
				
				
				args := Array new: 1.
				args at: 1 put: (lit).
				
				m := RBMessageNode 
							receiver: rec
							selector: #ctxRead:
							arguments: args.
				m parent: aVariableNode parent.
				
				aVariableNode replaceWith: m.
				
				self visitNode: m.! !

!TRegularAccessors methodsFor: 'as yet unclassified' stamp: 'ewe 9/26/2012 14:41'!
replaceInstVarWrite: anAssignmentNode

		| m rec args c lit lit2 |
				
				rec := RBVariableNode named: 'self'.
				rec parent: anAssignmentNode parent.
				
				lit := RBLiteralNode value: (anAssignmentNode variable name).
				lit parent: anAssignmentNode parent.
				
				args := Array new: 2.
				args at: 1 put: ( lit ).
				args at: 2 put: (anAssignmentNode value).
				
				m := RBMessageNode 
							receiver: rec
							selector: #ctxWrite:value:
							arguments: args.
				m parent: anAssignmentNode parent.
				
				anAssignmentNode replaceWith: m.
				
				self visitNode: m.! !

Trait named: #TStaticClassResolution
	uses: {}
	category: 'ActiveContext-Core'!

!TStaticClassResolution methodsFor: 'as yet unclassified' stamp: 'ewe 11/6/2012 14:06'!
replaceClassResolution: aVariableNode

| newName oldName newCls currentNonMetaClassName | 

"Transcript show: aVariableNode name; cr. "

oldName := aVariableNode name. 
currentNonMetaClassName := self compiledClass theNonMetaClass name. 

(currentNonMetaClassName endsWith: '1') ifTrue: [

	(oldName = 'Array') ifTrue: [ newName := 'ArrayL1' ].
	(oldName = 'HashedCollection') ifTrue: [ newName := 'HashedCollectionL1' ].
	(oldName = 'Dictionary') ifTrue: [ newName := 'DictionaryL1' ].
	(oldName = 'IdentityDictionary') ifTrue: [ newName := 'IdentityDictionaryL1' ].
	(oldName = 'Set') ifTrue: [ newName := 'SetL1' ].
	(oldName = 'LookupKey') ifTrue: [ newName := 'LookupKeyL1' ].
	(oldName = 'Association') ifTrue: [ newName := 'AssociationL1' ].
	(oldName = 'OrderedCollection') ifTrue: [ newName := 'OrderedCollectionL1' ].

	newName isNil ifTrue: [
		((CurrentContext contextualClasses collect: [:cls | cls canonicalName ]) includes: oldName ) ifTrue: [
			newName:= (aVariableNode name , '1').
		] ifFalse: [ 
			Transcript show: ('Is this really a primitive class? ', oldName). 
			newName := oldName. 
		]
	]
] ifFalse: [
	(oldName = 'Array') ifTrue: [ newName := 'ArrayL2' ].
	(oldName = 'HashedCollection') ifTrue: [ newName := 'HashedCollectionL2' ].
	(oldName = 'Dictionary') ifTrue: [ newName := 'DictionaryL2' ].
	(oldName = 'IdentityDictionary') ifTrue: [ newName := 'IdentityDictionaryL2' ].
	(oldName = 'Set') ifTrue: [ newName := 'SetL2' ].
	(oldName = 'LookupKey') ifTrue: [ newName := 'LookupKeyL2' ].
	(oldName = 'Association') ifTrue: [ newName := 'AssociationL2' ]. 
	(oldName = 'OrderedCollection') ifTrue: [ newName := 'OrderedCollectionL2' ].

	newName isNil ifTrue: [ 
		((CurrentContext contextualClasses collect: [:cls | cls canonicalName ]) includes: oldName ) ifTrue: [
			newName:= (aVariableNode name , '2').
		] ifFalse: [
			Transcript show: ('Is this really a primitive class? ', oldName). 
			newName := oldName. 
		]
	]
].

newCls := Smalltalk at: newName asSymbol.
aVariableNode token value: newName. 
! !

!DictionaryL2 methodsFor: '*ActiveContext' stamp: 'ewe 10/11/2012 15:12'!
_postCopy
	<ctxMeta>
	"Must copy the associations, or later store will affect both the
original and the copy"
	self contextInfo: ContextualInfo new.
	self contextInfo global: true.
	self contextInfo allDirtyBit: false.
	self contextInfo uuid: UUID new..
	
	self flag: 'Should we use array copy, or collect the copy of the assoc?'.
	array := array collect: [ :association |
		association ifNotNil: [ association copy ] ]! !

!DictionaryL2 methodsFor: '*activecontext' stamp: 'ewe 11/27/2012 13:35'!
ctxWritearray: v2 __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: 2 . self markOtherAsDirty: 2 ]. ^ array := v2  ! !

!DictionaryL2 methodsFor: '*activecontext' stamp: 'ewe 10/31/2012 05:53'!
isThreadSafe 
	^false ! !

!DictionaryL2 methodsFor: '*ActiveContext' stamp: 'ewe 10/11/2012 14:38'!
postCopy
	<ctxMeta>
	"Must copy the associations, or later store will affect both the
original and the copy"
	super postCopy .
	self flag: 'Should we use array copy, or collect the copy of the assoc?'.
	array := array collect: [ :association |
		association ifNotNil: [ association copy ] ]! !

!DictionaryL2 methodsFor: '*ActiveContext' stamp: 'ewe 10/11/2012 14:38'!
printOn: aStream

	super printOn: aStream .
	
	( self isCtxGlobal and:  [ self contextInfo isNil not ] ) ifTrue: [
		self nextMe isNil ifTrue: [ aStream nextPutAll: 'OLD'  ]
					    ifFalse: [aStream nextPutAll: 'NEW'  ].
	]  ! !

!DictionaryL2 methodsFor: '*activecontext' stamp: 'ewe 10/31/2012 08:52'!
secureSelf
<ctxMeta>
	self primitiveChangeClassTo: DictionaryS2 new.  
	__lock__ := Semaphore forMutualExclusion.
	"we must not use method that are not ctxMeta"
	1 to: array size do: 	[:index | ( array primAt: index ) secure ]
	! !

!HashedCollectionL2 methodsFor: '*activecontext' stamp: 'ewe 10/11/2012 14:38'!
asSet
	"Answer a Set whose elements are the unique elements of the receiver."

	^ Set withAll: self! !

!HashedCollectionL2 methodsFor: '*activecontext' stamp: 'ewe 11/1/2012 07:38'!
contextInfo
	^ __ctxInfo__! !

!HashedCollectionL2 methodsFor: '*activecontext' stamp: 'ewe 11/1/2012 07:38'!
contextInfo: value
	 __ctxInfo__ := value.! !

!HashedCollectionL2 methodsFor: '*activecontext-test' stamp: 'ewe 10/31/2012 05:39'!
first
	^ self at: 1. ! !

!HashedCollectionL2 methodsFor: '*activecontext' stamp: 'ewe 10/11/2012 14:38'!
gather: aBlock
	^ Array streamContents:
		[:stream |
		self do: [:ea | stream nextPutAll: (aBlock value: ea)]]! !

!HashedCollectionL2 methodsFor: '*activecontext-test' stamp: 'ewe 11/1/2012 08:01'!
get
	^self at: 1! !

!HashedCollectionL2 methodsFor: '*activecontext' stamp: 'ewe 11/1/2012 07:38'!
isCtxGlobal
	<ctxMeta>
	^ __ctxInfo__ isNil not. ! !

!HashedCollectionL2 methodsFor: '*activecontext' stamp: 'ewe 10/30/2012 08:50'!
isThreadSafe 
	^false ! !

!HashedCollectionL2 methodsFor: '*activecontext' stamp: 'ewe 11/12/2012 15:30'!
postCopy
	<ctxMeta>
	super postCopy. 
	__ctxInfo__ := nil .! !

!HashedCollectionL2 methodsFor: '*activecontext' stamp: 'ewe 10/30/2012 08:51'!
secure
	<ctxMeta>
	self secureSelf. 
	self isCtxGlobal ifTrue: [
		self prevMe ifNotNil: [ self prevMe secureSelf ].
		self nextMe ifNotNil: [ self nextMe secureSelf ].
	]! !

!HashedCollectionL2 methodsFor: '*activecontext' stamp: 'ewe 10/31/2012 05:47'!
secureSelf
<ctxMeta>
	self subclassResponsibility ! !

!HashedCollectionL2 methodsFor: '*activecontext-test' stamp: 'ewe 11/1/2012 08:01'!
set: value
	self at: 1 put: value ! !

!Character methodsFor: '*activecontext' stamp: 'ewe 9/27/2011 14:28'!
isPrimitive ^true! !

!MCPatch methodsFor: '*activecontext' stamp: 'ewe 9/28/2012 13:12'!
initializeWithBase: baseSnapshot target: targetSnapshot
	| base target |	
	operations := OrderedCollection new.
	base := MCDefinitionIndex definitions: baseSnapshot definitions.
	target := MCDefinitionIndex definitions: targetSnapshot definitions.
	
	target definitions do:
		[:t |
		base
			definitionLike: t
			ifPresent: [:b | (b isSameRevisionAs: t) ifFalse: [
					| mod |
					mod := MCModification of: b to: t.
					mod hasEffectiveChanges ifTrue: [	operations add: mod ] 
				]]
			ifAbsent: [operations add: (MCAddition of: t)]]
		displayingProgress: 'Diffing...'.
		
	base definitions do:
		[:b |
		target
			definitionLike: b
			ifPresent: [:t]
			ifAbsent: [operations add: (MCRemoval of: b)]]		! !

!Semaphore methodsFor: '*activecontext' stamp: 'ewe 9/27/2011 14:32'!
isPrimitive ^true! !

!SetS2 methodsFor: '*activecontext' stamp: 'ewe 11/27/2012 13:35'!
ctxWritearray: v2 __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: 2 . self markOtherAsDirty: 2 ]. ^ array := v2  ! !

!SetS2 methodsFor: '*activecontext' stamp: 'ewe 11/1/2012 08:18'!
isThreadSafe 
	^true ! !

!SetS2 methodsFor: '*activecontext' stamp: 'ewe 11/1/2012 08:18'!
secureSelf
! !

!Behavior methodsFor: '*ActiveContext' stamp: 'ewe 11/12/2012 14:34'!
recompileAll
	"Transcript show: ( 'Recompile all methods for: ' , self asString  ) ; cr. "
	self methodDict keys do: [ :method | 	method first = $_ ifFalse: [ self recompile: method ] ].! !

!Behavior methodsFor: '*ActiveContext' stamp: 'ewe 11/2/2012 09:29'!
selfAndAllSubclasses
	| t |
	t := self allSubclasses .
	t add: self.
	^ t.! !

WeakArray weakSubclass: #WeakReference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Core'!

!WeakReference class methodsFor: 'as yet unclassified' stamp: 'ewe 9/7/2011 14:08'!
new
	^ super new: 1. ! !

!WeakReference methodsFor: 'as yet unclassified' stamp: 'ewe 9/7/2011 14:07'!
get
	^ self at: 1. ! !

!WeakReference methodsFor: 'as yet unclassified' stamp: 'ewe 9/7/2011 14:07'!
set: anObject
	self at: 1 put: anObject ! !

!SetL2 methodsFor: '*ActiveContext' stamp: 'ewe 10/11/2012 15:12'!
_postCopy
	<ctxMeta>
	super postCopy.
	
	self contextInfo: ContextualInfo new.
	self contextInfo global: true.
	self contextInfo allDirtyBit: false.
	self contextInfo uuid: UUID new..
	
	array := array copy! !

!SetL2 methodsFor: '*activecontext' stamp: 'ewe 11/27/2012 13:35'!
ctxWritearray: v2 __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: 2 . self markOtherAsDirty: 2 ]. ^ array := v2  ! !

!SetL2 methodsFor: '*activecontext-test' stamp: 'ewe 11/1/2012 08:19'!
get
	^self anyOne! !

!SetL2 methodsFor: '*activecontext' stamp: 'ewe 11/1/2012 08:18'!
isThreadSafe 
	^false ! !

!SetL2 methodsFor: '*ActiveContext' stamp: 'ewe 10/11/2012 14:38'!
postCopy
	<ctxMeta>
	super postCopy.
	
	array := array copy! !

!SetL2 methodsFor: '*activecontext' stamp: 'ewe 11/1/2012 08:16'!
secureSelf
<ctxMeta>
	self primitiveChangeClassTo: SetS2 new.   
	__lock__ := Semaphore forMutualExclusion.
	"we must not use method that are not ctxMeta"
	1 to: array size do: 	[:index | ( array primAt: index ) secure ]! !

!SetL2 methodsFor: '*activecontext-test' stamp: 'ewe 11/1/2012 08:14'!
set: value 
	self add: value ! !

!IdentityDictionaryS2 methodsFor: '*activecontext' stamp: 'ewe 11/27/2012 13:35'!
ctxWritearray: v2 __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: 2 . self markOtherAsDirty: 2 ]. ^ array := v2  ! !

!IdentityDictionaryS2 methodsFor: '*activecontext' stamp: 'ewe 11/1/2012 07:42'!
isThreadSafe 
	^true ! !

!IdentityDictionaryS2 methodsFor: '*activecontext' stamp: 'ewe 11/1/2012 07:42'!
secureSelf
 ! !

!OrderedCollectionS2 methodsFor: '*activecontext' stamp: 'ewe 11/27/2012 13:35'!
ctxWritearray: v2 __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: 3 . self markOtherAsDirty: 3 ]. ^ array := v2  ! !

!OrderedCollectionS2 methodsFor: '*activecontext' stamp: 'ewe 11/1/2012 08:39'!
isThreadSafe 
	^true ! !

!OrderedCollectionS2 methodsFor: '*activecontext' stamp: 'ewe 11/1/2012 08:40'!
secureSelf
! !

!BlockClosure methodsFor: '*ActiveContext' stamp: 'ewe 11/23/2012 12:01'!
contextIdentity
	^VirtualField instance for: self field: #identity! !

!BlockClosure methodsFor: '*ActiveContext' stamp: 'ewe 11/23/2012 11:58'!
contextIdentity: anIdentity
	VirtualField instance bind: self to: anIdentity field: #identity! !

!BlockClosure methodsFor: '*ActiveContext' stamp: 'ewe 11/23/2012 11:26'!
contextInfo
	"ContextStatistics checkStatistics  increment: self class."
	^ VirtualField instance for: self . ! !

!BlockClosure methodsFor: '*ActiveContext' stamp: 'ewe 11/23/2012 11:26'!
contextInfo: info
	VirtualField instance bind: self to: info.! !

!BlockClosure methodsFor: '*ActiveContext' stamp: 'ewe 9/27/2011 14:29'!
isPrimitive ^false! !

!BlockClosure methodsFor: '*ActiveContext' stamp: 'ewe 12/3/2012 14:12'!
migrateToNext
	<ctxMeta>
	| clone ctx sender receiver newCtx cls newClass newMeth newSender newReceiver args  |
	self flag: 'The outerContext''s method should be migrated to the corresponding method in the new class'.
	clone := ( BlockClosure new: self size ) globalize: self uuid..
	
	ctx := self outerContext. 
	cls := ctx method methodClass.
	sender := ctx sender.
	receiver := ctx receiver. 
	newClass := cls nextMe.  
	newMeth := newClass methodDict at: ctx method selector.
	newSender := self safeMigrateNext: sender.
	self flag: 'Don''t know what''s the sender exactly'.
	newReceiver := self safeMigrateNext:   receiver .  
	args := ( 1 to: ctx numArgs ) collect: [ :i | ctx at: i ].
	newCtx := MethodContext sender: newSender  
						 receiver: newReceiver 
						method: newMeth arguments: args. 
	
	"Transcript show: '------', newCtx ; cr. "
	
	clone instVarNamed: #outerContext put: newCtx.
	clone instVarNamed: #numArgs put: self  numArgs .
	clone instVarNamed: #startpc put: self  startpc .

	1 to: self size  do: [ :i |
				| p |
				p := self at: i.   
				( p isPrimitive not )  ifTrue: [
					"lazy migration after update"
					p migrateToNextIfNecessary .
					clone at: i put: p nextMe. .
					"Transcript show: ( self uuid, '.' , field, ' := ', p next asString ); cr."
				] ifFalse: [
					clone at:  i put: p.  
					"Transcript show: ( self uuid, '.' , field, ' := ', p asString ); cr."
				]. 
			]  .
		
	clone allDirtyBit: false.
	self nextMe: clone.
	clone prevMe: self.! !

!BlockClosure methodsFor: '*ActiveContext' stamp: 'ewe 12/3/2012 14:13'!
migrateToPrev
	<ctxMeta>
	| clone ctx sender receiver newCtx cls newClass newMeth newSender newReceiver args  |
	self flag: 'The outerContext''s method should be migrated to the corresponding method in the new class'.
	clone := ( BlockClosure new: self size ) globalize: self uuid..
	
	ctx := self outerContext. 
	cls := ctx method methodClass.
	sender := ctx sender.
	receiver := ctx receiver. 
	newClass := cls prevMe.  
	newMeth := newClass methodDict at: ctx method selector.
	newSender := self safeMigratePrev: sender.
	self flag: 'Don''t know what''s the sender exactly'.
	newReceiver := self safeMigratePrev:   receiver .  
	args := ( 1 to: ctx numArgs ) collect: [ :i | ctx at: i ].
	newCtx := MethodContext sender: newSender  
						 receiver: newReceiver 
						method: newMeth arguments: args. 
	
	"Transcript show: '------', newCtx ; cr. "
	
	clone instVarNamed: #outerContext put: newCtx.
	clone instVarNamed: #numArgs put: self  numArgs .
	clone instVarNamed: #startpc put: self  startpc .

	1 to: self size  do: [ :i |
				| p |
				p := self at: i.   
				( p isPrimitive not )  ifTrue: [
					"lazy migration after update"
					p migrateToPrevIfNecessary .
					clone at: i put: p prevMe. .
					"Transcript show: ( self uuid, '.' , field, ' := ', p next asString ); cr."
				] ifFalse: [
					clone at:  i put: p.  
					"Transcript show: ( self uuid, '.' , field, ' := ', p asString ); cr."
				]. 
			]  .
		
	clone allDirtyBit: false.
	self prevMe: clone.
	clone nextMe: self.! !

!BlockClosure methodsFor: '*ActiveContext' stamp: 'ewe 11/13/2012 14:57'!
newContextProcess: ctx
	|p|
	p :=  [ ctx do:  self  ] primNewProcess.
	p environmentAt: #activeContext put: ctx.
	^ p.
! !

!BlockClosure methodsFor: '*ActiveContext' stamp: 'ewe 11/13/2012 15:11'!
newProcess

		|p ctx|
		
		Processor activeProcess environmentAt: #activeContext ifAbsent: [ 
			^ self primNewProcess. 
		].
		
		ctx := CurrentContext latest. 
		ctx isNil ifTrue: [
			^ self primNewProcess. 
		] ifFalse: [
			^ self newContextProcess: ctx .
		].! !

!BlockClosure methodsFor: '*ActiveContext' stamp: 'ewe 7/7/2011 17:08'!
primNewProcess
	"Answer a Process running the code in the receiver. The process is not 
	scheduled."
	<primitive: 19> "Simulation guard"
	^Process
		forContext: 
			[self value.
			Processor terminateActive] asContext
		priority: Processor activePriority! !

!BlockClosure methodsFor: '*ActiveContext' stamp: 'ewe 12/3/2012 14:12'!
safeMigrateNext: aClassOrMetaclass
	aClassOrMetaclass ifNil: [ ^ nil ].
	
	aClassOrMetaclass isClass ifFalse: [ 
		aClassOrMetaclass migrateToNextIfNecessary . 
		^ aClassOrMetaclass nextMe ].  
	
	aClassOrMetaclass isMeta ifTrue: [ 
		aClassOrMetaclass theNonMetaClass migrateToNextIfNecessary.
		^ aClassOrMetaclass theNonMetaClass  nextMe class ] 
	ifFalse: [ 
		aClassOrMetaclass migrateToNextIfNecessary .
		^ aClassOrMetaclass nextMe 
	].! !

!BlockClosure methodsFor: '*ActiveContext' stamp: 'ewe 12/3/2012 14:14'!
safeMigratePrev: aClassOrMetaclass
	aClassOrMetaclass ifNil: [ ^ nil ].
	
	aClassOrMetaclass isClass ifFalse: [ 
		aClassOrMetaclass migrateToPrevIfNecessary  . 
		^ aClassOrMetaclass prevMe ].  
	
	aClassOrMetaclass isMeta ifTrue: [ 
		aClassOrMetaclass theNonMetaClass migrateToPrevIfNecessary.
		^ aClassOrMetaclass theNonMetaClass  prevMe class ] 
	ifFalse: [ 
		aClassOrMetaclass migrateToPrevIfNecessary  .
		^ aClassOrMetaclass prevMe  
	].! !

!BlockClosure methodsFor: '*ActiveContext' stamp: 'ewe 12/3/2012 14:07'!
traverseAndDo: aBlock exclude: visited 
	
	( visited includes: self ) ifTrue: [ ^ self ].  
	visited add: self. 	
	aBlock value: self. 
	1 to: self size  do:  [ :i | ( self at: i  ) traverseAndDo: aBlock exclude:  visited  ].! !

!String methodsFor: '*activecontext' stamp: 'ewe 11/22/2012 16:05'!
isContextReservedVar
	^ self = '__ctxInfo__' or: [ self  = '__lock__' or: [ self = '__ctxIdentity__' ] ]! !

!String methodsFor: '*activecontext' stamp: 'ewe 9/27/2011 14:27'!
isPrimitive ^true! !

!UndefinedObject methodsFor: '*ActiveContext' stamp: 'ewe 10/11/2012 15:13'!
hasDirtyBit 
	^ false. ! !

!UndefinedObject methodsFor: '*ActiveContext' stamp: 'ewe 5/20/2011 12:24'!
isPrimitive 
	^ true! !

!UndefinedObject methodsFor: '*ActiveContext' stamp: 'ewe 8/24/2011 15:06'!
nextMe
	Abort signal: 'nil is immutable'! !

!UndefinedObject methodsFor: '*ActiveContext' stamp: 'ewe 8/24/2011 15:07'!
nextMe: aValue
	Abort signal: 'nil is immutable'! !

!UndefinedObject methodsFor: '*ActiveContext' stamp: 'ewe 8/24/2011 15:08'!
prevMe
	Abort signal: 'nil is immutable'! !

!UndefinedObject methodsFor: '*ActiveContext' stamp: 'ewe 8/24/2011 15:07'!
prevMe: aValue
	Abort signal: 'nil is immutable'! !

!UndefinedObject methodsFor: '*ActiveContext' stamp: 'ewe 7/6/2011 16:09'!
uuid
	Abort signal: 'Uuid on nil is forbidden'.! !

!MCModification methodsFor: '*activecontext' stamp: 'ewe 9/28/2012 13:12'!
hasEffectiveChanges
	^ ( self fromSource = self toSource ) not ! !

RBCompiler subclass: #BaseCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Core'!

!BaseCompiler class methodsFor: 'as yet unclassified' stamp: 'ewe 9/27/2012 15:45'!
evaluate: aString 
	^ self evaluate: aString for: nil logged: false! !

!BaseCompiler class methodsFor: 'as yet unclassified' stamp: 'ewe 9/27/2012 15:45'!
evaluate: aString for: anObject logged: aBoolean 
	^ self evaluate: aString for: anObject notifying: nil logged: aBoolean! !

!BaseCompiler class methodsFor: 'as yet unclassified' stamp: 'ewe 9/27/2012 15:45'!
evaluate: aString for: anObject notifying: aController logged: aBoolean
	^ self new evaluate: aString in: nil to: anObject notifying: aController ifFail: [ ^ nil ] logged: aBoolean! !

!BaseCompiler class methodsFor: 'as yet unclassified' stamp: 'ewe 9/27/2012 15:45'!
evaluate: aString logged: aBoolean 
	^ self evaluate: aString for: nil logged: aBoolean! !

!BaseCompiler class methodsFor: 'as yet unclassified' stamp: 'ewe 9/27/2012 15:45'!
evaluate: aString notifying: aController logged: aBoolean 
	^ self evaluate: aString for: nil notifying: aController logged: aBoolean! !

!BaseCompiler methodsFor: 'as yet unclassified' stamp: 'ewe 9/1/2011 15:51'!
translate: aProgramNode
| vis |
vis := self visitorClass new.
vis compiledClass: class.  
self flag: 'Skip class resolution is probably wrong. Classes whose instance only are contextual must still resolve *other* classes that could be contextual correctly, not only self-reference....'.
"((CurrentContext contextualClasses includes: class class) not and: [ class isMeta not ]  ) ifTrue:  [ vis skipClassResolution ]  ."
vis  visitNode: aProgramNode methodNode.
^ super translate: aProgramNode methodNode.
! !

BaseCompiler subclass: #ContextualCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Core'!

!ContextualCompiler class methodsFor: 'as yet unclassified' stamp: 'ewe 5/19/2011 18:06'!
evaluate: textOrString for: anObject notifying: aController logged: logFlag
	"Compile and execute the argument, textOrString with respect to the class 
	of anObject. If a compilation error occurs, notify aController. If both 
	compilation and execution are successful then, if logFlag is true, log 
	(write) the text onto a system changes file so that it can be replayed if 
	necessary."

	^ self new
				evaluate: textOrString
				in: nil
				to: anObject
				notifying: aController
				ifFail: [^nil]
				logged: logFlag.! !

!ContextualCompiler class methodsFor: 'as yet unclassified' stamp: 'ewe 5/19/2011 18:05'!
evaluate: textOrString notifying: aController logged: logFlag 
	"See Compiler|evaluate:for:notifying:logged:. Compilation is carried out 
	with respect to nil, i.e., no object."

	^self evaluate: textOrString for: nil notifying: aController logged: logFlag! !

!ContextualCompiler methodsFor: 'as yet unclassified' stamp: 'ewe 8/31/2011 11:30'!
visitorClass 
	^ ContextualProgramNodeVisitor! !

BaseCompiler subclass: #NormalizedCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Core'!

!NormalizedCompiler methodsFor: 'as yet unclassified' stamp: 'ewe 8/31/2011 14:59'!
visitorClass 
	^ NormalizedProgramNodeVisitor  ! !

BaseCompiler subclass: #OptimizedContextualCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Core'!

!OptimizedContextualCompiler methodsFor: 'as yet unclassified' stamp: 'ewe 8/31/2011 11:30'!
visitorClass 
	^ OptimizedContextualProgramNodeVisitor ! !

BaseCompiler subclass: #StaticResolutionCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Core'!

!StaticResolutionCompiler methodsFor: 'as yet unclassified' stamp: 'ewe 11/12/2012 13:31'!
visitorClass 
	^ StaticResolutionVisitor ! !

Collection subclass: #HashedCollectionL1
	instanceVariableNames: 'tally array __ctxInfo__ __lock__ __ctxIdentity__'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Kernel'!

HashedCollectionL1 subclass: #DictionaryL1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Kernel'!

!DictionaryL1 class methodsFor: 'instance creation' stamp: 'ewe 10/12/2012 11:35'!
isPrimitive ^ false! !

!DictionaryL1 class methodsFor: 'instance creation' stamp: 'ewe 9/26/2011 23:42'!
newFrom: t1 
	| t2 |
	t2 := self new: t1 size.
	t1
		associationsDo: [:t3 | (t2 includesKey: t3 key)
				ifTrue: [self error: 'Duplicate key: ' , t3 key printString]
				ifFalse: [t2 add: t3]].
	^ t2! !

!DictionaryL1 class methodsFor: 'instance creation' stamp: 'ewe 9/26/2011 23:42'!
newFromPairs: t1 
	| t2 |
	t2 := self new: t1 size / 2.
	1
		to: t1 size - 1
		by: 2
		do: [:t3 | t2
				at: (t1 at: t3)
				put: (t1 at: t3 + 1)].
	^ t2! !

!DictionaryL1 methodsFor: 'comparing' stamp: 'ewe 9/26/2011 23:42'!
= t1 
	self == t1
		ifTrue: [^ true].
	t1 isDictionary
		ifFalse: [^ false].
	self size = t1 size
		ifFalse: [^ false].
	self
		associationsDo: [:t2 | (t1
					at: t2 key
					ifAbsent: [^ false])
					= t2 value
				ifFalse: [^ false]].
	^ true! !

!DictionaryL1 methodsFor: '*ActiveContext' stamp: 'ewe 10/11/2012 15:12'!
_postCopy
	<ctxMeta>
	"Must copy the associations, or later store will affect both the
original and the copy"
	self contextInfo: ContextualInfo new.
	self contextInfo global: true.
	self contextInfo allDirtyBit: false.
	self contextInfo uuid: UUID new..
	
	self flag: 'Should we use array copy, or collect the copy of the assoc?'.
	array := array collect: [ :association |
		association ifNotNil: [ association copy ] ]! !

!DictionaryL1 methodsFor: 'adding' stamp: 'ewe 9/6/2011 17:30'!
add: anAssociation
	| index element |
	index := self findElementOrNil: anAssociation key.
	element := array at: index.
	element == nil
		ifTrue: [self atNewIndex: index put: anAssociation]
		ifFalse: [element value: anAssociation value].
	^ anAssociation! !

!DictionaryL1 methodsFor: 'adding' stamp: 'ewe 9/6/2011 17:30'!
addAll: aKeyedCollection
	aKeyedCollection == self ifFalse: [
		aKeyedCollection keysAndValuesDo: [:key :value |
			self at: key put: value]].
	^aKeyedCollection! !

!DictionaryL1 methodsFor: 'converting' stamp: 'ewe 11/6/2012 11:34'!
asSet
	^ Set withAll: self! !

!DictionaryL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 17:30'!
associationAt: key 
	^ self associationAt: key ifAbsent: [self errorKeyNotFound]! !

!DictionaryL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 17:30'!
associationAt: key ifAbsent: aBlock 
	"Answer the association with the given key.
	If key is not found, return the result of evaluating aBlock."

	| index assoc |
	index := self findElementOrNil: key.
	assoc := array at: index.
	nil == assoc ifTrue: [ ^ aBlock value ].
	^ assoc! !

!DictionaryL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 17:30'!
associations
	"Answer a Collection containing the receiver's associations."
	"Suggested by l. Uzonyi"
	
	^Array new: self size streamContents: [ :stream |
		self associationsDo: [ :each | stream nextPut: each ] ]! !

!DictionaryL1 methodsFor: 'enumerating' stamp: 'ewe 9/6/2011 17:30'!
associationsDo: aBlock 
	"Evaluate aBlock for each of the receiver's elements (key/value 
	associations)."

	tally = 0 ifTrue: [^ self].
	array do:
		[:each |
		each ifNotNil: [aBlock value: each]]! !

!DictionaryL1 methodsFor: 'enumerating' stamp: 'ewe 9/26/2011 23:42'!
associationsSelect: t1 
	| t2 |
	t2 := self species new.
	self
		associationsDo: [:t3 | (t1 value: t3)
				ifTrue: [t2 add: t3]].
	^ t2! !

!DictionaryL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 17:30'!
at: key 
	"Answer the value associated with the key."

	^ self at: key ifAbsent: [self errorKeyNotFound]! !

!DictionaryL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 17:30'!
at: key ifAbsent: aBlock 
	"Answer the value associated with the key or, if key isn't found,
	answer the result of evaluating aBlock."

	^((array at: (self findElementOrNil: key)) 
			ifNil: [aBlock] 
			ifNotNil: [:assoc | assoc]) value.! !

!DictionaryL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 17:30'!
at: key ifAbsentPut: aBlock 
	"Return the value at the given key. 
	If key is not included in the receiver store the result 
	of evaluating aBlock as new value."

	^ self at: key ifAbsent: [self at: key put: aBlock value]! !

!DictionaryL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 17:30'!
at: key ifPresent: aBlock
	"Lookup the given key in the receiver. If it is present, answer the value of evaluating the given block with the value associated with the key. Otherwise, answer nil."

	| v |
	v := self at: key ifAbsent: [^ nil].
	^ aBlock value: v
! !

!DictionaryL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 17:30'!
at: key ifPresent: oneArgBlock ifAbsent: absentBlock
	"Lookup the given key in the receiver. If it is present, answer the value of evaluating the oneArgBlock with the value associated with the key, otherwise answer the value of absentBlock."
	
	self at: key ifPresent: [ :v | ^oneArgBlock value: v ].
	^absentBlock value! !

!DictionaryL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 17:30'!
at: key put: anObject 
	"Set the value at key to be anObject.  If key is not found, create a
	new entry for key and set is value to anObject. Answer anObject."

	| index assoc |
	index := self findElementOrNil: key.
	assoc := array at: index.
	assoc
		ifNil: [self atNewIndex: index put: (Association key: key value: anObject)]
		ifNotNil: [assoc value: anObject].
	^ anObject! !

!DictionaryL1 methodsFor: 'enumerating' stamp: 'ewe 9/6/2011 17:30'!
collect: aBlock 
	"Evaluate aBlock with each of my values as the argument.  Collect the
	resulting values into a collection that is like me. Answer with the new
	collection."
	| newCollection |
	newCollection := self species new.
	self associationsDo:[:each |
		newCollection at: each key put: (aBlock value: each value).
	].
	^newCollection! !

!DictionaryL1 methodsFor: '*activecontext' stamp: 'ewe 11/27/2012 13:35'!
ctxWritearray: v2 __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: 2 . self markOtherAsDirty: 2 ]. ^ array := v2  ! !

!DictionaryL1 methodsFor: 'as yet unclassified' stamp: 'ewe 11/27/2012 13:35'!
ctxWritetally: v2 __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: 1 . self markOtherAsDirty: 1 ]. ^ tally := v2  ! !

!DictionaryL1 methodsFor: 'adding' stamp: 'ewe 9/26/2011 23:42'!
declare: t1 from: t2 
	(self includesKey: t1)
		ifTrue: [^ self].
	(t2 includesKey: t1)
		ifTrue: [self
				add: (t2 associationAt: t1).
			t2 removeKey: t1]
		ifFalse: [self add: t1 -> nil]! !

!DictionaryL1 methodsFor: 'enumerating' stamp: 'ewe 9/6/2011 17:30'!
do: aBlock

	^self valuesDo: aBlock! !

!DictionaryL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:30'!
errorKeyNotFound

	self error: 'key not found'! !

!DictionaryL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:30'!
errorValueNotFound

	self error: 'value not found'! !

!DictionaryL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:30'!
fillFrom: aCollection with: aBlock
	"Evaluate aBlock with each of aCollections's elements as the argument.  
	Collect the resulting values into self. Answer self."

	aCollection keysAndValuesDo: [ :key :value |
		self at: key put: (aBlock value: value) ]! !

!DictionaryL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:30'!
fixCollisionsFrom: start
	"The element at start has been removed and replaced by nil.
	This method moves forward from there, relocating any entries
	that had been placed below due to collisions with this one."
	| element index |
	index := start.
	[ (element := array at: (index := index \\ array size + 1)) == nil ] whileFalse: [
		| newIndex |
		(newIndex := self findElementOrNil: element key) = index ifFalse: [
			array swap: index with: newIndex ] ]! !

!DictionaryL1 methodsFor: 'printing' stamp: 'ewe 9/26/2011 23:42'!
flattenOnStream: t1 
	^ t1 writeDictionary: self! !

!DictionaryL1 methodsFor: 'testing' stamp: 'ewe 9/6/2011 17:30'!
hasBindingThatBeginsWith: aString
	"Answer true if the receiver has a key that begins with aString, false otherwise"
	
	self keysDo:[:each | 
		(each beginsWith: aString)
			ifTrue:[^true]].
	^false! !

!DictionaryL1 methodsFor: 'testing' stamp: 'ewe 9/6/2011 17:30'!
includes: anObject

	self do: [:each | anObject = each ifTrue: [^true]].
	^false! !

!DictionaryL1 methodsFor: 'testing' stamp: 'ewe 9/6/2011 17:30'!
includesAssociation: anAssociation
  ^ (self   
      associationAt: anAssociation key
      ifAbsent: [ ^ false ]) value = anAssociation value
! !

!DictionaryL1 methodsFor: 'testing' stamp: 'ewe 9/6/2011 17:30'!
includesIdentity: anObject
	"Answer whether anObject is one of the values of the receiver.  Contrast #includes: in which there is only an equality check, here there is an identity check"

	self do: [:each | anObject == each ifTrue: [^ true]].
	^ false! !

!DictionaryL1 methodsFor: 'testing' stamp: 'ewe 9/6/2011 17:30'!
includesKey: key 
	"Answer whether the receiver has a key equal to the argument, key."
	
	self at: key ifAbsent: [^false].
	^true! !

!DictionaryL1 methodsFor: 'testing' stamp: 'ewe 9/26/2011 23:42'!
isDictionary
	^ true! !

!DictionaryL1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
isPrimitive ^ false! !

!DictionaryL1 methodsFor: '*activecontext' stamp: 'ewe 10/31/2012 05:53'!
isThreadSafe 
	^false ! !

!DictionaryL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 17:30'!
keyAtIdentityValue: value 
	"Answer the key that is the external name for the argument, value. If 
	there is none, answer nil.
	Note: There can be multiple keys with the same value. Only one is returned."

	^self keyAtIdentityValue: value ifAbsent: [self errorValueNotFound]! !

!DictionaryL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 17:30'!
keyAtIdentityValue: value ifAbsent: exceptionBlock
	"Answer the key that is the external name for the argument, value. If 
	there is none, answer the result of evaluating exceptionBlock.
	Note: There can be multiple keys with the same value. Only one is returned."
 
	self associationsDo: 
		[:association | value == association value ifTrue: [^association key]].
	^exceptionBlock value! !

!DictionaryL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 17:30'!
keyAtValue: value 
	"Answer the key that is the external name for the argument, value. If 
	there is none, signal an error."

	^self keyAtValue: value ifAbsent: [self errorValueNotFound]! !

!DictionaryL1 methodsFor: 'accessing' stamp: 'ewe 9/26/2011 23:42'!
keyAtValue: t1 ifAbsent: t2 
	self
		associationsDo: [:t3 | 
			t1 = t3 value
				ifTrue: [^ t3 key].
			nil].
	^ t2 value! !

!DictionaryL1 methodsFor: 'testing' stamp: 'ewe 9/6/2011 17:30'!
keyForIdentity: anObject
	"If anObject is one of the values of the receive, return its key, else return nil.  Contrast #keyAtValue: in which there is only an equality check, here there is an identity check"

	self associationsDo: [:assoc | assoc value == anObject ifTrue: [^ assoc key]].
	^ nil! !

!DictionaryL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 17:30'!
keys
	"Answer an Array containing the receiver's keys."
	
	^Array new: self size streamContents: [:s| self keysDo: [:key| s nextPut: key]]! !

!DictionaryL1 methodsFor: 'enumerating' stamp: 'ewe 9/6/2011 17:30'!
keysAndValuesDo: aBlock
	^self associationsDo:[:assoc|
		aBlock value: assoc key value: assoc value].! !

!DictionaryL1 methodsFor: 'removing' stamp: 'ewe 11/6/2012 11:33'!
keysAndValuesRemove: t1 
	| t2 |
	t2 := OrderedCollection new.
	self
		associationsDo: [:t3 | (t1 value: t3 key value: t3 value)
				ifTrue: [t2 add: t3 key]].
	t2
		do: [:t3 | self removeKey: t3]! !

!DictionaryL1 methodsFor: 'enumerating' stamp: 'ewe 9/6/2011 17:30'!
keysDo: aBlock 
	"Evaluate aBlock for each of the receiver's keys."

	self associationsDo: [:association | aBlock value: association key]! !

!DictionaryL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 17:30'!
keysSortedSafely
	"Answer an Array containing the receiver's keys."
 	"Suggested by l. Uzonyi"
	
 	| sortedKeys |
 	sortedKeys := Array 
						new: self size 
						streamContents: [ :stream |
 								self keysDo: [ :each | stream nextPut: each ] ].
 	sortedKeys sort: [ :x :y |
 		"Should really be use <obj, string, num> compareSafely..."
 		((x isString and: [ y isString ])
 			or: [ x isNumber and: [ y isNumber ] ])
 			ifTrue: [ x < y ]
 			ifFalse: [ x class == y class
 				ifTrue: [ x printString < y printString ]
 				ifFalse: [ x class name < y class name ] ] ].
 	^sortedKeys! !

!DictionaryL1 methodsFor: 'private' stamp: 'ewe 9/26/2011 23:42'!
noCheckAdd: t1 
	self ctxReadarray
		at: (self findElementOrNil: t1 key)
		put: t1.
	self ctxWritetally: self ctxReadtally + 1! !

!DictionaryL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:30'!
noCheckNoGrowFillFrom: anArray
	"Add the elements of anArray except nils to me assuming that I don't contain any of them, they are unique and I have more free space than they require."

	1 to: anArray size do: [ :index |
		(anArray at: index) ifNotNil: [ :association |
			array
				at: (self scanForEmptySlotFor: association key)
				put: association ] ]! !

!DictionaryL1 methodsFor: 'testing' stamp: 'ewe 9/6/2011 17:30'!
occurrencesOf: anObject 
	"Answer how many of the receiver's elements are equal to anObject."

	| count |
	count := 0.
	self do: [:each | anObject = each ifTrue: [count := count + 1]].
	^count! !

!DictionaryL1 methodsFor: '*ActiveContext' stamp: 'ewe 9/14/2011 11:11'!
postCopy
	<ctxMeta>
	"Must copy the associations, or later store will affect both the
original and the copy"
	super postCopy .
	self flag: 'Should we use array copy, or collect the copy of the assoc?'.
	array := array collect: [ :association |
		association ifNotNil: [ association copy ] ]! !

!DictionaryL1 methodsFor: 'printing' stamp: 'ewe 9/6/2011 17:30'!
printElementsOn: aStream 
	aStream nextPut: $(.
	self size > 100
		ifTrue: [aStream nextPutAll: 'size '.
			self size printOn: aStream]
		ifFalse: [self keysSortedSafely
				do: [:key | aStream print: key;
						 nextPutAll: '->';				
						 print: (self at: key);
						 space]].
	aStream nextPut: $)! !

!DictionaryL1 methodsFor: '*ActiveContext' stamp: 'ewe 9/12/2011 14:32'!
printOn: aStream

	super printOn: aStream .
	
	( self isCtxGlobal and:  [ self contextInfo isNil not ] ) ifTrue: [
		self nextMe isNil ifTrue: [ aStream nextPutAll: 'OLD'  ]
					    ifFalse: [aStream nextPutAll: 'NEW'  ].
	]  ! !

!DictionaryL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:30'!
rehash
	"Smalltalk rehash."
	| newSelf |
	newSelf := self species new: self size.
	self associationsDo: [:each | newSelf noCheckAdd: each].
	array := newSelf array! !

!DictionaryL1 methodsFor: 'removing' stamp: 'ewe 9/6/2011 17:30'!
remove: anObject

	self shouldNotImplement! !

!DictionaryL1 methodsFor: 'removing' stamp: 'ewe 9/6/2011 17:30'!
remove: anObject ifAbsent: exceptionBlock

	self shouldNotImplement! !

!DictionaryL1 methodsFor: 'removing' stamp: 'ewe 9/6/2011 17:30'!
removeKey: key 
	"Remove key from the receiver.
	If key is not in the receiver, notify an error."

	^ self removeKey: key ifAbsent: [self errorKeyNotFound]! !

!DictionaryL1 methodsFor: 'removing' stamp: 'ewe 9/6/2011 17:30'!
removeKey: key ifAbsent: aBlock 
	"Remove key (and its associated value) from the receiver. If key is not in 
	the receiver, answer the result of evaluating aBlock. Otherwise, answer 
	the value externally named by key."

	| index assoc |
	index := self findElementOrNil: key.
	assoc := array at: index.
	assoc == nil ifTrue: [ ^ aBlock value ].
	array at: index put: nil.
	tally := tally - 1.
	self fixCollisionsFrom: index.
	^ assoc value! !

!DictionaryL1 methodsFor: 'removing' stamp: 'ewe 9/6/2011 17:30'!
removeUnreferencedKeys   "Undeclared removeUnreferencedKeys"

	^ self unreferencedKeys do: [:key | self removeKey: key].! !

!DictionaryL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:30'!
scanFor: anObject
	"Scan the key array for the first slot containing either a nil (indicating an empty slot) or an element that matches anObject. Answer the index of that slot or zero if no slot is found. This method will be overridden in various subclasses that have different interpretations for matching elements."
	| element start finish |
	finish := array size.
	start := (anObject hash \\ finish) + 1.

	"Search from (hash mod size) to the end."
	start to: finish do:
		[:index | ((element := array at: index) == nil or: [element key = anObject])
			ifTrue: [^ index ]].

	"Search from 1 to where we started."
	1 to: start-1 do:
		[:index | ((element := array at: index) == nil or: [element key = anObject])
			ifTrue: [^ index ]].

	^ 0  "No match AND no empty slot"! !

!DictionaryL1 methodsFor: '*activecontext' stamp: 'ewe 10/31/2012 09:00'!
secureSelf
<ctxMeta>
	self primitiveChangeClassTo: DictionaryS1 new.  
	__lock__ := Semaphore forMutualExclusion.
	"we must not use method that are not ctxMeta"
	1 to: array size do: 	[:index | ( array primAt: index ) secure ]! !

!DictionaryL1 methodsFor: 'enumerating' stamp: 'ewe 9/26/2011 23:42'!
select: t1 
	| t2 |
	t2 := self copyEmpty.
	self
		associationsDo: [:t3 | (t1 value: t3 value)
				ifTrue: [t2 add: t3 copy]].
	^ t2! !

!DictionaryL1 methodsFor: 'printing' stamp: 'ewe 9/6/2011 17:30'!
storeOn: aStream
	| noneYet |
	aStream nextPutAll: '(('.
	aStream nextPutAll: self class name.
	aStream nextPutAll: ' new)'.
	noneYet := true.
	self associationsDo: 
			[:each | 
			noneYet
				ifTrue: [noneYet := false]
				ifFalse: [aStream nextPut: $;].
			aStream nextPutAll: ' add: '.
			aStream store: each].
	noneYet ifFalse: [aStream nextPutAll: '; yourself'].
	aStream nextPut: $)! !

!DictionaryL1 methodsFor: 'removing' stamp: 'ewe 9/6/2011 17:30'!
unreferencedKeys
	"| uk | (Time millisecondsToRun: [uk := TextConstants unreferencedKeys]) -> uk"

	^'Scanning for references . . .' 
		displayProgressAt: Sensor cursorPoint
		from: 0
		to: Smalltalk globals classNames size * 2
		during: 
			[:bar | | currentClass n associations referencedAssociations |
			currentClass := nil.
			n := 0.
			associations := self associations asIdentitySet.
			referencedAssociations := IdentitySet new: associations size.
			self systemNavigation allSelect:
				[:m|
				m methodClass ~~ currentClass ifTrue:
					[currentClass := m methodClass.
					 bar value: (n := n + 1)].
				m literalsDo:
					[:l|
					(l isVariableBinding and: [associations includes: l]) ifTrue:
						[referencedAssociations add: l]].
				false].
			((associations reject: [:assoc | referencedAssociations includes: assoc]) collect: [:assoc| assoc key]) asSet]! !

!DictionaryL1 methodsFor: 'private' stamp: 'ewe 11/6/2012 11:28'!
valueAtNewKey: t1 put: t2 atIndex: t3 declareFrom: t4 
	(t4 includesKey: t1)
		ifTrue: [self
				atNewIndex: t3
				put: ((t4 associationAt: t1)
						value: t2).
			t4 removeKey: t1]
		ifFalse: [self
				atNewIndex: t3
				put: (Association key: t1 value: t2)]! !

!DictionaryL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 17:30'!
values
	"Answer a Collection containing the receiver's values."
	| out |
	out := (Array new: self size) writeStream.
	self valuesDo: [:value | out nextPut: value].
	^ out contents! !

!DictionaryL1 methodsFor: 'enumerating' stamp: 'ewe 9/6/2011 17:30'!
valuesDo: aBlock 
	"Evaluate aBlock for each of the receiver's values."

	self associationsDo: [:association | aBlock value: association value]! !

DictionaryL1 subclass: #DictionaryS1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Kernel'!

!DictionaryS1 class methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
isPrimitive ^ false! !

!DictionaryS1 methodsFor: '*activecontext' stamp: 'ewe 11/27/2012 13:35'!
ctxWritearray: v2 __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: 2 . self markOtherAsDirty: 2 ]. ^ array := v2  ! !

!DictionaryS1 methodsFor: 'as yet unclassified' stamp: 'ewe 11/27/2012 13:35'!
ctxWritetally: v2 __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: 1 . self markOtherAsDirty: 1 ]. ^ tally := v2  ! !

!DictionaryS1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
isPrimitive ^ false! !

!DictionaryS1 methodsFor: '*activecontext' stamp: 'ewe 10/31/2012 05:54'!
isThreadSafe 
	^true ! !

!DictionaryS1 methodsFor: '*activecontext' stamp: 'ewe 11/1/2012 07:40'!
secureSelf
 ! !

DictionaryL1 subclass: #IdentityDictionaryL1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Kernel'!

!IdentityDictionaryL1 class methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
isPrimitive ^ false! !

!IdentityDictionaryL1 methodsFor: '*activecontext' stamp: 'ewe 11/27/2012 13:35'!
ctxWritearray: v2 __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: 2 . self markOtherAsDirty: 2 ]. ^ array := v2  ! !

!IdentityDictionaryL1 methodsFor: 'as yet unclassified' stamp: 'ewe 11/27/2012 13:35'!
ctxWritetally: v2 __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: 1 . self markOtherAsDirty: 1 ]. ^ tally := v2  ! !

!IdentityDictionaryL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:32'!
fasterKeys
	"This was taking some time in publishing and we didn't really need a Set"
	| answer index |
	self deprecated: 'use keys. #fasterKeys
New implementation of #keys answers an Array and thus supersedes #fasterKeys both in Squeak3.11 and Pharo1.1'  on:  '9 February 2010' in: 'Pharo 1.1'.
	answer := Array new: self size.
	index := 0.
	self keysDo: [:key | answer at: (index := index + 1) put: key].
	^ answer! !

!IdentityDictionaryL1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
isPrimitive ^ false! !

!IdentityDictionaryL1 methodsFor: '*activecontext' stamp: 'ewe 11/1/2012 07:35'!
isThreadSafe 
	^false ! !

!IdentityDictionaryL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:32'!
keyAtValue: value ifAbsent: exceptionBlock
	"Answer the key that is the external name for the argument, value. If 
	there is none, answer the result of evaluating exceptionBlock."
 
	self associationsDo: 
		[:association | value == association value ifTrue: [^ association key]].
	^ exceptionBlock value! !

!IdentityDictionaryL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:32'!
scanFor: anObject
	"Scan the key array for the first slot containing either a nil (indicating an empty slot) or an element that matches anObject. Answer the index of that slot or zero if no slot is found. This method will be overridden in various subclasses that have different interpretations for matching elements."
	| finish start element |
	finish := array size.
	start := (anObject identityHash \\ finish) + 1.

	"Search from (hash mod size) to the end."
	start to: finish do:
		[:index | ((element := array at: index) == nil or: [element key == anObject])
			ifTrue: [^ index ]].

	"Search from 1 to where we started."
	1 to: start-1 do:
		[:index | ((element := array at: index) == nil or: [element key == anObject])
			ifTrue: [^ index ]].

	^ 0  "No match AND no empty slot"! !

!IdentityDictionaryL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:32'!
scanForEmptySlotFor: aKey
	"Scan the key array for the first slot containing an empty slot (indicated by a nil). Answer the index of that slot. This method will be overridden in various subclasses that have different interpretations for matching elements."
	
	| index start |
	index := start := aKey identityHash \\ array size + 1.
	[ 
		(array at: index) ifNil: [ ^index ].
		(index := index \\ array size + 1) = start ] whileFalse.
	self errorNoFreeSpace! !

!IdentityDictionaryL1 methodsFor: '*activecontext' stamp: 'ewe 11/1/2012 07:36'!
secureSelf
<ctxMeta>
	self primitiveChangeClassTo: IdentityDictionaryS1 new.   
	__lock__ := Semaphore forMutualExclusion.
	"we must not use method that are not ctxMeta"
	1 to: array size do: 	[:index | ( array primAt: index ) secure ]! !

IdentityDictionaryL1 subclass: #IdentityDictionaryS1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Kernel'!

!IdentityDictionaryS1 class methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
isPrimitive ^ false! !

!IdentityDictionaryS1 methodsFor: '*activecontext' stamp: 'ewe 11/27/2012 13:35'!
ctxWritearray: v2 __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: 2 . self markOtherAsDirty: 2 ]. ^ array := v2  ! !

!IdentityDictionaryS1 methodsFor: 'as yet unclassified' stamp: 'ewe 11/27/2012 13:35'!
ctxWritetally: v2 __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: 1 . self markOtherAsDirty: 1 ]. ^ tally := v2  ! !

!IdentityDictionaryS1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
isPrimitive ^ false! !

!IdentityDictionaryS1 methodsFor: '*activecontext' stamp: 'ewe 11/1/2012 07:39'!
isThreadSafe 
	^true ! !

!IdentityDictionaryS1 methodsFor: '*activecontext' stamp: 'ewe 11/1/2012 07:40'!
secureSelf
 ! !

!HashedCollectionL1 class methodsFor: 'cleanup' stamp: 'ewe 9/6/2011 17:30'!
cleanUp: aggressive
	"Rehash all instances when cleaning aggressively"

	aggressive ifTrue: [self compactAll].
! !

!HashedCollectionL1 class methodsFor: 'initialization' stamp: 'ewe 9/6/2011 17:30'!
compactAll
	"HashedCollection rehashAll"	
		
	self allSubclassesDo: #compactAllInstances! !

!HashedCollectionL1 class methodsFor: 'initialization' stamp: 'ewe 9/6/2011 17:30'!
compactAllInstances
	"Do not use #allInstancesDo: because rehash may create new instances."
	
	self allInstances do: [ :each | each compact ]! !

!HashedCollectionL1 class methodsFor: 'initialization' stamp: 'ewe 10/12/2012 11:35'!
isPrimitive ^ false! !

!HashedCollectionL1 class methodsFor: 'instance creation' stamp: 'ewe 9/6/2011 17:30'!
new
	^ self basicNew
		initialize: 5! !

!HashedCollectionL1 class methodsFor: 'instance creation' stamp: 'ewe 9/6/2011 17:30'!
new: nElements
	"Create a Set large enough to hold nElements without growing"
	^ self basicNew initialize: (self sizeFor: nElements)! !

!HashedCollectionL1 class methodsFor: 'instance creation' stamp: 'ewe 9/6/2011 17:30'!
newFrom: aCollection 
	"Answer an instance of me containing the same elements as aCollection."
	^self subclassResponsibility! !

!HashedCollectionL1 class methodsFor: 'initialization' stamp: 'ewe 9/6/2011 17:30'!
rehashAll
	"HashedCollection rehashAll"	
		
	self allSubclassesDo: #rehashAllInstances! !

!HashedCollectionL1 class methodsFor: 'initialization' stamp: 'ewe 9/6/2011 17:30'!
rehashAllInstances
	"Do not use #allInstancesDo: because rehash may create new instances."
	
	self allInstances do: [ :each | each rehash ]! !

!HashedCollectionL1 class methodsFor: 'initialization' stamp: 'ewe 9/6/2011 17:30'!
rehashAllSubInstances
	"HashedCollection rehashAll"	
	self deprecated: 'Use HashedCollection rehashAll ' on: '01 September 2010' in: 'Pharo1.2'.
	self rehashAll! !

!HashedCollectionL1 class methodsFor: 'instance creation' stamp: 'ewe 9/6/2011 17:30'!
sizeFor: nElements
	"Large enough size to hold nElements with some slop (see fullCheck)"
	
	nElements < 4 ifTrue: [ ^5 ].
	^ HashTableSizes atLeast: nElements +1 * 4 // 3! !

!HashedCollectionL1 methodsFor: 'adding' stamp: 'ewe 9/6/2011 17:30'!
add: newObject withOccurrences: anInteger
	"Add newObject anInteger times to the receiver. Do nothing if anInteger is less than one. Answer newObject."
	
	anInteger < 1 ifTrue: [ ^newObject ].
	"I can only store an object once."
	^ self add: newObject! !

!HashedCollectionL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:30'!
array
	^ array! !

!HashedCollectionL1 methodsFor: '*activecontext' stamp: 'ewe 9/12/2011 19:08'!
asSet
	"Answer a Set whose elements are the unique elements of the receiver."

	^ Set withAll: self! !

!HashedCollectionL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:30'!
atNewIndex: index put: anObject
	array at: index put: anObject.
	tally := tally + 1.
	self fullCheck! !

!HashedCollectionL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 17:30'!
capacity
	"Answer the current capacity of the receiver."

	^ array size! !

!HashedCollectionL1 methodsFor: 'objects from disk' stamp: 'ewe 9/6/2011 17:30'!
comeFullyUpOnReload: smartRefStream
	"Symbols have new hashes in this image."

	self  compact.
	"^ self"
! !

!HashedCollectionL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:30'!
compact
	"Reduce the size of array so that the load factor will be ~75%."
	
	| newCapacity |
	newCapacity := HashTableSizes atLeast: tally * 4 // 3.
	self growTo: newCapacity! !

!HashedCollectionL1 methodsFor: 'as yet unclassified' stamp: 'ewe 11/19/2012 15:03'!
contextIdentity ^__ctxIdentity__! !

!HashedCollectionL1 methodsFor: 'as yet unclassified' stamp: 'ewe 11/19/2012 15:03'!
contextIdentity: id __ctxIdentity__ := id! !

!HashedCollectionL1 methodsFor: '*activecontext' stamp: 'ewe 11/1/2012 07:37'!
contextInfo
	^ __ctxInfo__! !

!HashedCollectionL1 methodsFor: '*activecontext' stamp: 'ewe 11/1/2012 07:38'!
contextInfo: value
	 __ctxInfo__ := value.! !

!HashedCollectionL1 methodsFor: 'copying' stamp: 'ewe 9/6/2011 17:30'!
copyEmpty
	"Answer an empty copy of this collection"
	
	"Note: this code could be moved to super"
	
	^self species new! !

!HashedCollectionL1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
ctxRead__ctxInfo__ self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 3 ]. ^  __ctxInfo__! !

!HashedCollectionL1 methodsFor: 'as yet unclassified' stamp: 'ewe 11/27/2012 13:33'!
ctxReadarray __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: 2 ]. ^  array! !

!HashedCollectionL1 methodsFor: 'as yet unclassified' stamp: 'ewe 11/27/2012 13:33'!
ctxReadtally __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: 1 ]. ^  tally! !

!HashedCollectionL1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
ctxWrite__ctxInfo__: v2 self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 3 . self markOtherAsDirty: 3 ].  ^ __ctxInfo__ := v2 secure  ! !

!HashedCollectionL1 methodsFor: 'as yet unclassified' stamp: 'ewe 11/27/2012 13:35'!
ctxWritearray: v2 __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: 2 . self markOtherAsDirty: 2 ]. ^ array := v2  ! !

!HashedCollectionL1 methodsFor: 'as yet unclassified' stamp: 'ewe 11/27/2012 13:35'!
ctxWritetally: v2 __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: 1 . self markOtherAsDirty: 1 ]. ^ tally := v2  ! !

!HashedCollectionL1 methodsFor: 'enumerating' stamp: 'ewe 9/6/2011 17:30'!
doWithIndex: aBlock2
	"Support Set enumeration with a counter, even though not ordered"
	| index |
	index := 0.
	self do: [:item | aBlock2 value: item value: (index := index+1)]! !

!HashedCollectionL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:30'!
errorNoFreeSpace

	self error: 'There is no free space in this collection!!'! !

!HashedCollectionL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:30'!
findElementOrNil: anObject
	"Answer the index of a first slot containing either a nil (indicating an empty slot) or an element that matches the given object. Answer the index of that slot or zero. Fail if neither a match nor an empty slot is found."

	| index |

	index := self scanFor: anObject.
	index > 0 ifTrue: [^index].

	"Bad scene.  Neither have we found a matching element
	nor even an empty slot.  No hashed set is ever supposed to get
	completely full."
	self error: 'There is no free space in this set!!'.! !

!HashedCollectionL1 methodsFor: '*activecontext-test' stamp: 'ewe 10/31/2012 05:39'!
first
	^ self at: 1. ! !

!HashedCollectionL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:30'!
fixCollisionsFrom: start
	"The element at start has been removed and replaced by nil.
	This method moves forward from there, relocating any entries
	that had been placed below due to collisions with this one."
	
	self subclassResponsibility! !

!HashedCollectionL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:30'!
fullCheck
	"Keep array at least 1/4 free for decent hash behavior"
	array size - tally < (array size // 4 max: 1)
		ifTrue: [self grow]! !

!HashedCollectionL1 methodsFor: '*activecontext' stamp: 'ewe 9/12/2011 19:01'!
gather: aBlock
	^ Array streamContents:
		[:stream |
		self do: [:ea | stream nextPutAll: (aBlock value: ea)]]! !

!HashedCollectionL1 methodsFor: '*activecontext-test' stamp: 'ewe 11/1/2012 08:02'!
get
	^self at: 1! !

!HashedCollectionL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:30'!
grow
	"Grow the elements array and reinsert the old elements"

	| oldElements |
	oldElements := array.
	array := Array new: (HashTableSizes atLeast: oldElements size * 2).
	tally := 0.
	oldElements
		do:
			[ :each | 
			each == nil
				ifFalse: [ self noCheckAdd: each ] ]! !

!HashedCollectionL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:30'!
growSize
	"Answer what my next higher table size should be"

	^HashTableSizes atLeast: self capacity * 3 // 2 + 2
	! !

!HashedCollectionL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:30'!
growTo: anInteger
	"Grow the elements array and reinsert the old elements"
	
	| oldElements |
	oldElements := array.
	array := Array new: anInteger.
	self noCheckNoGrowFillFrom: oldElements! !

!HashedCollectionL1 methodsFor: 'explorer' stamp: 'ewe 9/6/2011 17:30'!
hasContentsInExplorer

	^self notEmpty! !

!HashedCollectionL1 methodsFor: 'as yet unclassified' stamp: 'ewe 11/19/2012 15:03'!
identityHash ^ self contextIdentityHash! !

!HashedCollectionL1 methodsFor: 'private' stamp: 'ewe 1/15/2012 16:35'!
initialize: n
	"Initialize array to an array size of n"
	array := Array new: n.
	tally := 0  ! !

!HashedCollectionL1 methodsFor: '*activecontext' stamp: 'ewe 11/1/2012 07:38'!
isCtxGlobal
	<ctxMeta>
	^ __ctxInfo__ isNil not. ! !

!HashedCollectionL1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
isPrimitive ^ false! !

!HashedCollectionL1 methodsFor: '*activecontext' stamp: 'ewe 10/30/2012 08:49'!
isThreadSafe 
	^false ! !

!HashedCollectionL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:30'!
noCheckNoGrowFillFrom: anArray
	"Add the elements of anArray except nils to me assuming that I don't contain any of them, they are unique and I have more free space than they require."
	
	self subclassResponsibility! !

!HashedCollectionL1 methodsFor: '*activecontext' stamp: 'ewe 11/12/2012 15:29'!
postCopy
	<ctxMeta>
	super postCopy. 
	__ctxInfo__ := nil .! !

!HashedCollectionL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:30'!
rehash
	self growTo: self capacity! !

!HashedCollectionL1 methodsFor: 'removing' stamp: 'ewe 9/6/2011 17:30'!
removeAll
	"remove all elements from this collection.
	Preserve the capacity"
	
	self initialize: self capacity! !

!HashedCollectionL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:30'!
scanFor: anObject
	"Scan the key array for the first slot containing either a nil (indicating an empty slot) or an element that matches anObject. Answer the index of that slot or raise an error if no slot is found. This method will be overridden in various subclasses that have different interpretations for matching elements."
	
	self subclassResponsibility! !

!HashedCollectionL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:30'!
scanForEmptySlotFor: aKey
	"Scan the key array for the first slot containing an empty slot (indicated by a nil). Answer the index of that slot. This method will be overridden in various subclasses that have different interpretations for matching elements."
	
	| index start |
	index := start := aKey hash \\ array size + 1.
	[ 
		(array at: index) ifNil: [ ^index ].
		(index := index \\ array size + 1) = start ] whileFalse.
	self errorNoFreeSpace! !

!HashedCollectionL1 methodsFor: '*activecontext' stamp: 'ewe 10/30/2012 08:51'!
secure
	<ctxMeta>
	self secureSelf. 
	self isCtxGlobal ifTrue: [
		self prevMe ifNotNil: [ self prevMe secureSelf ].
		self nextMe ifNotNil: [ self nextMe secureSelf ].
	]! !

!HashedCollectionL1 methodsFor: '*activecontext' stamp: 'ewe 10/31/2012 05:47'!
secureSelf
<ctxMeta>
	self subclassResponsibility ! !

!HashedCollectionL1 methodsFor: '*activecontext-test' stamp: 'ewe 11/1/2012 08:02'!
set: value
	self at: 1 put: value ! !

!HashedCollectionL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 17:30'!
size
	^ tally! !

!HashedCollectionL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 17:30'!
someElement
	"Deprecated. Use anyOne."

	^ self anyOne! !

!HashedCollectionL1 methodsFor: 'enumerating' stamp: 'ewe 9/6/2011 17:30'!
union: aCollection
	"Answer the set theoretic union of the receiver and aCollection, using the receiver's notion of equality and not side effecting the receiver at all."

	^ self copy addAll: aCollection; yourself

! !

HashedCollectionL1 subclass: #HashedCollectionS1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Kernel'!

!HashedCollectionS1 class methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
isPrimitive ^ false! !

!HashedCollectionS1 methodsFor: 'as yet unclassified' stamp: 'ewe 11/27/2012 13:35'!
ctxWritearray: v2 __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: 2 . self markOtherAsDirty: 2 ]. ^ array := v2  ! !

!HashedCollectionS1 methodsFor: 'as yet unclassified' stamp: 'ewe 11/27/2012 13:35'!
ctxWritetally: v2 __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: 1 . self markOtherAsDirty: 1 ]. ^ tally := v2  ! !

!HashedCollectionS1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
isPrimitive ^ false! !

!HashedCollectionS1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/30/2012 08:50'!
isThreadSafe 
	^true ! !

!HashedCollectionS1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/30/2012 08:53'!
secure 
	^self! !

HashedCollectionL1 subclass: #SetL1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Kernel'!

!SetL1 class methodsFor: 'instance creation' stamp: 'ewe 10/12/2012 11:35'!
isPrimitive ^ false! !

!SetL1 class methodsFor: 'instance creation' stamp: 'ewe 9/6/2011 17:32'!
new
	^ self basicNew
		initialize: 5;
		yourself! !

!SetL1 class methodsFor: 'instance creation' stamp: 'ewe 9/6/2011 17:32'!
new: nElements
	"Create a Set large enough to hold nElements without growing"
	^ self basicNew initialize: (self sizeFor: nElements)! !

!SetL1 class methodsFor: 'instance creation' stamp: 'ewe 9/6/2011 17:32'!
newFrom: aCollection 
	"Answer an instance of me containing the same elements as aCollection."
	| newCollection |
	newCollection := self new: aCollection size.
	newCollection addAll: aCollection.
	^ newCollection
"
	Set newFrom: {1. 2. 3}
	{1. 2. 3} as: Set
"! !

!SetL1 class methodsFor: 'initialization' stamp: 'ewe 9/6/2011 17:32'!
quickRehashAllSets  

	self deprecated: 'Use HashedCollection >> #rehashAll' on: '01 September 2010' in: 'Pharo1.2'.	
	HashedCollection rehashAll! !

!SetL1 class methodsFor: 'initialization' stamp: 'ewe 9/6/2011 17:32'!
rehashAllSets
	self deprecated: 'Use HashedCollection >> #rehashAll' on: '01 September 2010' in: 'Pharo1.2'.	
	HashedCollection rehashAll! !

!SetL1 class methodsFor: 'instance creation' stamp: 'ewe 9/6/2011 17:32'!
sizeFor: nElements
	"Large enough size to hold nElements with some slop (see fullCheck)"

	^ HashTableSizes atLeast: nElements * 4 // 3! !

!SetL1 methodsFor: 'testing' stamp: 'ewe 9/6/2011 17:32'!
= aSet
	self == aSet ifTrue: [^ true].	"stop recursion"
	(aSet isKindOf: Set) ifFalse: [^ false].
	self size = aSet size ifFalse: [^ false].
	self do: [:each | (aSet includes: each) ifFalse: [^ false]].
	^ true! !

!SetL1 methodsFor: '*ActiveContext' stamp: 'ewe 10/11/2012 15:12'!
_postCopy
	<ctxMeta>
	super postCopy.
	
	self contextInfo: ContextualInfo new.
	self contextInfo global: true.
	self contextInfo allDirtyBit: false.
	self contextInfo uuid: UUID new..
	
	array := array copy! !

!SetL1 methodsFor: 'adding' stamp: 'ewe 9/6/2011 17:32'!
add: newObject
	"Include newObject as one of the receiver's elements, but only if
	not already present. Answer newObject."

	| index |
	newObject ifNil: [self error: 'Sets cannot meaningfully contain nil as an element'].
	index := self findElementOrNil: newObject.
	(array at: index) ifNil: [self atNewIndex: index put: newObject].
	^ newObject! !

!SetL1 methodsFor: 'adding' stamp: 'ewe 9/6/2011 17:32'!
add: newObject withOccurrences: anInteger
	^ self add: newObject! !

!SetL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:32'!
array
	^ array! !

!SetL1 methodsFor: 'converting' stamp: 'ewe 9/6/2011 17:32'!
asSet
	^self! !

!SetL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:32'!
atNewIndex: index put: anObject
	array at: index put: anObject.
	tally := tally + 1.
	self fullCheck! !

!SetL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 17:32'!
atRandom: aGenerator
	"Answer a random element of the receiver. Uses aGenerator which
should be kept by the user in a variable and used every time. Use
this instead of #atRandom for better uniformity of random numbers because 
	only you use the generator. Causes an error if self has no elements."
	| rand |

	self emptyCheck.
	rand := aGenerator nextInt: self size.
	self doWithIndex:[:each :ind |
		ind == rand ifTrue:[^each]].
	^ self errorEmptyCollection
! !

!SetL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 17:32'!
capacity
	"Answer the current capacity of the receiver."

	^ array size! !

!SetL1 methodsFor: 'enumerating' stamp: 'ewe 9/6/2011 17:32'!
collect: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument.  
	Collect the resulting values into a collection like the receiver. Answer  
	the new collection."

	| newSet |
	newSet := Set new: self size.
	array do: [:each | each ifNotNil: [newSet add: (aBlock value: each)]].
	^ newSet! !

!SetL1 methodsFor: 'objects from disk' stamp: 'ewe 9/6/2011 17:32'!
comeFullyUpOnReload: smartRefStream
	"Symbols have new hashes in this image."

	self rehash.
	"^ self"
! !

!SetL1 methodsFor: 'copying' stamp: 'ewe 9/6/2011 17:32'!
copyEmpty
	"Answer an empty copy of this collection"
	
	"Note: this code could be moved to super"
	
	^self species new! !

!SetL1 methodsFor: 'removing' stamp: 'ewe 9/6/2011 17:32'!
copyWithout: oldElement 
	"Answer a copy of the receiver that does not contain any
	elements equal to oldElement."

	^ self copy
		remove: oldElement ifAbsent: [];
		yourself! !

!SetL1 methodsFor: '*activecontext' stamp: 'ewe 11/27/2012 13:35'!
ctxWritearray: v2 __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: 2 . self markOtherAsDirty: 2 ]. ^ array := v2  ! !

!SetL1 methodsFor: 'as yet unclassified' stamp: 'ewe 11/27/2012 13:35'!
ctxWritetally: v2 __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: 1 . self markOtherAsDirty: 1 ]. ^ tally := v2  ! !

!SetL1 methodsFor: 'enumerating' stamp: 'ewe 9/6/2011 17:32'!
do: aBlock 
	tally = 0 ifTrue: [^ self].
	array do:
		[:each |
		each ifNotNil: [aBlock value: each]]! !

!SetL1 methodsFor: 'enumerating' stamp: 'ewe 9/6/2011 17:32'!
doWithIndex: aBlock2
	"Support Set enumeration with a counter, even though not ordered"
	| index |
	index := 0.
	self do: [:item | aBlock2 value: item value: (index := index+1)]! !

!SetL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:32'!
findElementOrNil: anObject
	"Answer the index of a first slot containing either a nil (indicating an empty slot) or an element that matches the given object. Answer the index of that slot or zero. Fail if neither a match nor an empty slot is found."

	| index |

	index := self scanFor: anObject.
	index > 0 ifTrue: [^index].

	"Bad scene.  Neither have we found a matching element
	nor even an empty slot.  No hashed set is ever supposed to get
	completely full."
	self error: 'There is no free space in this set!!'.! !

!SetL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:32'!
fixCollisionsFrom: start
	"The element at start has been removed and replaced by nil.
	This method moves forward from there, relocating any entries
	that had been placed below due to collisions with this one"

	| element index |
	index := start.
	[ (element := array at: (index := index \\ array size + 1)) == nil ] whileFalse: [
		| newIndex |
		(newIndex := self findElementOrNil: element) = index ifFalse: [
			array swap: index with: newIndex ] ]! !

!SetL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:32'!
fullCheck
	"Keep array at least 1/4 free for decent hash behavior"
	array size - tally < (array size // 4 max: 1)
		ifTrue: [self grow]! !

!SetL1 methodsFor: '*activecontext-test' stamp: 'ewe 11/1/2012 08:19'!
get
	^self anyOne! !

!SetL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:32'!
grow
	"Grow the elements array and reinsert the old elements"

	| oldElements |
	oldElements := array.
	array := Array new: (HashTableSizes atLeast: oldElements size * 2).
	tally := 0.
	oldElements
		do:
			[ :each | 
			each == nil
				ifFalse: [ self noCheckAdd: each ] ]! !

!SetL1 methodsFor: 'explorer' stamp: 'ewe 9/6/2011 17:32'!
hasContentsInExplorer

	^self notEmpty! !

!SetL1 methodsFor: 'testing' stamp: 'ewe 9/6/2011 17:32'!
includes: anObject 
	^ (array at: (self findElementOrNil: anObject)) ~~ nil! !

!SetL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:32'!
initialize: n
	"Initialize array to an array size of n"
	array := Array new: n.
	tally := 0! !

!SetL1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
isPrimitive ^ false! !

!SetL1 methodsFor: '*activecontext' stamp: 'ewe 11/1/2012 08:18'!
isThreadSafe 
	^false ! !

!SetL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 17:32'!
like: anObject
	"Answer an object in the receiver that is equal to anObject,
	nil if no such object is found. Relies heavily on hash properties"

	| index |

	^(index := self scanFor: anObject) = 0
		ifFalse: [array at: index]! !

!SetL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:32'!
noCheckAdd: anObject
	array at: (self findElementOrNil: anObject) put: anObject.
	tally := tally + 1! !

!SetL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:32'!
noCheckNoGrowFillFrom: anArray
	"Add the elements of anArray except nils to me assuming that I don't contain any of them, they are unique and I have more free space than they require."

	1 to: anArray size do: [ :index |
		(anArray at: index) ifNotNil: [ :object |
			array
				at: (self scanForEmptySlotFor: object)
				put: object ] ]! !

!SetL1 methodsFor: 'testing' stamp: 'ewe 9/6/2011 17:32'!
occurrencesOf: anObject 
	^ (self includes: anObject) ifTrue: [1] ifFalse: [0]! !

!SetL1 methodsFor: '*ActiveContext' stamp: 'ewe 9/9/2011 12:18'!
postCopy
	<ctxMeta>
	super postCopy.
	
	array := array copy! !

!SetL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:32'!
rehash
	| newSelf |
	newSelf := self species new: self size.
	self do: [:each | newSelf noCheckAdd: each].
	array := newSelf array! !

!SetL1 methodsFor: 'removing' stamp: 'ewe 9/6/2011 17:32'!
remove: oldObject ifAbsent: aBlock

	| index |
	index := self findElementOrNil: oldObject.
	(array at: index) == nil ifTrue: [ ^ aBlock value ].
	array at: index put: nil.
	tally := tally - 1.
	self fixCollisionsFrom: index.
	^ oldObject! !

!SetL1 methodsFor: 'removing' stamp: 'ewe 9/6/2011 17:32'!
removeAll
	"remove all elements from this collection.
	Preserve the capacity"
	
	self initialize: self capacity! !

!SetL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:32'!
scanFor: anObject
	"Scan the key array for the first slot containing either a nil (indicating an empty slot) or an element that matches anObject. Answer the index of that slot or zero if no slot is found. This method will be overridden in various subclasses that have different interpretations for matching elements."
	| element start finish |
	finish := array size.
	start := (anObject hash \\ finish) + 1.
	
	"Search from (hash mod size) to the end."
	start to: finish do:
		[:index | ((element := array at: index) == nil or: [element = anObject])
			ifTrue: [^ index ]].

	"Search from 1 to where we started."
	1 to: start-1 do:
		[:index | ((element := array at: index) == nil or: [element = anObject])
			ifTrue: [^ index ]].

	^ 0  "No match AND no empty slot"! !

!SetL1 methodsFor: '*activecontext' stamp: 'ewe 11/1/2012 08:17'!
secureSelf
<ctxMeta>
	self primitiveChangeClassTo: SetS1 new.   
	__lock__ := Semaphore forMutualExclusion.
	"we must not use method that are not ctxMeta"
	1 to: array size do: 	[:index | ( array primAt: index ) secure ]! !

!SetL1 methodsFor: 'enumerating' stamp: 'ewe 9/6/2011 17:32'!
select: aBlock 
	"Use copyEmpty instead of self species new to give subclasses a chance to initialize additional inst vars."

	"Note: this code could be moved to super"
	
	| newCollection |
	newCollection := self copyEmpty.
	self do: [:each | (aBlock value: each) ifTrue: [newCollection add: each]].
	^newCollection! !

!SetL1 methodsFor: '*activecontext-test' stamp: 'ewe 11/1/2012 08:14'!
set: value 
	self add: value ! !

!SetL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 17:32'!
size
	^ tally! !

!SetL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 17:32'!
someElement
	"Deprecated. Use anyOne."

	^ self anyOne! !

!SetL1 methodsFor: 'enumerating' stamp: 'ewe 9/6/2011 17:32'!
union: aCollection
	"Answer the set theoretic union of the receiver and aCollection, using the receiver's notion of equality and not side effecting the receiver at all."

	^ self copy addAll: aCollection; yourself

! !

!SetL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:32'!
withArray: anArray
	"private -- for use only in copy"
	"I want to get a conflict"
	array := anArray! !

SetL1 subclass: #SetS1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Kernel'!

!SetS1 class methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
isPrimitive ^ false! !

!SetS1 methodsFor: '*activecontext' stamp: 'ewe 11/27/2012 13:35'!
ctxWritearray: v2 __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: 2 . self markOtherAsDirty: 2 ]. ^ array := v2  ! !

!SetS1 methodsFor: 'as yet unclassified' stamp: 'ewe 11/27/2012 13:35'!
ctxWritetally: v2 __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: 1 . self markOtherAsDirty: 1 ]. ^ tally := v2  ! !

!SetS1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
isPrimitive ^ false! !

!SetS1 methodsFor: '*activecontext' stamp: 'ewe 11/1/2012 08:18'!
isThreadSafe 
	^true ! !

!SetS1 methodsFor: '*activecontext' stamp: 'ewe 11/1/2012 08:18'!
secureSelf
! !

!IdentityDictionaryL2 methodsFor: '*activecontext' stamp: 'ewe 11/27/2012 13:35'!
ctxWritearray: v2 __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: 2 . self markOtherAsDirty: 2 ]. ^ array := v2  ! !

!IdentityDictionaryL2 methodsFor: '*activecontext' stamp: 'ewe 11/1/2012 07:36'!
isThreadSafe 
	^false ! !

!IdentityDictionaryL2 methodsFor: '*activecontext' stamp: 'ewe 11/1/2012 07:36'!
secureSelf
<ctxMeta>
	self primitiveChangeClassTo: IdentityDictionaryS2 new.   
	__lock__ := Semaphore forMutualExclusion.
	"we must not use method that are not ctxMeta"
	1 to: array size do: 	[:index | ( array primAt: index ) secure ]! !

!OrderedCollectionL2 methodsFor: '*ActiveContext' stamp: 'ewe 10/11/2012 15:12'!
_postCopy
	<ctxMeta>
	self contextInfo: ContextualInfo new.
	self contextInfo global: true.
	self contextInfo allDirtyBit: false.
	self contextInfo uuid: UUID new..
	array := array copy! !

!OrderedCollectionL2 methodsFor: '*ActiveContext' stamp: 'ewe 10/11/2012 15:12'!
_postCopyFrom: startIndex to: endIndex 
	<ctxMeta>
	self contextInfo: ContextualInfo new.
	self contextInfo global: true.
	self contextInfo allDirtyBit: false.
	self contextInfo uuid: UUID new..
	
	"finish copying the array in a certain range."

	endIndex < startIndex ifFalse: [
		"Because actual size of the array may be greater than used size,
		postCopyFrom:to: may fail to fail and answer an incorrect result
		if this sanity check were not applied"
		(startIndex between: 1 and: self size) ifFalse: [^self error: 'startIndex is out of bounds'].
		(endIndex between: 1 and: self size) ifFalse: [^self error: 'endIndex is out of bounds']].
	
	"Add a protection that lacks in Array>>postcopy"
	array := array copyFrom: startIndex + firstIndex - 1 to: (endIndex max: startIndex - 1) + firstIndex - 1.
	firstIndex := 1.
	lastIndex := array size! !

!OrderedCollectionL2 methodsFor: '*ActiveContext' stamp: 'ewe 10/11/2012 14:38'!
asSet
	"Answer a Set whose elements are the unique elements of the receiver."

	^ Set withAll: self! !

!OrderedCollectionL2 methodsFor: '*activecontext' stamp: 'ewe 11/1/2012 08:37'!
contextInfo
	^ __ctxInfo__! !

!OrderedCollectionL2 methodsFor: '*activecontext' stamp: 'ewe 11/1/2012 08:37'!
contextInfo: value
	 __ctxInfo__ := value.! !

!OrderedCollectionL2 methodsFor: '*ActiveContext' stamp: 'ewe 10/11/2012 14:38'!
gather: aBlock
	^ Array streamContents:
		[:stream |
		self do: [:ea | stream nextPutAll: (aBlock value: ea)]]! !

!OrderedCollectionL2 methodsFor: '*activecontext-test' stamp: 'ewe 11/1/2012 08:33'!
get
	^self at: 1! !

!OrderedCollectionL2 methodsFor: '*activecontext' stamp: 'ewe 11/1/2012 08:37'!
isCtxGlobal
	<ctxMeta>
	^ __ctxInfo__ isNil not. ! !

!OrderedCollectionL2 methodsFor: '*activecontext' stamp: 'ewe 11/1/2012 08:38'!
isThreadSafe 
	^false ! !

!OrderedCollectionL2 methodsFor: '*ActiveContext' stamp: 'ewe 11/12/2012 15:30'!
postCopy
	<ctxMeta>
	super postCopy. 
	__ctxInfo__ := nil .
	array := array copy! !

!OrderedCollectionL2 methodsFor: '*ActiveContext' stamp: 'ewe 10/11/2012 14:38'!
postCopyFrom: startIndex to: endIndex 
	<ctxMeta>

	"finish copying the array in a certain range."

	endIndex < startIndex ifFalse: [
		"Because actual size of the array may be greater than used size,
		postCopyFrom:to: may fail to fail and answer an incorrect result
		if this sanity check were not applied"
		(startIndex between: 1 and: self size) ifFalse: [^self error: 'startIndex is out of bounds'].
		(endIndex between: 1 and: self size) ifFalse: [^self error: 'endIndex is out of bounds']].
	
	"Add a protection that lacks in Array>>postcopy"
	array := array copyFrom: startIndex + firstIndex - 1 to: (endIndex max: startIndex - 1) + firstIndex - 1.
	firstIndex := 1.
	lastIndex := array size! !

!OrderedCollectionL2 methodsFor: '*activecontext' stamp: 'ewe 11/1/2012 08:40'!
secure
	<ctxMeta>
	self secureSelf. 
	self isCtxGlobal ifTrue: [
		self prevMe ifNotNil: [ self prevMe secureSelf ].
		self nextMe ifNotNil: [ self nextMe secureSelf ].
	]! !

!OrderedCollectionL2 methodsFor: '*activecontext' stamp: 'ewe 11/1/2012 08:39'!
secureSelf
<ctxMeta>
	self primitiveChangeClassTo: OrderedCollectionS2 new.   
	__lock__ := Semaphore forMutualExclusion.
	"we must not use method that are not ctxMeta"
	1 to: array size do: 	[:index | ( array primAt: index ) secure ]! !

!OrderedCollectionL2 methodsFor: '*activecontext-test' stamp: 'ewe 11/1/2012 08:34'!
set: value
	self add: value ! !

!SystemDictionary methodsFor: '*activecontext' stamp: 'ewe 11/12/2012 10:45'!
at: key ifAbsent: aBlock 
	"Answer the value associated with the key or, if key isn't found,
	answer the result of evaluating aBlock."

	^((array at: (self findElementOrNil: key)) 
			ifNil: [aBlock] 
			ifNotNil: [:assoc | assoc]) value.! !

!AssociationS2 methodsFor: '*activecontext' stamp: 'ewe 11/27/2012 13:35'!
ctxWritekey: v2 __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: 3 . self markOtherAsDirty: 3 ]. ^ key := v2  ! !

!AssociationS2 methodsFor: '*activecontext' stamp: 'ewe 11/27/2012 13:35'!
ctxWritevalue: v2 __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: 5 . self markOtherAsDirty: 5 ]. ^ value := v2  ! !

!AssociationS2 methodsFor: '*activecontext' stamp: 'ewe 10/31/2012 06:16'!
isThreadSafe 
	^true ! !

Magnitude subclass: #LookupKeyL1
	instanceVariableNames: '__ctxInfo__ __lock__ key __ctxIdentity__'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Kernel'!

LookupKeyL1 subclass: #AssociationL1
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Kernel'!

!AssociationL1 class methodsFor: 'instance creation' stamp: 'ewe 10/12/2012 11:35'!
isPrimitive ^ false! !

!AssociationL1 class methodsFor: 'instance creation' stamp: 'ewe 9/6/2011 17:32'!
key: newKey value: newValue
	"Answer an instance of me with the arguments as the key and value of 
	the association."

	^(super key: newKey) value: newValue! !

!AssociationL1 methodsFor: 'comparing' stamp: 'ewe 9/6/2011 17:32'!
= anAssociation

	^ super = anAssociation and: [value = anAssociation value]! !

!AssociationL1 methodsFor: 'as yet unclassified' stamp: 'ewe 11/27/2012 13:34'!
ctxReadvalue __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: 5 ]. ^  value! !

!AssociationL1 methodsFor: '*activecontext' stamp: 'ewe 11/27/2012 13:35'!
ctxWritekey: v2 __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: 3 . self markOtherAsDirty: 3 ]. ^ key := v2  ! !

!AssociationL1 methodsFor: '*activecontext' stamp: 'ewe 11/27/2012 13:35'!
ctxWritevalue: v2 __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: 5 . self markOtherAsDirty: 5 ]. ^ value := v2  ! !

!AssociationL1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
isPrimitive ^ false! !

!AssociationL1 methodsFor: 'self evaluating' stamp: 'ewe 9/6/2011 17:32'!
isSelfEvaluating
	^ self class == Association and: [self key isSelfEvaluating and: [self value isSelfEvaluating]]! !

!AssociationL1 methodsFor: '*activecontext' stamp: 'ewe 10/31/2012 06:15'!
isThreadSafe 
	^false ! !

!AssociationL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 17:32'!
key: aKey value: anObject 
	"Store the arguments as the variables of the receiver."

	key := aKey.
	value := anObject! !

!AssociationL1 methodsFor: 'printing' stamp: 'ewe 9/12/2011 14:28'!
printOn: aStream

	super printOn: aStream.
	aStream nextPutAll: '-->'.
	value printOn: aStream.
	
	( self isCtxGlobal and:  [ self contextInfo isNil not ] ) ifTrue: [
		self nextMe isNil ifTrue: [ aStream nextPutAll: 'OLD'  ]
					    ifFalse: [aStream nextPutAll: 'NEW'  ].
	]
	! !

!AssociationL1 methodsFor: '*activecontext' stamp: 'ewe 10/31/2012 06:19'!
secureSelf
<ctxMeta>
	self primitiveChangeClassTo: AssociationS1 new.  
	__lock__ := Semaphore forMutualExclusion.
	key secure.
	value secure. 
	! !

!AssociationL1 methodsFor: 'printing' stamp: 'ewe 9/6/2011 17:32'!
storeOn: aStream
	"Store in the format (key->value)"
	aStream nextPut: $(.
	key storeOn: aStream.
	aStream nextPutAll: '->'.
	value storeOn: aStream.
	aStream nextPut: $)! !

!AssociationL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 17:32'!
value
	"Answer the value of the receiver."

	^value! !

!AssociationL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 17:32'!
value: anObject 
	"Store the argument, anObject, as the value of the receiver."

	value := anObject! !

AssociationL1 subclass: #AssociationS1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Kernel'!

!AssociationS1 class methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
isPrimitive ^ false! !

!AssociationS1 methodsFor: '*activecontext' stamp: 'ewe 11/27/2012 13:35'!
ctxWritekey: v2 __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: 3 . self markOtherAsDirty: 3 ]. ^ key := v2  ! !

!AssociationS1 methodsFor: '*activecontext' stamp: 'ewe 11/27/2012 13:35'!
ctxWritevalue: v2 __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: 5 . self markOtherAsDirty: 5 ]. ^ value := v2  ! !

!AssociationS1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
isPrimitive ^ false! !

!AssociationS1 methodsFor: '*activecontext' stamp: 'ewe 10/31/2012 06:16'!
isThreadSafe 
	^true ! !

!LookupKeyL1 class methodsFor: 'instance creation' stamp: 'ewe 10/12/2012 11:35'!
isPrimitive ^ false! !

!LookupKeyL1 class methodsFor: 'instance creation' stamp: 'ewe 9/6/2011 17:32'!
key: aKey 
	"Answer an instance of me with the argument as the lookup up."

	^self basicNew key: aKey! !

!LookupKeyL1 methodsFor: 'comparing' stamp: 'ewe 9/6/2011 17:32'!
< aLookupKey 
	"Refer to the comment in Magnitude|<."

	^key < aLookupKey key! !

!LookupKeyL1 methodsFor: 'comparing' stamp: 'ewe 9/6/2011 17:32'!
= aLookupKey

	self species = aLookupKey species
		ifTrue: [^key = aLookupKey key]
		ifFalse: [^false]! !

!LookupKeyL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 17:32'!
canAssign

	^ true! !

!LookupKeyL1 methodsFor: 'as yet unclassified' stamp: 'ewe 11/19/2012 15:03'!
contextIdentity ^__ctxIdentity__! !

!LookupKeyL1 methodsFor: 'as yet unclassified' stamp: 'ewe 11/19/2012 15:03'!
contextIdentity: id __ctxIdentity__ := id! !

!LookupKeyL1 methodsFor: '*activecontext' stamp: 'ewe 10/31/2012 08:12'!
contextInfo
	^ __ctxInfo__! !

!LookupKeyL1 methodsFor: '*activecontext' stamp: 'ewe 10/31/2012 08:12'!
contextInfo: value
	 __ctxInfo__ := value.! !

!LookupKeyL1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
ctxRead__ctxInfo__ self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 2 ]. ^  __ctxInfo__! !

!LookupKeyL1 methodsFor: 'as yet unclassified' stamp: 'ewe 11/27/2012 13:34'!
ctxReadkey __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: 3 ]. ^  key! !

!LookupKeyL1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
ctxWrite__ctxInfo__: v2 self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 2 . self markOtherAsDirty: 2 ].  ^ __ctxInfo__ := v2 secure  ! !

!LookupKeyL1 methodsFor: 'as yet unclassified' stamp: 'ewe 11/27/2012 13:35'!
ctxWritekey: v2 __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: 3 . self markOtherAsDirty: 3 ]. ^ key := v2  ! !

!LookupKeyL1 methodsFor: 'comparing' stamp: 'ewe 9/6/2011 17:32'!
hash
	"Hash is reimplemented because = is implemented."

	^key hash! !

!LookupKeyL1 methodsFor: 'as yet unclassified' stamp: 'ewe 11/19/2012 15:03'!
identityHash ^ self contextIdentityHash! !

!LookupKeyL1 methodsFor: '*activecontext' stamp: 'ewe 10/31/2012 08:16'!
isCtxGlobal
	<ctxMeta>
	^ __ctxInfo__ isNil not. ! !

!LookupKeyL1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
isPrimitive ^ false! !

!LookupKeyL1 methodsFor: 'testing' stamp: 'ewe 9/6/2011 17:32'!
isSpecialReadBinding
	"Return true if this variable binding is read protected, e.g., should not be accessed primitively but rather by sending #value messages"
	^false! !

!LookupKeyL1 methodsFor: 'testing' stamp: 'ewe 9/6/2011 17:32'!
isVariableBinding
	"Return true if I represent a literal variable binding"
	^true! !

!LookupKeyL1 methodsFor: 'accessing' stamp: 'ewe 10/31/2012 06:45'!
key
	"Answer the lookup key of the receiver."

	^key! !

!LookupKeyL1 methodsFor: 'accessing' stamp: 'ewe 10/31/2012 06:45'!
key: anObject 
	"Store the argument, anObject, as the lookup key of the receiver."

	key := anObject! !

!LookupKeyL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 17:32'!
name

	^ self key isString
		ifTrue: [self key]
		ifFalse: [self key printString]! !

!LookupKeyL1 methodsFor: '*activecontext' stamp: 'ewe 10/31/2012 08:11'!
postCopy
	<ctxMeta>
	super postCopy. 
	__ctxInfo__ := nil .! !

!LookupKeyL1 methodsFor: 'printing' stamp: 'ewe 9/6/2011 17:32'!
printOn: aStream

	key printOn: aStream! !

!LookupKeyL1 methodsFor: '*activecontext' stamp: 'ewe 10/31/2012 08:58'!
secure
	<ctxMeta>
	self secureSelf. 
	self isCtxGlobal ifTrue: [
		self prevMe ifNotNil: [ self prevMe secureSelf ].
		self nextMe ifNotNil: [ self nextMe secureSelf ].
	]! !

!LookupKeyL1 methodsFor: 'filter streaming' stamp: 'ewe 9/6/2011 17:32'!
writeOnFilterStream: aStream

	aStream write:key.! !

LookupKeyL1 subclass: #LookupKeyS1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Kernel'!

!LookupKeyS1 class methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
isPrimitive ^ false! !

!LookupKeyS1 methodsFor: 'as yet unclassified' stamp: 'ewe 11/27/2012 13:35'!
ctxWritekey: v2 __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: 3 . self markOtherAsDirty: 3 ]. ^ key := v2  ! !

!LookupKeyS1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
isPrimitive ^ false! !

!Magnitude methodsFor: '*activecontext' stamp: 'ewe 9/27/2011 14:28'!
isPrimitive ^true! !

SequenceableCollection subclass: #OrderedCollectionL1
	uses: TSortable
	instanceVariableNames: '__ctxInfo__ __lock__ array firstIndex lastIndex __ctxIdentity__'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Kernel'!

OrderedCollectionL1 class
	uses: TSortable classTrait
	instanceVariableNames: ''!

!OrderedCollectionL1 class methodsFor: 'instance creation' stamp: 'ewe 10/12/2012 11:35'!
isPrimitive ^ false! !

!OrderedCollectionL1 class methodsFor: 'instance creation' stamp: 'ewe 9/6/2011 17:32'!
new
	^ self new: 10! !

!OrderedCollectionL1 class methodsFor: 'instance creation' stamp: 'ewe 11/6/2012 14:05'!
new: anInteger 
	"Create a collection with enough room allocated to contain up to anInteger elements.
	The new instance will be of size 0 (allocated room is not necessarily used)."

	^self basicNew setCollection: (Array new: anInteger)! !

!OrderedCollectionL1 class methodsFor: 'instance creation' stamp: 'ewe 9/6/2011 17:32'!
new: anInteger withAll: anObject
	^ self basicNew setContents: (Array new: anInteger withAll: anObject)! !

!OrderedCollectionL1 class methodsFor: 'instance creation' stamp: 'ewe 9/6/2011 17:32'!
newFrom: aCollection 
	"Answer an instance of me containing the same elements as aCollection."

	| newCollection |
	newCollection := self new: aCollection size.
	newCollection addAll: aCollection.
	^newCollection

"	OrderedCollection newFrom: {1. 2. 3}
	{1. 2. 3} as: OrderedCollection
	{4. 2. 7} as: SortedCollection
"! !

!OrderedCollectionL1 class methodsFor: 'instance creation' stamp: 'ewe 9/6/2011 17:32'!
ofSize: n
	"Create a new collection of size n with nil as its elements.
	This method exists because OrderedCollection new: n creates an
	empty collection,  not one of size n."
	| collection |
	collection := self new: n.
	collection setContents: (collection collector).
	^ collection
! !

!OrderedCollectionL1 methodsFor: '*ActiveContext' stamp: 'ewe 10/11/2012 15:12'!
_postCopy
	<ctxMeta>
	self contextInfo: ContextualInfo new.
	self contextInfo global: true.
	self contextInfo allDirtyBit: false.
	self contextInfo uuid: UUID new..
	array := array copy! !

!OrderedCollectionL1 methodsFor: '*ActiveContext' stamp: 'ewe 10/11/2012 15:12'!
_postCopyFrom: startIndex to: endIndex 
	<ctxMeta>
	self contextInfo: ContextualInfo new.
	self contextInfo global: true.
	self contextInfo allDirtyBit: false.
	self contextInfo uuid: UUID new..
	
	"finish copying the array in a certain range."

	endIndex < startIndex ifFalse: [
		"Because actual size of the array may be greater than used size,
		postCopyFrom:to: may fail to fail and answer an incorrect result
		if this sanity check were not applied"
		(startIndex between: 1 and: self size) ifFalse: [^self error: 'startIndex is out of bounds'].
		(endIndex between: 1 and: self size) ifFalse: [^self error: 'endIndex is out of bounds']].
	
	"Add a protection that lacks in Array>>postcopy"
	array := array copyFrom: startIndex + firstIndex - 1 to: (endIndex max: startIndex - 1) + firstIndex - 1.
	firstIndex := 1.
	lastIndex := array size! !

!OrderedCollectionL1 methodsFor: 'adding' stamp: 'ewe 9/6/2011 17:32'!
add: newObject

	^self addLast: newObject! !

!OrderedCollectionL1 methodsFor: 'adding' stamp: 'ewe 9/6/2011 17:32'!
add: newObject after: oldObject 
	"Add the argument, newObject, as an element of the receiver. Put it in 
	the sequence just succeeding oldObject. Answer newObject."
	
	| index |
	index := self find: oldObject.
	self insert: newObject before: index + 1.
	^newObject! !

!OrderedCollectionL1 methodsFor: 'adding' stamp: 'ewe 9/6/2011 17:32'!
add: newObject afterIndex: index 
	"Add the argument, newObject, as an element of the receiver. Put it in 
	the sequence just after index. Answer newObject."
	(index between: 0 and: self size) ifFalse:[^self errorSubscriptBounds: index].
	self insert: newObject before: firstIndex + index.
	^ newObject! !

!OrderedCollectionL1 methodsFor: 'adding' stamp: 'ewe 9/6/2011 17:32'!
add: newObject before: oldObject 
	"Add the argument, newObject, as an element of the receiver. Put it in 
	the sequence just preceding oldObject. Answer newObject."
	
	| index |
	index := self find: oldObject.
	self insert: newObject before: index.
	^newObject! !

!OrderedCollectionL1 methodsFor: 'adding' stamp: 'ewe 9/6/2011 17:32'!
add: newObject beforeIndex: index 
	"Add the argument, newObject, as an element of the receiver. Put it in 
	the sequence just before index. Answer newObject."
	(index between: 1 and: self size+1) ifFalse:[^self errorSubscriptBounds: index].
	self insert: newObject before: firstIndex + index - 1.
	^ newObject! !

!OrderedCollectionL1 methodsFor: 'adding' stamp: 'ewe 9/6/2011 17:32'!
addAll: aCollection 
	"Add each element of aCollection at my end. Answer	aCollection."

	^ self addAllLast: aCollection! !

!OrderedCollectionL1 methodsFor: 'adding' stamp: 'ewe 9/6/2011 17:32'!
addAllFirst: anOrderedCollection 
	"Add each element of anOrderedCollection at the beginning of the 
	receiver. Answer anOrderedCollection."

	anOrderedCollection reverseDo: [:each | self addFirst: each].
	^anOrderedCollection! !

!OrderedCollectionL1 methodsFor: 'adding' stamp: 'ewe 9/6/2011 17:32'!
addAllFirstUnlessAlreadyPresent: anOrderedCollection 
	"Add each element of anOrderedCollection at the beginning of the receiver, preserving the order, but do not add any items that are already in the receiver.  Answer anOrderedCollection."

	anOrderedCollection reverseDo:
		[:each | (self includes: each) ifFalse: [self addFirst: each]].
	^ anOrderedCollection! !

!OrderedCollectionL1 methodsFor: 'adding' stamp: 'ewe 9/6/2011 17:32'!
addAllLast: aCollection 
	"Add each element of aCollection at the end of the receiver. 
	Answer aCollection."

	aCollection do: [:each | self addLast: each].
	^aCollection! !

!OrderedCollectionL1 methodsFor: 'adding' stamp: 'ewe 9/6/2011 17:32'!
addFirst: newObject 
	"Add newObject to the beginning of the receiver. Answer newObject."

	firstIndex = 1 ifTrue: [self makeRoomAtFirst].
	firstIndex := firstIndex - 1.
	array at: firstIndex put: newObject.
	^ newObject! !

!OrderedCollectionL1 methodsFor: 'adding' stamp: 'ewe 9/6/2011 17:32'!
addLast: newObject 
	"Add newObject to the end of the receiver. Answer newObject."

	lastIndex = array size ifTrue: [self makeRoomAtLast].
	lastIndex := lastIndex + 1.
	array at: lastIndex put: newObject.
	^ newObject! !

!OrderedCollectionL1 methodsFor: 'converting' stamp: 'ewe 9/6/2011 17:32'!
asArray
	^ (Array new: self size) replaceFrom: 1 to: self size with: array startingAt: firstIndex.! !

!OrderedCollectionL1 methodsFor: '*ActiveContext' stamp: 'ewe 9/12/2011 19:08'!
asSet
	"Answer a Set whose elements are the unique elements of the receiver."

	^ Set withAll: self! !

!OrderedCollectionL1 methodsFor: 'sorting' stamp: 'ewe 9/6/2011 17:32'!
asSortedArray
	self deprecated: 'Use asArray sort' on: '01 April 2010' in: 'Pharo1.1'.
	self isSorted ifTrue: [^ self asArray].
	^ super asSortedArray! !

!OrderedCollectionL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 17:32'!
at: anInteger 
	"Answer my element at index anInteger. at: is used by a knowledgeable
	client to access an existing element"

	(anInteger < 1 or: [anInteger + firstIndex - 1 > lastIndex])
		ifTrue: [self errorNoSuchElement]
		ifFalse: [^ array at: anInteger + firstIndex - 1]! !

!OrderedCollectionL1 methodsFor: 'adding' stamp: 'ewe 9/6/2011 17:32'!
at: index ifAbsentPut: block
	"Return value at index, however, if value does not exist (nil or out of bounds) then add block's value at index (growing self if necessary)"

	| v |
	index <= self size ifTrue: [
		^ (v := self at: index)
			ifNotNil: [v]
			ifNil: [self at: index put: block value]
	].
	[self size < index] whileTrue: [self add: nil].
	^ self at: index put: block value! !

!OrderedCollectionL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 17:32'!
at: anInteger put: anObject 
	"Put anObject at element index anInteger. at:put: cannot be used to
	append, front or back, to an ordered collection; it is used by a
	knowledgeable client to replace an element."

	| index |
	index := anInteger asInteger.
	(index < 1 or: [index + firstIndex - 1 > lastIndex])
		ifTrue: [self errorNoSuchElement]
		ifFalse: [^array at: index + firstIndex - 1 put: anObject]! !

!OrderedCollectionL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 17:32'!
capacity
	"Answer the current capacity of the receiver."

	^ array size! !

!OrderedCollectionL1 methodsFor: 'enumerating' stamp: 'ewe 9/6/2011 17:32'!
collect: aBlock 
	"Evaluate aBlock with each of my elements as the argument. Collect the 
	resulting values into a collection that is like me. Answer the new 
	collection. Override superclass in order to use addLast:, not at:put:."

	| newCollection |
	newCollection := self species new: self size.
	firstIndex to: lastIndex do:
		[:index |
		newCollection addLast: (aBlock value: (array at: index))].
	^ newCollection! !

!OrderedCollectionL1 methodsFor: 'enumerating' stamp: 'ewe 9/6/2011 17:32'!
collect: aBlock from: fromIndex to: toIndex
	"Override superclass in order to use addLast:, not at:put:."
	| result |
	(fromIndex < 1 or:[toIndex + firstIndex - 1 > lastIndex])
		ifTrue: [^self errorNoSuchElement].
	result := self species new: toIndex - fromIndex + 1.
	firstIndex + fromIndex - 1 to: firstIndex + toIndex - 1 do:
		[:index | result addLast: (aBlock value: (array at: index))].
	^ result
! !

!OrderedCollectionL1 methodsFor: 'enumerating' stamp: 'ewe 9/6/2011 17:32'!
collect: collectBlock thenSelect: selectBlock
    " Utility method to improve readability.
	Do not create the intermediate collection."

    | newCollection |

    newCollection := self copyEmpty.
    firstIndex to: lastIndex do:[: index | 
		| newElement |
		newElement := collectBlock value: ( array at: index ).
		( selectBlock value: newElement ) 
			ifTrue:[ newCollection addLast: newElement. ]
    ].
    ^ newCollection! !

!OrderedCollectionL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:32'!
collector  "Private"
	^ array! !

!OrderedCollectionL1 methodsFor: 'as yet unclassified' stamp: 'ewe 11/19/2012 15:03'!
contextIdentity ^__ctxIdentity__! !

!OrderedCollectionL1 methodsFor: 'as yet unclassified' stamp: 'ewe 11/19/2012 15:03'!
contextIdentity: id __ctxIdentity__ := id! !

!OrderedCollectionL1 methodsFor: '*activecontext' stamp: 'ewe 11/1/2012 08:37'!
contextInfo
	^ __ctxInfo__! !

!OrderedCollectionL1 methodsFor: '*activecontext' stamp: 'ewe 11/1/2012 08:37'!
contextInfo: value
	 __ctxInfo__ := value.! !

!OrderedCollectionL1 methodsFor: 'copying' stamp: 'ewe 9/6/2011 17:32'!
copyEmpty
	"Answer a copy of the receiver that contains no elements."

	^self species new! !

!OrderedCollectionL1 methodsFor: 'copying' stamp: 'ewe 9/6/2011 17:32'!
copyFrom: startIndex to: endIndex 
	"Answer a copy of the receiver that contains elements from position
	startIndex to endIndex."

	^self shallowCopy postCopyFrom: startIndex to: endIndex! !

!OrderedCollectionL1 methodsFor: 'copying' stamp: 'ewe 9/6/2011 17:32'!
copyReplaceFrom: start to: stop with: replacementCollection 
	"Answer a copy of the receiver with replacementCollection's elements in
	place of the receiver's start'th to stop'th elements. This does not expect
	a 1-1 map from replacementCollection to the start to stop elements, so it
	will do an insert or append."

	| newOrderedCollection delta startIndex stopIndex |
	"if start is less than 1, ignore stop and assume this is inserting at the front. 
	if start greater than self size, ignore stop and assume this is appending. 
	otherwise, it is replacing part of me and start and stop have to be within my 
	bounds. "
	delta := 0.
	startIndex := start.
	stopIndex := stop.
	start < 1
		ifTrue: [startIndex := stopIndex := 0]
		ifFalse: [startIndex > self size
				ifTrue: [startIndex := stopIndex := self size + 1]
				ifFalse: 
					[(stopIndex < (startIndex - 1) or: [stopIndex > self size])
						ifTrue: [self errorOutOfBounds].
					delta := stopIndex - startIndex + 1]].
	newOrderedCollection := 
		self species new: self size + replacementCollection size - delta.
	1 to: startIndex - 1 do: [:index | newOrderedCollection add: (self at: index)].
	1 to: replacementCollection size do: 
		[:index | newOrderedCollection add: (replacementCollection at: index)].
	stopIndex + 1 to: self size do: [:index | newOrderedCollection add: (self at: index)].
	^newOrderedCollection! !

!OrderedCollectionL1 methodsFor: 'copying' stamp: 'ewe 9/6/2011 17:32'!
copyWith: newElement 
	"Answer a copy of the receiver that is 1 bigger than the receiver and 
	includes the argument, newElement, at the end."

	| newCollection |
	newCollection := self copy.
	newCollection add: newElement.
	^newCollection! !

!OrderedCollectionL1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
ctxRead__ctxInfo__ self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 4 ]. ^  __ctxInfo__! !

!OrderedCollectionL1 methodsFor: 'as yet unclassified' stamp: 'ewe 11/27/2012 13:34'!
ctxReadarray __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: 3 ]. ^  array! !

!OrderedCollectionL1 methodsFor: 'as yet unclassified' stamp: 'ewe 11/27/2012 13:34'!
ctxReadfirstIndex __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: 4 ]. ^  firstIndex! !

!OrderedCollectionL1 methodsFor: 'as yet unclassified' stamp: 'ewe 11/27/2012 13:34'!
ctxReadlastIndex __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: 5 ]. ^  lastIndex! !

!OrderedCollectionL1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
ctxWrite__ctxInfo__: v2 self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 4 . self markOtherAsDirty: 4 ].  ^ __ctxInfo__ := v2 secure  ! !

!OrderedCollectionL1 methodsFor: 'as yet unclassified' stamp: 'ewe 11/27/2012 13:35'!
ctxWritearray: v2 __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: 3 . self markOtherAsDirty: 3 ]. ^ array := v2  ! !

!OrderedCollectionL1 methodsFor: 'as yet unclassified' stamp: 'ewe 11/27/2012 13:35'!
ctxWritefirstIndex: v2 __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: 4 . self markOtherAsDirty: 4 ]. ^ firstIndex := v2  ! !

!OrderedCollectionL1 methodsFor: 'as yet unclassified' stamp: 'ewe 11/27/2012 13:35'!
ctxWritelastIndex: v2 __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: 5 . self markOtherAsDirty: 5 ]. ^ lastIndex := v2  ! !

!OrderedCollectionL1 methodsFor: 'enumerating' stamp: 'ewe 9/6/2011 17:32'!
do: aBlock 
	"Override the superclass for performance reasons."
	| index |
	index := firstIndex.
	[index <= lastIndex]
		whileTrue: 
			[aBlock value: (array at: index).
			index := index + 1]! !

!OrderedCollectionL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:32'!
errorConditionNotSatisfied

	self error: 'no element satisfies condition'! !

!OrderedCollectionL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:32'!
errorNoSuchElement

	self error: 'attempt to index non-existent element in an ordered collection'! !

!OrderedCollectionL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:32'!
find: oldObject
  "  This method answers an index in the range firstIndex .. lastIndex, which is meant for internal use only.
     Never use this method in your code, the methods for public use are:
        #indexOf:
        #indexOf:ifAbsent: "

	| index |
	index := firstIndex.
	[index <= lastIndex]
		whileTrue:
			[(array at: index) = oldObject ifTrue: [^ index].
			index := index + 1].
	self errorNotFound: oldObject! !

!OrderedCollectionL1 methodsFor: '*ActiveContext' stamp: 'ewe 9/12/2011 19:01'!
gather: aBlock
	^ Array streamContents:
		[:stream |
		self do: [:ea | stream nextPutAll: (aBlock value: ea)]]! !

!OrderedCollectionL1 methodsFor: '*activecontext-test' stamp: 'ewe 11/1/2012 08:36'!
get
	^self at: 1! !

!OrderedCollectionL1 methodsFor: 'adding' stamp: 'ewe 9/6/2011 17:32'!
grow
	"Become larger. Typically, a subclass has to override this if the subclass
	adds instance variables."
	| newArray |
	newArray := Array new: self size + self growSize.
	newArray replaceFrom: 1 to: array size with: array startingAt: 1.
	array := newArray! !

!OrderedCollectionL1 methodsFor: 'adding' stamp: 'ewe 9/6/2011 17:32'!
growSize
	^ array size max: 2! !

!OrderedCollectionL1 methodsFor: 'testing' stamp: 'ewe 9/6/2011 17:32'!
hasContentsInExplorer

	^self notEmpty! !

!OrderedCollectionL1 methodsFor: 'as yet unclassified' stamp: 'ewe 11/19/2012 15:03'!
identityHash ^ self contextIdentityHash! !

!OrderedCollectionL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:32'!
insert: anObject before: spot

  "  spot is an index in the range firstIndex .. lastIndex, such an index is not known from outside the collection. 
     Never use this method in your code, it is meant for private use by OrderedCollection only.
     The methods for use are:
        #add:before:   to insert an object before another object
        #add:beforeIndex:   to insert an object before a given position. "
	| "index" delta spotIndex|
	spotIndex := spot.
	delta := spotIndex - firstIndex.
	firstIndex = 1
		ifTrue: 
			[self makeRoomAtFirst.
			spotIndex := firstIndex + delta].
	firstIndex := firstIndex - 1.
	array
		replaceFrom: firstIndex
		to: spotIndex - 2
		with: array
		startingAt: firstIndex + 1.
	array at: spotIndex - 1 put: anObject.
"	index := firstIndex := firstIndex - 1.
	[index < (spotIndex - 1)]
		whileTrue: 
			[array at: index put: (array at: index + 1).
			index := index + 1].
	array at: index put: anObject."
	^ anObject! !

!OrderedCollectionL1 methodsFor: '*activecontext' stamp: 'ewe 11/1/2012 08:37'!
isCtxGlobal
	<ctxMeta>
	^ __ctxInfo__ isNil not. ! !

!OrderedCollectionL1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
isPrimitive ^ false! !

!OrderedCollectionL1 methodsFor: 'sorting' stamp: 'ewe 9/6/2011 17:32'!
isSorted
	"Return true if the receiver is sorted by the given criterion.
	Optimization for isSortedBy: [:a :b | a <= b]."

	| lastElm elm |
	self isEmpty ifTrue: [^ true].
	lastElm := self first.
	2 to: self size do: 
		[:index | 
		elm := self at: index.
		lastElm <= elm ifFalse: [^ false].
		lastElm := elm].
	^ true! !

!OrderedCollectionL1 methodsFor: 'sorting' stamp: 'ewe 9/6/2011 17:32'!
isSortedBy: aBlock
	"Return true if the receiver is sorted by the given criterion."

	| lastElm elm |
	self isEmpty ifTrue: [^ true].
	lastElm := self first.
	2 to: self size do: 
		[:index | 
		elm := self at: index.
		(aBlock value: lastElm value: elm) ifFalse: [^ false].
		lastElm := elm].
	^ true! !

!OrderedCollectionL1 methodsFor: '*activecontext' stamp: 'ewe 11/1/2012 08:39'!
isThreadSafe 
	^false ! !

!OrderedCollectionL1 methodsFor: 'splitjoin' stamp: 'ewe 9/6/2011 17:32'!
join: aCollection 
	| result |
	result := self class new.
	aCollection
		do: [:each | each appendTo: result]
		separatedBy: [self appendTo: result].
	^ result! !

!OrderedCollectionL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:32'!
makeRoomAtFirst
	| delta index |
	delta := array size - self size.
	delta = 0 ifTrue: 
			[self grow.
			delta := array size - self size].
	lastIndex = array size ifTrue: [^ self]. "just in case we got lucky"
	index := array size.
	[index > delta]
		whileTrue: 
			[array at: index put: (array at: index - delta + firstIndex - 1).
			array at: index - delta + firstIndex - 1 put: nil.
			index := index - 1].
	firstIndex := delta + 1.
	lastIndex := array size! !

!OrderedCollectionL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:32'!
makeRoomAtLast
	| newLast delta |
	newLast := self size.
	array size - self size = 0 ifTrue: [self grow].
	(delta := firstIndex - 1) = 0 ifTrue: [^ self].
	"we might be here under false premises or grow did the job for us"
	1 to: newLast do:
		[:index |
		array at: index put: (array at: index + delta).
		array at: index + delta put: nil].
	firstIndex := 1.
	lastIndex := newLast! !

!OrderedCollectionL1 methodsFor: 'sorting' stamp: 'ewe 9/6/2011 17:32'!
mergeFirst: first middle: middle last: last into: dst by: aBlock
	"Private. Merge the sorted ranges [first..middle] and [middle+1..last] 
	of the receiver into the range [first..last] of dst."

	| i1 i2 val1 val2 out |
	i1 := first.
	i2 := middle + 1.
	val1 := self at: i1.
	val2 := self at: i2.
	out := first - 1.  "will be pre-incremented"

	"select 'lower' half of the elements based on comparator"
	[(i1 <= middle) and: [i2 <= last]] whileTrue:
		[(aBlock value: val1 value: val2)
			ifTrue: [dst at: (out := out + 1) put: val1.
					val1 := self at: (i1 := i1 + 1)]
			ifFalse: [dst at: (out := out + 1) put: val2.
					i2 := i2 + 1.
					i2 <= last ifTrue: [val2 := self at: i2]]].

	"copy the remaining elements"
	i1 <= middle
		ifTrue: [dst replaceFrom: out + 1 to: last with: self startingAt: i1]
		ifFalse: [dst replaceFrom: out + 1 to: last with: self startingAt: i2]! !

!OrderedCollectionL1 methodsFor: 'sorting' stamp: 'ewe 9/6/2011 17:32'!
mergeSortFrom: startIndex to: stopIndex by: aBlock
	"Sort the given range of indices using the mergesort algorithm.
	Mergesort is a worst-case O(N log N) sorting algorithm that usually
	does only half as many comparisons as heapsort or quicksort."

	"Details: recursively split the range to be sorted into two halves,
	mergesort each half, then merge the two halves together. An extra 
	copy of the data is used as temporary storage and successive merge 
	phases copy data back and forth between the receiver and this copy.
	The recursion is set up so that the final merge is performed into the
	receiver, resulting in the receiver being completely sorted."

	self size <= 1 ifTrue: [^ self].  "nothing to do"
	startIndex = stopIndex ifTrue: [^ self].
	[startIndex >= 1 and: [startIndex < stopIndex]] assert. "bad start index"
	[stopIndex <= self size] assert. "bad stop index"
	self
		mergeSortFrom: startIndex
		to: stopIndex 
		src: self copy 
		dst: self 
		by: aBlock! !

!OrderedCollectionL1 methodsFor: 'sorting' stamp: 'ewe 9/6/2011 17:32'!
mergeSortFrom: first to: last src: src dst: dst by: aBlock
	"Private. Split the range to be sorted in half, sort each half, and 
	merge the two half-ranges into dst."

	| middle |
	first = last ifTrue: [^ self].
	middle := (first + last) // 2.
	self mergeSortFrom: first to: middle src: dst dst: src by: aBlock.
	self mergeSortFrom: middle + 1 to: last src: dst dst: src by: aBlock.
	src mergeFirst: first middle: middle last: last into: dst by: aBlock! !

!OrderedCollectionL1 methodsFor: '*ActiveContext' stamp: 'ewe 11/12/2012 15:30'!
postCopy
	<ctxMeta>
	super postCopy. 
	__ctxInfo__ := nil .
	array := array copy! !

!OrderedCollectionL1 methodsFor: '*ActiveContext' stamp: 'ewe 9/9/2011 12:19'!
postCopyFrom: startIndex to: endIndex 
	<ctxMeta>

	"finish copying the array in a certain range."

	endIndex < startIndex ifFalse: [
		"Because actual size of the array may be greater than used size,
		postCopyFrom:to: may fail to fail and answer an incorrect result
		if this sanity check were not applied"
		(startIndex between: 1 and: self size) ifFalse: [^self error: 'startIndex is out of bounds'].
		(endIndex between: 1 and: self size) ifFalse: [^self error: 'endIndex is out of bounds']].
	
	"Add a protection that lacks in Array>>postcopy"
	array := array copyFrom: startIndex + firstIndex - 1 to: (endIndex max: startIndex - 1) + firstIndex - 1.
	firstIndex := 1.
	lastIndex := array size! !

!OrderedCollectionL1 methodsFor: 'removing' stamp: 'ewe 9/6/2011 17:32'!
remove: oldObject ifAbsent: absentBlock

	| index |
	index := firstIndex.
	[index <= lastIndex]
		whileTrue: 
			[oldObject = (array at: index)
				ifTrue: 
					[self removeIndex: index.
					^ oldObject]
				ifFalse: [index := index + 1]].
	^ absentBlock value! !

!OrderedCollectionL1 methodsFor: 'removing' stamp: 'ewe 9/6/2011 17:32'!
removeAll
	"remove all the elements from this collection.
	Keep same amount of storage"
	
	self setCollection: (Array new: array size)! !

!OrderedCollectionL1 methodsFor: 'removing' stamp: 'ewe 9/6/2011 17:32'!
removeAllSuchThat: aBlock 
	"Remove each element of the receiver for which aBlock evaluates to true.
	The method in Collection is O(N^2), this is O(N)."

	| n |
	n := firstIndex.
	firstIndex to: lastIndex do: [:index |
	    (aBlock value: (array at: index)) ifFalse: [
			array at: n put: (array at: index).
			n := n + 1]].
	array from: n to: lastIndex put: nil.
	lastIndex := n - 1! !

!OrderedCollectionL1 methodsFor: 'removing' stamp: 'ewe 9/6/2011 17:32'!
removeAt: index
	| removed |
	removed := self at: index.
	self removeIndex: index + firstIndex - 1.
	^removed! !

!OrderedCollectionL1 methodsFor: 'removing' stamp: 'ewe 9/6/2011 17:32'!
removeFirst
	"Remove the first element of the receiver and answer it. If the receiver is 
	empty, create an error notification."
	| firstObject |
	self emptyCheck.
	firstObject := array at: firstIndex.
	array at: firstIndex put: nil.
	firstIndex := firstIndex + 1.
	^ firstObject! !

!OrderedCollectionL1 methodsFor: 'removing' stamp: 'ewe 9/6/2011 17:32'!
removeFirst: n
	"Remove first n object into an array"

	| list |
	list := Array new: n.
	1 to: n do: [:i |
		list at: i put: self removeFirst].
	^ list! !

!OrderedCollectionL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:32'!
removeIndex: removedIndex
  "  removedIndex is an index in the range firstIndex .. lastIndex, such an index is not known from outside the collection.
    Never use this method in your code, it is meant for private use by OrderedCollection only.
     The method for public use is:
        #removeAt: "

	array 
		replaceFrom: removedIndex 
		to: lastIndex - 1 
		with: array 
		startingAt: removedIndex+1.
	array at: lastIndex put: nil.
	lastIndex := lastIndex - 1.! !

!OrderedCollectionL1 methodsFor: 'removing' stamp: 'ewe 9/6/2011 17:32'!
removeLast
	"Remove the last element of the receiver and answer it. If the receiver is 
	empty, create an error notification."
	| lastObject |
	self emptyCheck.
	lastObject := array at: lastIndex.
	array at: lastIndex put: nil.
	lastIndex := lastIndex - 1.
	^ lastObject! !

!OrderedCollectionL1 methodsFor: 'removing' stamp: 'ewe 9/6/2011 17:32'!
removeLast: n
	"Remove last n object into an array with last in last position"

	| list |
	list := Array new: n.
	n to: 1 by: -1 do: [:i |
		list at: i put: self removeLast].
	^ list! !

!OrderedCollectionL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:32'!
reset
	firstIndex := array size // 3 max: 1.
	lastIndex := firstIndex - 1! !

!OrderedCollectionL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:32'!
resetTo: index
	firstIndex := index.
	lastIndex := firstIndex - 1! !

!OrderedCollectionL1 methodsFor: 'enumerating' stamp: 'ewe 9/6/2011 17:32'!
reverseDo: aBlock 
	"Override the superclass for performance reasons."
	| index |
	index := lastIndex.
	[index >= firstIndex]
		whileTrue: 
			[aBlock value: (array at: index).
			index := index - 1]! !

!OrderedCollectionL1 methodsFor: 'copying' stamp: 'ewe 9/6/2011 17:32'!
reversed
	"Answer a copy of the receiver with element order reversed.  "
	| newCol |
	newCol := self species new.
	self reverseDo:
		[:elem | newCol addLast: elem].
	^ newCol

"#(2 3 4 'fred') reversed"! !

!OrderedCollectionL1 methodsFor: '*activecontext' stamp: 'ewe 11/1/2012 08:40'!
secure
	<ctxMeta>
	self secureSelf. 
	self isCtxGlobal ifTrue: [
		self prevMe ifNotNil: [ self prevMe secureSelf ].
		self nextMe ifNotNil: [ self nextMe secureSelf ].
	]! !

!OrderedCollectionL1 methodsFor: '*activecontext' stamp: 'ewe 11/1/2012 08:39'!
secureSelf
<ctxMeta>
	self primitiveChangeClassTo: OrderedCollectionS1 new.   
	__lock__ := Semaphore forMutualExclusion.
	"we must not use method that are not ctxMeta"
	1 to: array size do: 	[:index | ( array primAt: index ) secure ]! !

!OrderedCollectionL1 methodsFor: 'enumerating' stamp: 'ewe 9/6/2011 17:32'!
select: aBlock 
	"Evaluate aBlock with each of my elements as the argument. Collect into
	a new collection like the receiver, only those elements for which aBlock
	evaluates to true."

	| newCollection element |
	newCollection := self copyEmpty.
	firstIndex to: lastIndex do:
		[:index |
		(aBlock value: (element := array at: index))
			ifTrue: [newCollection addLast: element]].
	^ newCollection! !

!OrderedCollectionL1 methodsFor: 'enumerating' stamp: 'ewe 9/6/2011 17:32'!
select: selectBlock thenCollect: collectBlock
    " Utility method to improve readability.
	Do not create the intermediate collection. "

	| newCollection |

    newCollection := self copyEmpty.
    firstIndex to: lastIndex do:[:index |
		| element |
		element := array at: index.
		( selectBlock value: element ) 
			ifTrue:[ newCollection addLast: ( collectBlock value: element ) ]
    ].
    ^ newCollection! !

!OrderedCollectionL1 methodsFor: '*activecontext-test' stamp: 'ewe 11/1/2012 08:36'!
set: value
	self add: value ! !

!OrderedCollectionL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:32'!
setCollection: anArray
	array := anArray.
	self reset! !

!OrderedCollectionL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 17:32'!
setContents: anArray
	array := anArray.
	firstIndex := 1.
	lastIndex := array size.! !

!OrderedCollectionL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 17:32'!
size
	"Answer how many elements the receiver contains."

	^ lastIndex - firstIndex + 1! !

!OrderedCollectionL1 methodsFor: 'enumerating' stamp: 'ewe 9/6/2011 17:32'!
sort
	"Sort the receiver into ascending order using the '<=' operator."

	self sort: [:a :b | a <= b]! !

!OrderedCollectionL1 methodsFor: 'enumerating' stamp: 'ewe 9/6/2011 17:32'!
sort: aSortBlock 
	"Sort this array using aSortBlock. The block should take two arguments
	and return true if the first element should preceed the second one."

	self size <= 1 ifTrue: [^ self].  "nothing to do"
	array
		mergeSortFrom: firstIndex
		to: lastIndex 
		src: array shallowCopy 
		dst: array 
		by: aSortBlock! !

!OrderedCollectionL1 methodsFor: 'sorting' stamp: 'ewe 9/6/2011 17:32'!
sorted: aSortBlockOrNil
	"Return a new sequenceable collection which contains the same elements as self but its elements are sorted by aSortBlockOrNil. The block should take two arguments and return true if the first element should preceed the second one. If aSortBlock is nil then <= is used for comparison."
	
	^self copy sort: aSortBlockOrNil! !

!OrderedCollectionL1 methodsFor: 'enumerating' stamp: 'ewe 9/6/2011 17:32'!
with: otherCollection collect: twoArgBlock 
	"Collect and return the result of evaluating twoArgBlock with 
	corresponding elements from this collection and otherCollection."
	| result |
	otherCollection size = self size ifFalse: [self error: 'otherCollection must be the same size'].
	result := self species new: self size.
	1 to: self size do:
		[:index | result addLast: (twoArgBlock value: (self at: index)
									value: (otherCollection at: index))].
	^ result! !

!OrderedCollectionL1 methodsFor: 'enumerating' stamp: 'ewe 9/6/2011 17:32'!
withIndexCollect: elementAndIndexBlock 
	"Just like with:collect: except that the iteration index supplies the second argument to the block. Override superclass in order to use addLast:, not at:put:."

	| newCollection |
	newCollection := self species new: self size.
	firstIndex to: lastIndex do:
		[:index |
		newCollection addLast: (elementAndIndexBlock
			value: (array at: index)
			value: index - firstIndex + 1)].
	^ newCollection! !

OrderedCollectionL1 subclass: #OrderedCollectionS1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Kernel'!

!OrderedCollectionS1 class methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
isPrimitive ^ false! !

!OrderedCollectionS1 methodsFor: '*activecontext' stamp: 'ewe 11/27/2012 13:35'!
ctxWritearray: v2 __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: 3 . self markOtherAsDirty: 3 ]. ^ array := v2  ! !

!OrderedCollectionS1 methodsFor: 'as yet unclassified' stamp: 'ewe 11/27/2012 13:35'!
ctxWritefirstIndex: v2 __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: 4 . self markOtherAsDirty: 4 ]. ^ firstIndex := v2  ! !

!OrderedCollectionS1 methodsFor: 'as yet unclassified' stamp: 'ewe 11/27/2012 13:35'!
ctxWritelastIndex: v2 __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: 5 . self markOtherAsDirty: 5 ]. ^ lastIndex := v2  ! !

!OrderedCollectionS1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
isPrimitive ^ false! !

!OrderedCollectionS1 methodsFor: '*activecontext' stamp: 'ewe 11/1/2012 08:39'!
isThreadSafe 
	^true ! !

!OrderedCollectionS1 methodsFor: '*activecontext' stamp: 'ewe 11/1/2012 08:39'!
secureSelf
! !

!Boolean methodsFor: '*activecontext' stamp: 'ewe 9/27/2011 14:27'!
isPrimitive ^true! !

!AssociationL2 methodsFor: '*activecontext' stamp: 'ewe 11/27/2012 13:35'!
ctxWritekey: v2 __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: 3 . self markOtherAsDirty: 3 ]. ^ key := v2  ! !

!AssociationL2 methodsFor: '*activecontext' stamp: 'ewe 11/27/2012 13:35'!
ctxWritevalue: v2 __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: 5 . self markOtherAsDirty: 5 ]. ^ value := v2  ! !

!AssociationL2 methodsFor: '*activecontext' stamp: 'ewe 10/31/2012 06:16'!
isThreadSafe 
	^false ! !

!AssociationL2 methodsFor: '*activecontext' stamp: 'ewe 10/31/2012 06:19'!
secureSelf
<ctxMeta>
	self primitiveChangeClassTo: AssociationS2 new.  
	__lock__ := Semaphore forMutualExclusion.
	key secure.
	value secure. 
	! !

ArrayedCollection variableSubclass: #ArrayL1
	instanceVariableNames: '__ctxInfo__ __lock__ __ctxIdentity__'
	classVariableNames: ''
	poolDictionaries: 'TextConstants'
	category: 'ActiveContext-Kernel'!

!ArrayL1 class methodsFor: 'brace support' stamp: 'ewe 9/6/2011 16:43'!
braceStream: nElements
	"This method is used in compilation of brace constructs.
	It MUST NOT be deleted or altered."

	^ WriteStream basicNew braceArray: (self new: nElements)
! !

!ArrayL1 class methodsFor: 'brace support' stamp: 'ewe 9/6/2011 16:43'!
braceWith: a
	"This method is used in compilation of brace constructs.
	It MUST NOT be deleted or altered."

	| array |
	array := self new: 1.
	array at: 1 put: a.
	^ array! !

!ArrayL1 class methodsFor: 'brace support' stamp: 'ewe 9/6/2011 16:43'!
braceWith: a with: b 
	"This method is used in compilation of brace constructs.
	It MUST NOT be deleted or altered."

	| array |
	array := self new: 2.
	array at: 1 put: a.
	array at: 2 put: b.
	^ array! !

!ArrayL1 class methodsFor: 'brace support' stamp: 'ewe 9/6/2011 16:43'!
braceWith: a with: b with: c 
	"This method is used in compilation of brace constructs.
	It MUST NOT be deleted or altered."

	| array |
	array := self new: 3.
	array at: 1 put: a.
	array at: 2 put: b.
	array at: 3 put: c.
	^ array! !

!ArrayL1 class methodsFor: 'brace support' stamp: 'ewe 9/6/2011 16:43'!
braceWith: a with: b with: c with: d
	"This method is used in compilation of brace constructs.
	It MUST NOT be deleted or altered."

	| array |
	array := self new: 4.
	array at: 1 put: a.
	array at: 2 put: b.
	array at: 3 put: c.
	array at: 4 put: d.
	^ array! !

!ArrayL1 class methodsFor: 'brace support' stamp: 'ewe 9/6/2011 16:43'!
braceWithNone
	"This method is used in compilation of brace constructs.
	It MUST NOT be deleted or altered."

	^ self new: 0! !

!ArrayL1 class methodsFor: 'instance creation' stamp: 'ewe 9/6/2011 16:43'!
empty
	"A canonicalized empty Array instance."
	^ #()! !

!ArrayL1 class methodsFor: 'instance creation' stamp: 'ewe 10/12/2012 11:35'!
isPrimitive ^ false! !

!ArrayL1 class methodsFor: 'instance creation' stamp: 'ewe 9/6/2011 16:43'!
new: sizeRequested 
	"Answer an instance of this class with the number of indexable
	variables specified by the argument, sizeRequested.
	
	This is a shortcut (direct call of primitive, no #initialize, for performance"

	<primitive: 71>  "This method runs primitively if successful"
	^ self basicNew: sizeRequested  "Exceptional conditions will be handled in basicNew:"
! !

!ArrayL1 methodsFor: '*ActiveContext' stamp: 'ewe 10/11/2012 15:12'!
_postCopy 
	<ctxMeta>
	self contextInfo: ContextualInfo new.
	self contextInfo global: true.
	self contextInfo allDirtyBit: false.
	self contextInfo uuid: UUID new..! !

!ArrayL1 methodsFor: 'converting' stamp: 'ewe 9/6/2011 16:43'!
asArray
	"Answer with the receiver itself."

	^ self! !

!ArrayL1 methodsFor: '*ActiveContext' stamp: 'ewe 9/14/2011 14:55'!
asNativeArray
	<ctxMeta>
	| a|
	a := Array new: self size. 
	(1 to: self size) do: [ :i | a at: i put: (self at: i )].
	^ a.! !

!ArrayL1 methodsFor: '*ActiveContext' stamp: 'ewe 9/13/2011 08:47'!
asSet
	"Answer a Set whose elements are the unique elements of the receiver."

	^ Set withAll: self! !

!ArrayL1 methodsFor: '*ActiveContext' stamp: 'ewe 1/15/2012 15:41'!
at: i 
	<ctxMeta>
	self isCtxGlobal  ifTrue: [    
		self synchronizeIfNecessary: i.
		^ super at: i.  
	]
	ifFalse: [
		^ super at: i. 
	]  
	! !

!ArrayL1 methodsFor: '*ActiveContext' stamp: 'ewe 10/11/2012 15:55'!
at: i put: v
	<ctxMeta>
	self isCtxGlobal  ifTrue: [    
		self synchronizeIfNecessary: i.
		self markOtherAsDirty: i .
		^ super at: i put: v. 
	]
	ifFalse: [
		^ super at: i put: v. 
	]! !

!ArrayL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 16:43'!
atWrap: index 
	"Optimized to go through the primitive if possible"
	<primitive: 60>
	^ self at: index - 1 \\ self size + 1! !

!ArrayL1 methodsFor: 'accessing' stamp: 'ewe 9/6/2011 16:43'!
atWrap: index put: anObject
	"Optimized to go through the primitive if possible"
	<primitive: 61>
	^ self at: index - 1 \\ self size + 1 put: anObject! !

!ArrayL1 methodsFor: 'as yet unclassified' stamp: 'ewe 11/19/2012 15:03'!
contextIdentity ^__ctxIdentity__! !

!ArrayL1 methodsFor: 'as yet unclassified' stamp: 'ewe 11/19/2012 15:03'!
contextIdentity: id __ctxIdentity__ := id! !

!ArrayL1 methodsFor: '*ActiveContext' stamp: 'ewe 10/11/2012 14:08'!
contextInfo
	^ __ctxInfo__! !

!ArrayL1 methodsFor: '*ActiveContext' stamp: 'ewe 10/11/2012 14:06'!
contextInfo: value
	 __ctxInfo__ := value.! !

!ArrayL1 methodsFor: 'copying' stamp: 'ewe 9/6/2011 16:43'!
copyWithDependent: newElement
	self size = 0 ifTrue:[^DependentsArray with: newElement].
	^self copyWith: newElement! !

!ArrayL1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
ctxRead__ctxInfo__ self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 1 ]. ^  __ctxInfo__! !

!ArrayL1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
ctxRead__lock__ self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 2 ]. ^  __lock__! !

!ArrayL1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
ctxWrite__ctxInfo__: v2 self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 1 . self markOtherAsDirty: 1 ].  ^ __ctxInfo__ := v2 secure  ! !

!ArrayL1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
ctxWrite__lock__: v2 self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 2 . self markOtherAsDirty: 2 ].  ^ __lock__ := v2 secure  ! !

!ArrayL1 methodsFor: 'converting' stamp: 'ewe 9/6/2011 16:43'!
elementsExchangeIdentityWith: otherArray
	"This primitive performs a bulk mutation, causing all pointers to the elements of this array to be replaced by pointers to the corresponding elements of otherArray.  At the same time, all pointers to the elements of otherArray are replaced by pointers to the corresponding elements of this array.  The identityHashes remain with the pointers rather than with the objects so that objects in hashed structures should still be properly indexed after the mutation."

	<primitive: 128>
	otherArray class == Array ifFalse: [^ self error: 'arg must be array'].
	self size = otherArray size ifFalse: [^ self error: 'arrays must be same size'].
	(self anySatisfy: [:obj | obj class == SmallInteger]) ifTrue: [^ self error: 'can''t become SmallIntegers'].
	(otherArray anySatisfy: [:obj | obj class == SmallInteger]) ifTrue: [^ self error: 'can''t become SmallIntegers'].
	self with: otherArray do:[:a :b| a == b ifTrue:[^self error:'can''t become yourself']].

	"Must have failed because not enough space in forwarding table (see ObjectMemory-prepareForwardingTableForBecoming:with:twoWay:).  Do GC and try again only once"
	(Smalltalk bytesLeft: true) = Smalltalk primitiveGarbageCollect
		ifTrue: [^ self primitiveFailed].
	^ self elementsExchangeIdentityWith: otherArray! !

!ArrayL1 methodsFor: 'converting' stamp: 'ewe 9/6/2011 16:43'!
elementsForwardIdentityTo: otherArray
	"This primitive performs a bulk mutation, causing all pointers to the elements of this array to be replaced by pointers to the corresponding elements of otherArray.  The identityHashes remain with the pointers rather than with the objects so that the objects in this array should still be properly indexed in any existing hashed structures after the mutation."
	<primitive: 72>
	self primitiveFailed! !

!ArrayL1 methodsFor: 'converting' stamp: 'ewe 9/6/2011 16:43'!
elementsForwardIdentityTo: otherArray copyHash: copyHash
	"This primitive performs a bulk mutation, causing all pointers to the elements of this array to be replaced by pointers to the corresponding elements of otherArray.  The identityHashes remain with the pointers rather than with the objects so that the objects in this array should still be properly indexed in any existing hashed structures after the mutation."
	<primitive: 249>
	self primitiveFailed! !

!ArrayL1 methodsFor: '*ActiveContext' stamp: 'ewe 9/12/2011 19:08'!
gather: aBlock
	^ Array streamContents:
		[:stream |
		self do: [:ea | stream nextPutAll: (aBlock value: ea)]]! !

!ArrayL1 methodsFor: '*activecontext-test' stamp: 'ewe 11/1/2012 08:02'!
get
	^self at: 1! !

!ArrayL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 16:43'!
hasLiteral: literal
	"Answer true if literal is identical to any literal in this array, even 
	if imbedded in further array structure. This method is only intended 
	for private use by CompiledMethod hasLiteralSymbol:"

	1 to: self size do: [:index |  
		| lit |
		(lit := self at: index) == literal ifTrue: [^ true].
		(lit class == Array and: [lit hasLiteral: literal]) ifTrue: [^ true]].
	^ false! !

!ArrayL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 16:43'!
hasLiteralSuchThat: testBlock
	"Answer true if testBlock returns true for any literal in this array, even if imbedded in 	further Arrays or CompiledMethods.  This method is only intended for private use by 	CompiledMethod 	hasLiteralSuchThat:"
	| lit |
	1 to: self size do: [:index |
		(testBlock value: (lit := self at: index)) ifTrue: [^ true].
		(lit hasLiteralSuchThat: testBlock) ifTrue: [^ true]].
	^ false! !

!ArrayL1 methodsFor: 'as yet unclassified' stamp: 'ewe 11/19/2012 15:03'!
identityHash ^ self contextIdentityHash! !

!ArrayL1 methodsFor: '*ActiveContext' stamp: 'ewe 10/12/2012 17:47'!
initialize 
__lock__ := Semaphore forMutualExclusion! !

!ArrayL1 methodsFor: 'testing' stamp: 'ewe 9/6/2011 16:43'!
isArray
	^true! !

!ArrayL1 methodsFor: '*ActiveContext' stamp: 'ewe 10/11/2012 14:35'!
isCtxGlobal
	<ctxMeta>
	^ __ctxInfo__ isNil not. ! !

!ArrayL1 methodsFor: 'testing' stamp: 'ewe 9/6/2011 16:43'!
isLiteral
	^self class == Array and: [self allSatisfy: [:each | each isLiteral]]! !

!ArrayL1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
isPrimitive ^ false! !

!ArrayL1 methodsFor: 'self evaluating' stamp: 'ewe 9/6/2011 16:43'!
isSelfEvaluating
	^ (self allSatisfy: [:each | each isSelfEvaluating]) and: [self class == Array]! !

!ArrayL1 methodsFor: '*ActiveContext' stamp: 'ewe 10/29/2012 07:19'!
isThreadSafe 
	^false ! !

!ArrayL1 methodsFor: 'comparing' stamp: 'ewe 9/6/2011 16:43'!
literalEqual: other

	self class == other class ifFalse: [^ false].
	self size = other size ifFalse: [^ false].
	self with: other do: [:e1 :e2 |
		(e1 literalEqual: e2) ifFalse: [^ false]].
	^ true! !

!ArrayL1 methodsFor: '*ActiveContext' stamp: 'ewe 10/12/2012 17:47'!
lock
	^__lock__! !

!ArrayL1 methodsFor: '*ActiveContext' stamp: 'ewe 10/12/2012 17:47'!
lock: l 
	__lock__ := l! !

!ArrayL1 methodsFor: '*ActiveContext' stamp: 'ewe 10/11/2012 15:58'!
markOtherAsDirty: i
 	super markOtherAsDirty: 1.   ! !

!ArrayL1 methodsFor: '*ActiveContext' stamp: 'ewe 10/12/2012 17:47'!
migrateToNext
	<ctxMeta>
	| clone |
	clone := ( self class nextMe new: self size ) globalize: self uuid.
	clone lock: self lock. 
	clone allDirtyBit: true.
	self nextMe: clone.
	clone prevMe: self.! !

!ArrayL1 methodsFor: '*ActiveContext' stamp: 'ewe 11/6/2012 13:55'!
migrateToPrev
	<ctxMeta>
		self error: 'Array(L|S) 1 cannot be migrated to prev'! !

!ArrayL1 methodsFor: '*ActiveContext' stamp: 'ewe 11/12/2012 16:54'!
postCopy
	<ctxMeta>
	super postCopy. 
	__ctxInfo__ := nil .! !

!ArrayL1 methodsFor: '*ActiveContext' stamp: 'ewe 9/6/2011 16:43'!
primAt: i 
	<ctxMeta>
	^ super at: i.  
	! !

!ArrayL1 methodsFor: '*ActiveContext' stamp: 'ewe 9/6/2011 16:43'!
primAt: i put: v
	<ctxMeta>
	^ super at: i put: v! !

!ArrayL1 methodsFor: 'self evaluating' stamp: 'ewe 9/6/2011 16:43'!
printAsLiteralFormOn: aStream
	aStream nextPut: $#.
	self printElementsOn: aStream
! !

!ArrayL1 methodsFor: 'self evaluating' stamp: 'ewe 9/6/2011 16:43'!
printAsSelfEvaluatingFormOn: aStream

	aStream nextPut: ${.
	self do: [:el | el storeOn: aStream] separatedBy: [ aStream nextPutAll: '. '].
	aStream nextPut: $}! !

!ArrayL1 methodsFor: 'printing' stamp: 'ewe 9/12/2011 14:30'!
printOn: aStream
	self isLiteral ifTrue: [self printAsLiteralFormOn: aStream. ^ self].
	self isSelfEvaluating ifTrue: [self printAsSelfEvaluatingFormOn: aStream. ^ self].

	super printOn: aStream.
	( self isCtxGlobal and:  [ self contextInfo isNil not ] ) ifTrue: [
		self nextMe isNil ifTrue: [ aStream nextPutAll: 'OLD'  ]
					    ifFalse: [aStream nextPutAll: 'NEW'  ].
	]! !

!ArrayL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 16:43'!
refersToLiteral: literal 
	"Answer true if literal is identical to any literal in this array, even if imbedded in further array structures or closure methods"
	1 
		to: self size
		do: 
			[ :index | 
			| lit |
			(lit := self at: index) == literal ifTrue: [ ^ true ].
			(lit refersToLiteral: literal) ifTrue: [ ^ true ] ].
	^ false! !

!ArrayL1 methodsFor: 'private' stamp: 'ewe 9/6/2011 16:43'!
replaceFrom: start to: stop with: replacement startingAt: repStart 
	"Primitive. This destructively replaces elements from start to stop in the receiver starting at index, repStart, in the collection, replacement. Answer the receiver. Range checks are performed in the primitive only. Optional. See Object documentation whatIsAPrimitive."
	<primitive: 105>
	super replaceFrom: start to: stop with: replacement startingAt: repStart! !

!ArrayL1 methodsFor: '*ActiveContext' stamp: 'ewe 10/29/2012 08:47'!
secure
	<ctxMeta>
	self secureSelf. 
	self isCtxGlobal ifTrue: [
		self prevMe ifNotNil: [ self prevMe secureSelf ].
		self nextMe ifNotNil: [ self nextMe secureSelf ].
	]! !

!ArrayL1 methodsFor: '*ActiveContext' stamp: 'ewe 10/29/2012 08:47'!
secureSelf
<ctxMeta>
	self primitiveChangeClassTo: ArrayS1 new.  
	__lock__ := Semaphore forMutualExclusion.
	self do: [ :each | each secure ].
	! !

!ArrayL1 methodsFor: '*activecontext-test' stamp: 'ewe 11/1/2012 08:02'!
set: value
	^self at: 1 put: value ! !

!ArrayL1 methodsFor: 'converting' stamp: 'ewe 9/6/2011 16:43'!
sorted: aSortBlockOrNil
	"Return a new sequenceable collection which contains the same elements as self but its 
elements are sorted by aSortBlockOrNil. The block should take two arguments and return true if 
the first element should preceed the second one. If aSortBlock is nil then <= is used for 
comparison."
	
	^self copy sort: aSortBlockOrNil! !

!ArrayL1 methodsFor: '*ActiveContext' stamp: 'ewe 10/10/2012 12:03'!
species 
	<ctxMeta>
	^ ArrayL1   ! !

!ArrayL1 methodsFor: 'printing' stamp: 'ewe 9/6/2011 16:43'!
storeOn: aStream 
	"Use the literal form if possible."

	self isLiteral
		ifTrue: 
			[aStream nextPut: $#; nextPut: $(.
			self do: 
				[:element | 
				element storeOn: aStream.
				aStream space].
			aStream nextPut: $)]
		ifFalse: [super storeOn: aStream]! !

!ArrayL1 methodsFor: '*ActiveContext' stamp: 'ewe 12/4/2012 14:07'!
synchronizeAll
		"Transcript show: ('Synchronize ', self class, '@', self identityHash ); cr."
		self prevMe ifNotNil: [
			
			1 to: self size  do: [ :i |
				| p |
				p := self prevMe primAt: i.   
				( p isPrimitive not )  ifTrue: [
					"lazy migration after update"
					p migrateToNextIfNecessary .
					self primAt: i put: p nextMe. .
					"Transcript show: ( self uuid, '.' , field, ' := ', p next asString ); cr."
				] ifFalse: [
					self primAt: i put: p.  
					"Transcript show: ( self uuid, '.' , field, ' := ', p asString ); cr."
				]. 
			]   
		] 
		ifNil: [
			1 to: self size do: [ :i |
				| n |
				n := self nextMe primAt: i.   
				( n isPrimitive not )  ifTrue: [
					"lazy migration after update"
					n migrateToPrevIfNecessary .
					self primAt: i put: n prevMe.
					"Transcript show: ( self uuid, '.' , field, ' := ', n prev asString ); cr."
				] ifFalse: [
					self primAt: i put: n.  
					"Transcript show: ( self uuid, '.' , field, ' := ', n asString ); cr."
				]. 
			]   
		].! !

!ArrayL1 methodsFor: '*ActiveContext' stamp: 'ewe 10/11/2012 15:25'!
synchronizeIfNecessary: index
	<ctxMeta>
	"We use 1 and not i because the array in context info might not be long enoug"
	(self dirtyBit: 1) ifTrue: [
		self synchronizeAll. 
		self dirtyBit: 1 set: false.
	]! !

!ArrayL1 methodsFor: '*ActiveContext' stamp: 'ewe 11/22/2012 11:32'!
traverseAndDo: aBlock exclude: visited 
	<ctxMeta>
	
	( visited includes: self ) ifTrue: [ ^ self ].  
	visited add: self. 	
	aBlock value: self. 
	1 to: self size  do:  [ :i | ( self primAt: i  ) traverseAndDo: aBlock exclude:  visited  ].! !

ArrayL1 variableSubclass: #ArrayS1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'TextConstants'
	category: 'ActiveContext-Kernel'!

!ArrayS1 class methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
isPrimitive ^ false! !

!ArrayS1 methodsFor: 'as yet unclassified' stamp: 'ewe 11/27/2012 12:29'!
at: index
	"self contextIdentityLock critical: [ "
		^ super at: index 
	"]"! !

!ArrayS1 methodsFor: 'as yet unclassified' stamp: 'ewe 11/27/2012 13:35'!
at: index put: value 
	"self contextIdentityLock critical: [ "
		^ super at: index put: value "secure "
	"]."! !

!ArrayS1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
isPrimitive ^ false! !

!ArrayS1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/29/2012 07:19'!
isThreadSafe
	<ctxMeta>
	^true! !

!ArrayS1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/11/2012 16:01'!
secure 
	^self! !

!UUID methodsFor: '*activecontext' stamp: 'ewe 9/27/2011 14:31'!
isPrimitive ^true! !

!Process methodsFor: '*activecontext' stamp: 'ewe 11/5/2012 15:09'!
detectMethod: selector 
| o | 
o := self listContexts .
o detect: [ :x | x method selector = selector ] ifNone: [ ^false ].
^true. ! !

!Process methodsFor: '*activecontext' stamp: 'ewe 11/13/2012 14:46'!
environmentIncludesKey: aKey
	env ifNil: [ ^ false ].
	^env includesKey: aKey. ! !

!Process methodsFor: '*activecontext' stamp: 'ewe 11/5/2012 15:08'!
listContexts 
| o c | 
c := self suspendedContext .
c ifNil: [ ^ #() ].
o := OrderedCollection new.
[ c sender isNil ] whileFalse: [
	o add: c sender.
	c := c sender. 
].
^ o. ! !

!Process methodsFor: '*activecontext' stamp: 'ewe 9/7/2011 15:35'!
terminate 
	"Stop the process that the receiver represents forever.  Unwind to execute pending ensure:/ifCurtailed: blocks before terminating."

	| ctxt unwindBlock oldList |
	
	self environmentRemoveKey: #activeContext ifAbsent: [].    
		
	self isActiveProcess 
		ifTrue: [
			ctxt := thisContext.
			[ ctxt := ctxt findNextUnwindContextUpTo: nil.
			ctxt isNil ] whileFalse: 
				[ (ctxt tempAt: 2) ifNil:
					[ ctxt tempAt: 2 put: nil.
					unwindBlock := ctxt tempAt: 1.
					thisContext terminateTo: ctxt.
					unwindBlock value ]].
			thisContext terminateTo: nil.
			self suspend ]
		 ifFalse: [
			"Always suspend the process first so it doesn't accidentally get woken up"
			 oldList := self suspend.
			suspendedContext ifNotNil:[
				"Figure out if we are terminating the process while waiting in Semaphore>>critical:
				In this case, pop the suspendedContext so that we leave the ensure: block inside
				Semaphore>>critical: without signaling the semaphore."
				(oldList class == Semaphore and:[
					suspendedContext method == (Semaphore compiledMethodAt: #critical:)]) ifTrue:[
						suspendedContext := suspendedContext home.].
					
			  "If we are terminating a process halfways through an unwind, try to complete that unwind block first."
				(suspendedContext findNextUnwindContextUpTo: nil) ifNotNil: [ :outer |
				(suspendedContext findContextSuchThat: [ :c | c closure == (outer tempAt: 1)]) 
					ifNotNil: [ :inner |
						 "This is an unwind block currently under evaluation"
						suspendedContext runUntilErrorOrReturnFrom: inner ]].		
			ctxt := self popTo: suspendedContext bottomContext.
			ctxt == suspendedContext bottomContext ifFalse: [
				self debug: ctxt title: 'Unwind error during termination']] ].
! !

Notification subclass: #CurrentContextNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Core'!

!LookupKeyL2 methodsFor: '*activecontext' stamp: 'ewe 10/31/2012 06:31'!
contextInfo
	^ __ctxInfo__! !

!LookupKeyL2 methodsFor: '*activecontext' stamp: 'ewe 10/31/2012 06:31'!
contextInfo: value
	 __ctxInfo__ := value.! !

!LookupKeyL2 methodsFor: '*activecontext' stamp: 'ewe 10/31/2012 06:31'!
isCtxGlobal
	<ctxMeta>
	^ __ctxInfo__ isNil not. ! !

!LookupKeyL2 methodsFor: '*activecontext' stamp: 'ewe 10/31/2012 08:10'!
postCopy
	<ctxMeta>
	super postCopy. 
	__ctxInfo__ := nil .! !

!LookupKeyL2 methodsFor: '*activecontext' stamp: 'ewe 10/31/2012 08:58'!
secure
	<ctxMeta>
	self secureSelf. 
	self isCtxGlobal ifTrue: [
		self prevMe ifNotNil: [ self prevMe secureSelf ].
		self nextMe ifNotNil: [ self nextMe secureSelf ].
	]! !

RBLiteralArrayNode subclass: #CArrayLiteralNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Core'!

!Metaclass methodsFor: '*ActiveContext' stamp: 'ewe 9/27/2012 15:54'!
allClassSideInstanceVariablesNames 
	| current vars |
	"Even if first-class, classes are special and we don't want to contextual things beyond object"
	current := self .
	vars := #().
	[ current = Object class or: [ current = ProtoObject class ]] whileFalse: [
		vars := current classSideInstanceVariablesNames  , vars.
		current := current superclass. 
	].
	^ vars.! !

!Metaclass methodsFor: '*ActiveContext' stamp: 'ewe 9/27/2012 15:54'!
allClassVariablesNames 
	| current vars |
	"Even if first-class, classes are special and we don't want to contextual things beyond object"
	current := self .
	vars := #().
	[ current = Object class or: [ current = ProtoObject class ]] whileFalse: [
		vars := current classVariablesNames  , vars.
		current := current superclass. 
	].
	^ vars.! !

!Metaclass methodsFor: '*ActiveContext' stamp: 'ewe 10/12/2012 11:59'!
allContextualInstVarNames 
	| a |
	a := OrderedCollection new.
	a addAll:  self allClassVariablesNames.
	a addAll: self allClassSideInstanceVariablesNames.
	^ a  select: [ :f | f isContextReservedVar not ].! !

!Metaclass methodsFor: '*ActiveContext' stamp: 'ewe 11/6/2012 13:49'!
canonicalName 
	^ self trimLorS: ( self trimDigitRight: self name ), ' class'! !

!Metaclass methodsFor: '*ActiveContext' stamp: 'ewe 9/27/2012 15:56'!
classSideInstanceVariablesNames  
	^self instVarNames! !

!Metaclass methodsFor: '*ActiveContext' stamp: 'ewe 9/27/2012 15:55'!
classVariablesNames 
	^self classPool keys. ! !

!Metaclass methodsFor: '*ActiveContext' stamp: 'ewe 11/12/2012 16:46'!
compilerClass 

	(  CurrentContext contextualClasses includes: self  ) ifTrue: [
		Transcript show:( 'Contextual compiler for ',  self asString  ); cr.
		  ^OptimizedContextualCompiler 
	].
	(  CurrentContext normalizedClasses includes: self  ) ifTrue: [
		Transcript show:( 'Normalized compiler for ',  self asString  ); cr.
		  ^NormalizedCompiler.
	].
	((PackageInfo named: 'ExcludedWeb1') classes includes: self theNonMetaClass  ) ifTrue: [
		^ StaticResolutionCompiler. 	
	].
	^ super compilerClass .! !

!Metaclass methodsFor: '*ActiveContext' stamp: 'ewe 11/2/2012 15:35'!
contextualInstVarNames  
	| a |
	a := OrderedCollection new.
	a addAll:  self classVariablesNames.
	a addAll: self classSideInstanceVariablesNames.
	^ a select: [ :f | f isContextReservedVar not ].! !

!Metaclass methodsFor: '*ActiveContext' stamp: 'ewe 11/2/2012 17:25'!
indexOfContextualInstVar: aName
	( self allClassVariablesNames includes: aName ) ifTrue: [
		^ -1. 
	].
	^ self allInstVarNames indexOf: aName  .
! !

!Metaclass methodsFor: '*ActiveContext' stamp: 'ewe 9/27/2012 15:06'!
isContextualClassVar: varName
	^ self allContextualInstVarNames includes: varName  ! !

!Metaclass methodsFor: '*ActiveContext' stamp: 'ewe 9/27/2012 15:05'!
isContextualInstVar: varName
	^ self allContextualInstVarNames includes: varName ! !

!Metaclass methodsFor: '*ActiveContext' stamp: 'ewe 9/27/2011 13:34'!
isPrimitive ^true! !

!Metaclass methodsFor: '*ActiveContext' stamp: 'ewe 11/1/2012 09:20'!
nextMe
	^thisClass nextMe class ! !

!Metaclass methodsFor: '*ActiveContext' stamp: 'ewe 11/1/2012 09:20'!
prevMe 
	^thisClass prevMe class ! !

RBArrayNode subclass: #CArrayNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Core'!

!Stream methodsFor: '*activecontext' stamp: 'ewe 9/27/2011 14:31'!
isPrimitive ^true! !

!Array methodsFor: '*ActiveContext' stamp: 'ewe 9/14/2011 14:58'!
asNativeArray 
	^ self.! !

!Array methodsFor: '*ActiveContext' stamp: 'ewe 1/16/2012 08:58'!
fillWith: aValue
	(1 to: self size ) do: [ :i | self at: i put: aValue ].! !

!ArrayL2 methodsFor: '*ActiveContext' stamp: 'ewe 10/11/2012 15:12'!
_postCopy 
	<ctxMeta>
	self contextInfo: ContextualInfo new.
	self contextInfo global: true.
	self contextInfo allDirtyBit: false.
	self contextInfo uuid: UUID new..! !

!ArrayL2 methodsFor: '*ActiveContext' stamp: 'ewe 10/11/2012 14:38'!
asNativeArray
	<ctxMeta>
	| a|
	a := Array new: self size. 
	(1 to: self size) do: [ :i | a at: i put: (self at: i )].
	^ a.! !

!ArrayL2 methodsFor: '*ActiveContext' stamp: 'ewe 10/11/2012 14:38'!
asSet
	"Answer a Set whose elements are the unique elements of the receiver."

	^ Set withAll: self! !

!ArrayL2 methodsFor: '*ActiveContext' stamp: 'ewe 10/11/2012 14:38'!
at: i 
	<ctxMeta>
	self isCtxGlobal  ifTrue: [    
		self synchronizeIfNecessary: i.
		^ super at: i.  
	]
	ifFalse: [
		^ super at: i. 
	]  
	! !

!ArrayL2 methodsFor: '*ActiveContext' stamp: 'ewe 10/11/2012 15:55'!
at: i put: v
	<ctxMeta>
	self isCtxGlobal  ifTrue: [    
		self synchronizeIfNecessary: i.
		self markOtherAsDirty: i .
		^ super at: i put: v. 
	]
	ifFalse: [
		^ super at: i put: v. 
	]! !

!ArrayL2 methodsFor: '*ActiveContext' stamp: 'ewe 10/11/2012 14:38'!
contextInfo
	^ __ctxInfo__! !

!ArrayL2 methodsFor: '*ActiveContext' stamp: 'ewe 10/11/2012 14:38'!
contextInfo: value
	 __ctxInfo__ := value.! !

!ArrayL2 methodsFor: '*ActiveContext' stamp: 'ewe 10/11/2012 14:38'!
gather: aBlock
	^ Array streamContents:
		[:stream |
		self do: [:ea | stream nextPutAll: (aBlock value: ea)]]! !

!ArrayL2 methodsFor: '*activecontext-test' stamp: 'ewe 11/1/2012 08:00'!
get
	^self at: 1! !

!ArrayL2 methodsFor: '*ActiveContext' stamp: 'ewe 10/11/2012 14:38'!
isCtxGlobal
	<ctxMeta>
	^ __ctxInfo__ isNil not. ! !

!ArrayL2 methodsFor: '*ActiveContext' stamp: 'ewe 10/29/2012 07:19'!
isThreadSafe 
	^false ! !

!ArrayL2 methodsFor: '*ActiveContext' stamp: 'ewe 10/12/2012 17:48'!
lock
	^__lock__! !

!ArrayL2 methodsFor: '*ActiveContext' stamp: 'ewe 10/12/2012 17:48'!
lock: l
	__lock__ := l! !

!ArrayL2 methodsFor: '*ActiveContext' stamp: 'ewe 10/11/2012 15:58'!
markOtherAsDirty: i
 	super markOtherAsDirty: 1.   ! !

!ArrayL2 methodsFor: '*ActiveContext' stamp: 'ewe 11/6/2012 13:54'!
migrateToNext
	<ctxMeta>
	self error: 'Array(L|S) 2 cannot be migrated to next'! !

!ArrayL2 methodsFor: '*ActiveContext' stamp: 'ewe 11/6/2012 13:57'!
migrateToPrev
	<ctxMeta>
	| clone |
	clone :=  (self class prevMe new: self size) globalize: self uuid.
	clone lock: self lock. 
	clone allDirtyBit: true.
	self prevMe: clone.
	clone nextMe: self.! !

!ArrayL2 methodsFor: '*ActiveContext' stamp: 'ewe 11/12/2012 16:54'!
postCopy
	<ctxMeta>
	super postCopy. 
	__ctxInfo__ := nil .! !

!ArrayL2 methodsFor: '*ActiveContext' stamp: 'ewe 10/11/2012 14:38'!
primAt: i 
	<ctxMeta>
	^ super at: i.  
	! !

!ArrayL2 methodsFor: '*ActiveContext' stamp: 'ewe 10/11/2012 14:38'!
primAt: i put: v
	<ctxMeta>
	^ super at: i put: v! !

!ArrayL2 methodsFor: '*ActiveContext' stamp: 'ewe 10/29/2012 08:48'!
secure
	<ctxMeta>
	self secureSelf. 
	self isCtxGlobal ifTrue: [
		self prevMe ifNotNil: [ self prevMe secureSelf ].
		self nextMe ifNotNil: [ self nextMe secureSelf ].
	]! !

!ArrayL2 methodsFor: '*ActiveContext' stamp: 'ewe 10/31/2012 05:52'!
secureSelf
<ctxMeta>
	self primitiveChangeClassTo: ArrayS2 new.  
	__lock__ := Semaphore forMutualExclusion.
	self do: [ :each | each secure ].
	! !

!ArrayL2 methodsFor: '*activecontext-test' stamp: 'ewe 11/1/2012 08:00'!
set: value
	^self at: 1 put: value ! !

!ArrayL2 methodsFor: '*ActiveContext' stamp: 'ewe 10/11/2012 14:38'!
species 
	<ctxMeta>
	^ ArrayL1   ! !

!ArrayL2 methodsFor: '*ActiveContext' stamp: 'ewe 12/4/2012 14:07'!
synchronizeAll
		"Transcript show: ('Synchronize ', self class, '@', self identityHash ); cr."
		self prevMe ifNotNil: [
			
			1 to: self size  do: [ :i |
				| p |
				p := self prevMe primAt: i.   
				( p isPrimitive not )  ifTrue: [
					"lazy migration after update"
					p migrateToNextIfNecessary .
					self primAt: i put: p nextMe. .
					"Transcript show: ( self uuid, '.' , field, ' := ', p next asString ); cr."
				] ifFalse: [
					self primAt: i put: p.  
					"Transcript show: ( self uuid, '.' , field, ' := ', p asString ); cr."
				]. 
			]   
		] 
		ifNil: [
			1 to: self size do: [ :i |
				| n |
				n := self nextMe primAt: i.   
				( n isPrimitive not )  ifTrue: [
					"lazy migration after update"
					n migrateToPrevIfNecessary .
					self primAt: i put: n prevMe.
					"Transcript show: ( self uuid, '.' , field, ' := ', n prev asString ); cr."
				] ifFalse: [
					self primAt: i put: n.  
					"Transcript show: ( self uuid, '.' , field, ' := ', n asString ); cr."
				]. 
			]   
		].! !

!ArrayL2 methodsFor: '*ActiveContext' stamp: 'ewe 10/11/2012 15:26'!
synchronizeIfNecessary: index
	<ctxMeta>
	"We use 1 and not i because the array in context info might not be long enoug"
	(self dirtyBit: 1) ifTrue: [
		self synchronizeAll. 
		self dirtyBit: 1 set: false.
	]! !

!ArrayL2 methodsFor: '*ActiveContext' stamp: 'ewe 11/22/2012 11:32'!
traverseAndDo: aBlock exclude: visited 
	<ctxMeta>
	
	( visited includes: self ) ifTrue: [ ^ self ].  
	visited add: self. 	
	aBlock value: self. 
	1 to: self size  do:  [ :i | ( self primAt: i  ) traverseAndDo: aBlock exclude:  visited  ].! !

RBProgramNodeVisitor subclass: #BaseProgramNodeVisitor
	instanceVariableNames: 'compiledClass skipClassResolution'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Core'!

!BaseProgramNodeVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 9/27/2012 15:07'!
acceptAssignmentNode: anAssignmentNode

	| name |
	name := anAssignmentNode variable name.
	
	( name = '__ctxInfo__' ) ifTrue: [
		^ super acceptAssignmentNode: anAssignmentNode .
	].
	
	(compiledClass isContextualInstVar: name ) ifTrue: 	 
	[
		"Transcript show: ('Replace write ', anAssignmentNode  variable  name); cr."
		self replaceInstVarWrite: anAssignmentNode .
	]
	ifFalse: 
	[
		(compiledClass class isContextualClassVar: name  ) ifTrue: [
			"Transcript show: ('Replace class var resolution ',   name); cr. "
			self replaceClassVarWrite: anAssignmentNode . 
		] ifFalse: [		
			"Transcript show: ('Don''t replace write ', anAssignmentNode  variable  name); cr."
			super acceptAssignmentNode: anAssignmentNode .
		]
	]! !

!BaseProgramNodeVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 9/26/2012 14:50'!
acceptMethodNode: methodNode 
	(  (methodNode name beginsWith: 'ctxRead'  ) or: 
	   [ (methodNode name beginsWith: 'ctxWrite' ) or: 
	    [ (methodNode pragmas select: [ :p | p selector = #ctxMeta ] ) size = 1]]  ) ifTrue: [		
		^ RBProgramNodeVisitor new visitNode: methodNode.
	] ifFalse: [
		^ super acceptMethodNode: methodNode 
	  ].  ! !

!BaseProgramNodeVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 9/27/2012 15:10'!
acceptVariableNode: aVariableNode

| name |

	name := aVariableNode name.

	({ '__ctxInfo__' . 'self' . 'super' . 'CurrentContext' } includes: name ) ifTrue: [
		^ super acceptVariableNode: aVariableNode . 
	].

	"Transcript show: ('Var read ',   name); cr."
	(compiledClass isContextualInstVar:  name )
	ifTrue: 	 
	[	
		"Transcript show: ('Replace read ',   name); cr."
		self replaceInstVarRead: aVariableNode .
	]
	ifFalse: 
	[
	  	(compiledClass class isContextualClassVar: name  ) ifTrue: [
			"Transcript show: ('Replace class var resolution ',   name); cr. "
			self replaceClassVarRead: aVariableNode . 
		] ifFalse: [
			(( name first isUppercase ) and: [skipClassResolution not]  ) ifTrue: [ 
				"Transcript show: ('Replace class resolution ',   name); cr. "
				self replaceClassResolution: aVariableNode . 
			]
			ifFalse: [
				"Transcript show: ('Don''t replace read ',   name); cr."
				super acceptVariableNode: aVariableNode . 
			].
		]
	]! !

!BaseProgramNodeVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 11/6/2012 11:23'!
compiledClass
	^compiledClass ! !

!BaseProgramNodeVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 8/31/2011 14:48'!
compiledClass: class
	compiledClass := class.! !

!BaseProgramNodeVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 8/31/2011 14:48'!
initialize 
	skipClassResolution := false.! !

!BaseProgramNodeVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 8/31/2011 14:51'!
replaceClassResolution: aVariableNode

		^ super acceptVariableNode: aVariableNode .  ! !

!BaseProgramNodeVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 8/31/2011 14:51'!
replaceClassVarRead: aVariableNode

		^ super acceptVariableNode: aVariableNode .  ! !

!BaseProgramNodeVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 8/31/2011 14:52'!
replaceClassVarWrite: anAssignmentNode

	^ super acceptAssignmentNode: anAssignmentNode .  ! !

!BaseProgramNodeVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 10/31/2012 06:41'!
replaceInstVarRead: aVariableNode

	^ super acceptVariableNode: aVariableNode .  ! !

!BaseProgramNodeVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 8/31/2011 14:52'!
replaceInstVarWrite: anAssignmentNode

	^ super acceptAssignmentNode: anAssignmentNode .  ! !

!BaseProgramNodeVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 8/31/2011 14:49'!
skipClassResolution
	skipClassResolution := true.! !

!BaseProgramNodeVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 10/31/2012 06:40'!
visitNode: aNode 

	^super visitNode: aNode. ! !

BaseProgramNodeVisitor subclass: #ContextualProgramNodeVisitor
	uses: TClassResolution + TRegularAccessors
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Core'!

ContextualProgramNodeVisitor class
	uses: TClassResolution classTrait + TRegularAccessors classTrait
	instanceVariableNames: ''!

ContextualProgramNodeVisitor subclass: #OptimizedContextualProgramNodeVisitor
	uses: TStaticClassResolution + TOptimizedAccessors
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Core'!

OptimizedContextualProgramNodeVisitor class
	uses: TOptimizedAccessors classTrait + TStaticClassResolution classTrait
	instanceVariableNames: ''!

!OptimizedContextualProgramNodeVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 11/6/2012 15:07'!
acceptArrayNode: anArrayNode  
	| m |
	
	(anArrayNode class == CArrayNode ) ifTrue: [
		^ super acceptArrayNode: anArrayNode.  
	].

	m := RBMessageNode 
		receiver: ( RBVariableNode named: 'Array' )
		selector: #newFrom:
		arguments: { CArrayNode statements: anArrayNode statements }.
		 
	anArrayNode replaceWith: m.
	super visitNode: m.     
	  ! !

!OptimizedContextualProgramNodeVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 11/12/2012 16:15'!
acceptLiteralArrayNode: aLiteralArrayNode
	| m s |
	
	(aLiteralArrayNode class == CArrayLiteralNode ) ifTrue: [
		^ super acceptLiteralArrayNode: aLiteralArrayNode.  
	].

	m := self turnArrayIntoStatement: aLiteralArrayNode value. 
		 
	aLiteralArrayNode replaceWith: m.
	super visitNode: m.     ! !

!OptimizedContextualProgramNodeVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 12/4/2012 14:50'!
acceptMessageNode: aMessageNode  
	
| map |

map := Dictionary new. 
map at: #-> put: #--> .
map at: #name put:  #canonicalName.

( (map keys includes: aMessageNode selector ) and: [ aMessageNode isSuperSend not ] ) ifTrue: [
	| m |
	
	m := RBMessageNode 
		receiver: aMessageNode receiver
		selector: (map at: aMessageNode selector)
		arguments: aMessageNode arguments.
	aMessageNode replaceWith: m.
	super visitNode: m.     
				
] ifFalse: [
	self flag: 'Move this logic in subclass'.
	(aMessageNode selector = #track or: 
	[ aMessageNode receiver isMessage and: [ aMessageNode receiver selector = #track ] ] ) ifFalse: [
		| track m |
		
		track:= RBMessageNode 
			receiver: aMessageNode receiver
			selector: #track
			arguments: #().
	
		m := RBMessageNode 
			receiver: track 
			selector: aMessageNode selector
			arguments: aMessageNode arguments.
	
		aMessageNode replaceWith: m .
		^ super visitNode: m.        
	] ifTrue: [
		^super acceptMessageNode: aMessageNode   
	]
]   ! !

!OptimizedContextualProgramNodeVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 11/27/2012 12:17'!
replaceClassResolution: aVariableNode

| newName oldName newCls currentNonMetaClassName | 

"Transcript show: aVariableNode name; cr. "

oldName := aVariableNode name. 
currentNonMetaClassName := self compiledClass theNonMetaClass name. 

(currentNonMetaClassName endsWith: '1') ifTrue: [

	(oldName = 'Array') ifTrue: [ newName := 'ArrayS1' ].
	(oldName = 'HashedCollection') ifTrue: [ newName := 'HashedCollectionS1' ]. 
	(oldName = 'Dictionary') ifTrue: [ newName := 'DictionaryS1' ].
	(oldName = 'IdentityDictionary') ifTrue: [ newName := 'IdentityDictionaryS1' ].
	(oldName = 'Set') ifTrue: [ newName := 'SetS1' ].
	(oldName = 'LookupKey') ifTrue: [ newName := 'LookupKeyS1' ].
	(oldName = 'Association') ifTrue: [ newName := 'AssociationS1' ].
	(oldName = 'OrderedCollection') ifTrue: [ newName := 'OrderedCollectionS1' ].

	newName isNil ifTrue: [
		((CurrentContext contextualClasses collect: [:cls | cls canonicalName ]) includes: oldName ) ifTrue: [
			newName:= (oldName , '1').
		] ifFalse: [ 
			newName:= (oldName , '1').
			Smalltalk at: newName asSymbol ifAbsent: [ 
				Transcript show: ('Is this really a primitive class? ', oldName). 
				newName := oldName. 
			]. 
		]
	]
] ifFalse: [
	(oldName = 'Array') ifTrue: [ newName := 'ArrayS2' ].
	(oldName = 'HashedCollection') ifTrue: [ newName := 'HashedCollectionS2' ]. 
	(oldName = 'Dictionary') ifTrue: [ newName := 'DictionaryS2' ]. 
	(oldName = 'IdentityDictionary') ifTrue: [ newName := 'IdentityDictionaryS2' ].
	(oldName = 'Set') ifTrue: [ newName := 'SetS2' ].
	(oldName = 'LookupKey') ifTrue: [ newName := 'LookupKeyS2' ].
	(oldName = 'Association') ifTrue: [ newName := 'AssociationS2' ]. 
	(oldName = 'OrderedCollection') ifTrue: [ newName := 'OrderedCollectionS2' ].

	newName isNil ifTrue: [ 
		((CurrentContext contextualClasses collect: [:cls | cls canonicalName ]) includes: oldName ) ifTrue: [
			newName:= (oldName , '2').
		] ifFalse: [
			newName:= (oldName , '1'). "Excluded class have only one version"
			Smalltalk at: newName asSymbol ifAbsent: [ 
				Transcript show: ('Is this really a primitive class? ', oldName). 
				newName := oldName. 
			]. 
		]
	]
].

newCls := Smalltalk at: newName asSymbol ifAbsent: [ Transcript show: 'Class Resolution Failed for: ' ; show: newName ; cr. nil ].
aVariableNode token value: newName. 
! !

!OptimizedContextualProgramNodeVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 11/13/2012 09:43'!
turnArrayIntoArray: anArray
	| m s |
	
	s := RBSequenceNode new. 
	anArray do: [ :each | 
		each isArray ifTrue: [
			s addNode: (self turnArrayIntoStatement: each )
		] ifFalse: [
			s addNode: (RBLiteralNode value: each) 
		]	
	 ].
	
	m := RBMessageNode 
		receiver: ( RBVariableNode named: 'Array' )
		selector: #newFrom:
		arguments: { CArrayNode statements: s }.
		
	^m! !

!OptimizedContextualProgramNodeVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 11/13/2012 09:44'!
turnArrayIntoLiteral: anArray
	| m  |
	
	m := RBMessageNode 
		receiver: ( RBVariableNode named: 'Array' )
		selector: #newFrom:
		arguments: { CArrayLiteralNode value: anArray }.
		
	^m! !

!OptimizedContextualProgramNodeVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 11/13/2012 11:25'!
turnArrayIntoStatement: anArray
		
	((anArray select: [ :v | v isArray ]) size > 0 ) ifTrue: [
		^ self turnArrayIntoArray: anArray. 
	] ifFalse: [
		^ self turnArrayIntoLiteral: anArray. 
	]
! !

BaseProgramNodeVisitor subclass: #NormalizedProgramNodeVisitor
	uses: TOptimizedAccessors
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Core'!

NormalizedProgramNodeVisitor class
	uses: TOptimizedAccessors classTrait
	instanceVariableNames: ''!

BaseProgramNodeVisitor subclass: #StaticResolutionVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Core'!

!StaticResolutionVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 11/12/2012 13:50'!
replaceClassResolution: aVariableNode

| newName oldName newCls currentNonMetaClassName | 

"Transcript show: aVariableNode name; cr. "

oldName := aVariableNode name. 
currentNonMetaClassName := self compiledClass theNonMetaClass name. 

(currentNonMetaClassName endsWith: '1') ifTrue: [
	newCls := Smalltalk at: oldName asSymbol ifAbsent: [ Smalltalk at: (oldName ,'1') asSymbol ifAbsent: [nil] ].
] ifFalse: [
	newCls := Smalltalk at: oldName asSymbol ifAbsent: [ Smalltalk at: (oldName ,'2') asSymbol ifAbsent: [nil]  ].
].
aVariableNode token value: newCls name. 
! !

!ProtoObject class methodsFor: '*ActiveContext' stamp: 'ewe 10/12/2012 11:58'!
allContextualInstVarNames
	^ self allInstVarNames select: [ :f | f isContextReservedVar not ].
! !

!ProtoObject class methodsFor: '*ActiveContext' stamp: 'ewe 11/2/2012 15:36'!
contextualInstVarNames
	^ self instVarNames select: [ :f | f isContextReservedVar not ].
! !

!ProtoObject class methodsFor: '*ActiveContext' stamp: 'ewe 11/2/2012 17:25'!
indexOfContextualInstVar: aName
	^ self allInstVarNames indexOf: aName  .
! !

!ProtoObject class methodsFor: '*ActiveContext' stamp: 'ewe 9/27/2012 15:06'!
isContextualClassVar: varName
	^ self allContextualInstVarNames includes: varName  ! !

!ProtoObject class methodsFor: '*ActiveContext' stamp: 'ewe 9/27/2012 15:05'!
isContextualInstVar: varName
	^ self allContextualInstVarNames includes: varName ! !

!ProtoObject methodsFor: '*activecontext' stamp: 'ewe 11/19/2012 16:48'!
identityHash
	^ self primIdentityHash ! !

!ProtoObject methodsFor: '*activecontext' stamp: 'ewe 8/8/2011 10:15'!
pointersFrom
	^ self pointersFromExclude: OrderedCollection new.  ! !

!ProtoObject methodsFor: '*activecontext' stamp: 'ewe 8/8/2011 10:39'!
pointersFromExclude: visited
	| sub bypassClasses |
	bypassClasses := { SmallInteger . MethodDictionary }.
	sub := OrderedCollection new.
	visited add: self. 

	( self isClass ) ifTrue: [
		| v |
		v:= self classPool.
		Transcript show: 'Add ',  v ; cr.  sub add: v ; addAll:  ( v pointersFromExclude: visited).
		^ sub. 
	]
.
	1 to: self class instSize do:
		[ :i | | v | v := self instVarAt: i.
		 ((  visited includes: v ) or: [ bypassClasses includes: v class ]) ifFalse: [ Transcript show: 'Add ',  v ; cr.  sub add: v ; addAll:  ( v pointersFromExclude: visited) ] ].
	1 to: self basicSize do:
		[ :i | | v | v := self basicAt: i.
		( (  visited includes: v ) or: [ bypassClasses includes: v class]) ifFalse: [ Transcript show: 'Add ',  v ; cr.  sub  add: v ; addAll:   ( v pointersFromExclude: visited) ]  ].
	^ sub. ! !

!ProtoObject methodsFor: '*activecontext' stamp: 'ewe 11/19/2012 16:47'!
primIdentityHash
	"Answer a SmallInteger whose value is related to the receiver's identity.
	This method must not be overridden, except by SmallInteger.
	
	Do not override."

	^ self basicIdentityHash bitShift: 18! !

TestCase subclass: #BasicTest
	instanceVariableNames: 'ctx1 ctx2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Tests'!

!BasicTest methodsFor: 'as yet unclassified' stamp: 'ewe 11/22/2012 14:13'!
setUp
	ctx1 := TestContext new.
	ctx2 := TestContext ancestor: ctx1.  
	CurrentContext prevMe: ctx1.
	CurrentContext nextMe: ctx2.
	CurrentContext instance: nil.   ! !

!BasicTest methodsFor: 'as yet unclassified' stamp: 'ewe 11/2/2012 16:08'!
tearDown
	
	"Release contet and garbage collect array, dictionary, etc."
	ctx1 release.
	ctx1 := nil.
	ctx2 := nil.
	CurrentContext prevMe: nil.
	CurrentContext nextMe: nil.
	! !

!BasicTest methodsFor: 'as yet unclassified' stamp: 'ewe 11/19/2012 15:45'!
testA1A2AreClean

	| a1 a2 |
	
	a2 := Example2 new. 
	self assert: a2 isCtxGlobal not. 
	a2 migrateToPrevIfNecessary. 
	a1 := a2 prevMe. 	
	
	self assert: ( a1 dirtyBit: 3 ) = true. 
	self assert: ( a2 dirtyBit: 3 ) = false. 
	 
	a1 f: 'hello'.
	
	self assert: ( a1 dirtyBit: 3 ) = false. 
	self assert: ( a2 dirtyBit: 3 ) = true. 
	
	a2 f. 
	
	self assert: ( a1 dirtyBit: 3 ) = false. 
	self assert: ( a2 dirtyBit: 3 ) = false. 
	
	a2 f: 'hello'. 
	
	self assert: ( a1 dirtyBit: 3 ) = true. 
	self assert: ( a2 dirtyBit: 3 ) = false. ! !

!BasicTest methodsFor: 'as yet unclassified' stamp: 'ewe 11/19/2012 15:45'!
testConcurrentCounterFake

	| a1 a2 b1 b2 |
	
	a2 := Counter2 new. 
	self assert: a2 isCtxGlobal not. 
	a2 migrateToPrevIfNecessary. 
	a1 := a2 prevMe. 	
	
	self assert: ( a1 dirtyBit: 3 ) = true. 
	self assert: ( a2 dirtyBit: 3 ) = false. 	
	
	a1 increment.
	a1 increment.
	
	self assert: (a1 value = 2  ).
	self assert: (a2 value = 2 ).

	a2 increment .
	a2 increment .
	
	self assert: (a1 value = 4  ).
	self assert: (a2 value = 4 ).
	
	a1 increment .
	a2 increment .
	
	self assert: (a1 value = 6  ).
	self assert: (a2 value = 6 ).! !

!BasicTest methodsFor: 'as yet unclassified' stamp: 'ewe 11/6/2012 12:16'!
testXDirtyObjectsAreA1B2

	| a1 a2 b1 b2 |
	
	a2 := Example2 new. 
	self assert: a2 isCtxGlobal not. 
	a2 migrateToPrevIfNecessary. 
	a1 := a2 prevMe. 
	
	b1 := Example1 new. 
	self assert: b1 isCtxGlobal not. 
	b1 migrateToNextIfNecessary. 
	b2 := b1 nextMe. 
	
	a2 instVarNamed: 'f' put: b2.
	b1 instVarNamed: 'f' put:   'hello'.
	
	self assert: ( a1 f = b1 ).
	self assert: ( a1 f f = 'hello').! !

!BasicTest methodsFor: 'as yet unclassified' stamp: 'ewe 11/6/2012 12:17'!
testXDirtyObjectsAreA2B1

	| a1 a2 b1 b2 |
	
	a1 := Example1 new. 
	self assert: a1 isCtxGlobal not. 
	a1 migrateToNextIfNecessary. 
	a2 := a1 nextMe. 
	
	b2 := Example2 new. 
	self assert: b2 isCtxGlobal not. 
	b2 migrateToPrevIfNecessary. 
	b1 := b2 prevMe. 
	
	
	a1 instVarNamed: 'f' put: b1.
	b2 instVarNamed: 'f' put: 'hello'.
	
	self assert: ( a2 f = b2 ).
	self assert: ( a2 f f = 'hello').! !

!BasicTest methodsFor: 'as yet unclassified' stamp: 'ewe 5/19/2011 14:48'!
testXInheritance
	self flag: 'todo'.! !

!BasicTest methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 17:10'!
testXLazyMigrationOldToNew

	| a1 a2 b1 |
	
	a1 := Example1 new. 
	self assert: a1 isCtxGlobal not. 
	a1 migrateToNextIfNecessary. 
	a2 := a1 nextMe. 
	
	b1 := Example1 new.
	
	a1 instVarNamed: 'f'  put:  b1.
	b1 instVarNamed: 'f' put: 'hello'.
	
	self assert: ( a2 f isNil not ).
	self assert: ( a2 f f = 'hello' ). ! !

!BasicTest methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 17:10'!
testXLazyMigrationOldToNewWithMany

	| a1 a2 b1 c1 d1 |
	
	a1 := Example1 new. 
	self assert: a1 isCtxGlobal not. 
	a1 migrateToNextIfNecessary. 
	a2 := a1 nextMe. 
	
	b1 := Example1 new.		
	a1 instVarNamed: 'f' put:   b1.
	
	c1 := Example1 new.	
	b1 instVarNamed: 'f' put:   c1.
	
	d1 := Example1 new.	

	c1 instVarNamed: 'f' put:   d1.
	d1 instVarNamed: 'f' put:   'hello'.
	
	self assert: ( a1 nextMe isNil not ).
	self assert: ( b1 isCtxGlobal not ).
	self assert: ( c1 isCtxGlobal not ).
	self assert: ( d1 isCtxGlobal not ).
			
	self assert: ( a2 f isNil not ).  "triggers lazy mig"
	
	self assert: ( a1 nextMe isNil not ).
	self assert: ( b1 nextMe isNil not ).
	self assert: ( c1  isCtxGlobal not ).
	self assert: ( d1  isCtxGlobal not ).
	
	self assert: ( a2 f f isNil not ).  "triggers lazy mig"
	
	self assert: ( a1 nextMe isNil not ).
	self assert: ( b1 nextMe isNil not ).
	self assert: ( c1 nextMe isNil not ).
	self assert: ( d1  isCtxGlobal not ).
	
	self assert: ( a2 f f f isNil not ).  "triggers lazy mig"
	
	self assert: ( a1 nextMe isNil not ).
	self assert: ( b1 nextMe isNil not ).
	self assert: ( c1 nextMe isNil not ).
	self assert: ( d1 nextMe isNil not ).
	
	self assert: ( a2 f f f f = 'hello' ). ! !

!BasicTest methodsFor: 'as yet unclassified' stamp: 'ewe 11/6/2012 12:17'!
testXLocalBecomeGlobalNew

	| a1 a2 b1 b2 |
	
	a1 := Example1 new. 
	self assert: a1 isCtxGlobal not. 
	a1 migrateToNextIfNecessary. 
	a2 := a1 nextMe. 
	
	b2 := Example2 new.
	
	b2 f: 'hello'.
	self assert: ( b2 isCtxGlobal not).

	a2 f: b2.
	self assert: (b2 isCtxGlobal not ).  
	b1:= a1 f.
	self assert: (b2 isCtxGlobal  ).  
	self assert: (b1 isCtxGlobal  ).  
	self assert: ( b1 f = 'hello' ). ! !

!BasicTest methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 17:10'!
testXLocalBecomeGlobalOld

	| a1 a2 b1 b2 |
	
	a1 := Example1 new. 
	self assert: a1 isCtxGlobal not. 
	a1 migrateToNextIfNecessary. 
	a2 := a1 nextMe. 
	
	b1 := Example1 new.
	
	b1 f: 'hello'.
	self assert: ( b1 isCtxGlobal not).

	a1 f: b1.
	self assert: (b1 isCtxGlobal not ).  
	b2:= a2 f. 
	self assert: (b2 isCtxGlobal ).  
	self assert: ( b2 f = 'hello' ). ! !

!BasicTest methodsFor: 'as yet unclassified' stamp: 'ewe 11/6/2012 12:18'!
testXLocalBecomeGlobalWithMany2New

	| a1 a2 b2 c2 |
	
	a1 := Example1 new. 
	self assert: a1 isCtxGlobal not. 
	a1 migrateToNextIfNecessary. 
	a2 := a1 nextMe. 
	
	b2 := Example2 new.
	b2 f: 'hello'.
	a2 f: b2.
	
	self assert: ( a1 f f = 'hello' ). 
	self assert: (b2 isCtxGlobal ).
	
	c2 := Example2 new.
	c2 f: 'hello'.
	b2 f: c2.
	self assert: (c2 isCtxGlobal not ). 
	
	self assert: ( a1 f f f = 'hello' ). 
	self assert: (c2 isCtxGlobal). ! !

!BasicTest methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 17:10'!
testXLocalBecomeGlobalWithMany2Old

	| a1 a2 b1 c1 |
	
	a1 := Example1 new. 
	self assert: a1 isCtxGlobal not. 
	a1 migrateToNextIfNecessary. 
	a2 := a1 nextMe. 
	
	b1 := Example1 new.
	b1 f: 'hello'.
	a1 f: b1.
	
	self assert: ( a2 f f = 'hello' ). 
	self assert: (b1 isCtxGlobal ).
	 
	c1 := Example1 new.
	c1 f: 'hello'.
	b1 f: c1.
	self assert: (c1 isCtxGlobal not ).
	
	self assert: ( a2 f f f = 'hello' ). ! !

!BasicTest methodsFor: 'as yet unclassified' stamp: 'ewe 11/6/2012 12:18'!
testXLocalBecomeGlobalWithManyNew

	| a1 a2 b2 c2 |
	
	a1 := Example1 new. 
	self assert: a1 isCtxGlobal not. 
	a1 migrateToNextIfNecessary. 
	a2 := a1 nextMe. 
	
	b2 := Example2 new.
	
	c2 := Example2 new.
	c2 f: 'hello'.
	b2 f: c2.
	
	a2 f: b2.
	self assert: b2 isCtxGlobal not.
	self assert: c2 isCtxGlobal not.    
	self assert: ( a1 f f f = 'hello' ). ! !

!BasicTest methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 17:10'!
testXLocalBecomeGlobalWithManyOld

	| a1 a2 b1 c1 |
	
	a1 := Example1 new. 
	self assert: a1 isCtxGlobal not. 
	a1 migrateToNextIfNecessary. 
	a2 := a1 nextMe. 
	
	b1 := Example1 new.
	
	c1 := Example1 new.
	c1 f: 'hello'.
	b1 f: c1.
	
	a1 f: b1.
	self assert: b1 isCtxGlobal not.
	self assert: c1 isCtxGlobal not.    
	self assert: ( a2 f f f = 'hello' ). ! !

!BasicTest methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 17:10'!
testXNewContextIsDirty

	| a1 a2 b1 b2 |
	
	a1 := Example1 new. 
	self assert: a1 isCtxGlobal not. 
	a1 migrateToNextIfNecessary. 
	a2 := a1 nextMe. 
	
	b1 := Example1 new. 
	self assert: b1 isCtxGlobal not. 
	b1 migrateToNextIfNecessary. 
	b2 := b1 nextMe. 
	
	a1 instVarNamed: 'f' put:  b1.
	b1 instVarNamed: 'f' put: 'hello'.
	
	self assert: ( a2 f = b2 ).
	self assert: ( a2 f f = 'hello' ). ! !

!BasicTest methodsFor: 'as yet unclassified' stamp: 'ewe 11/6/2012 12:18'!
testXOldContextIsDirty

	| a1 a2 b1 b2 |
	
	a2 := Example2 new. 
	self assert: a2 isCtxGlobal not. 
	a2 migrateToPrevIfNecessary. 
	a1 := a2 prevMe. 
	
	b2 := Example2 new. 
	self assert: b2 isCtxGlobal not. 
	b2 migrateToPrevIfNecessary. 
	b1 := b2 prevMe. 
	 
	a2 instVarNamed: 'f' put:  b2. 
	b2 instVarNamed: 'f' put: 'hello'.
	
	self assert: ( a1 f = b1 ).
	self assert: ( a1 f f = 'hello').! !

!BasicTest methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 17:10'!
testXTwoCycles

	| a1 a2 b1 a3 |
	
	a1 := Example1  new.
	
	b1 := Example1  new.
	
	a1 instVarNamed: 'f' put:    b1.
	b1 instVarNamed: 'f' put:   'hello'.
	
	
	a1 migrateToNextIfNecessary.
	a2 := a1 nextMe. 
	
	self assert: ( a2 f isNil not ).
	self assert: ( a2 f f = 'hello' ). 
	
	"we simulate the end of the 1st cycle"
	a2 contextInfo: nil.
	( a2 instVarNamed: 'f' )  contextInfo: nil. 

	"trick because we have only two versions of the classes ATM"
	a2 primitiveChangeClassTo: Example1 new.
	( a2 instVarNamed: 'f' )  primitiveChangeClassTo: Example1 new.
	 
	a2 migrateToNextIfNecessary .
	a3 := a2 nextMe. 
	
	self assert: ( a3 f isNil not ).
	self assert: ( a3 f f = 'hello' ). ! !

TestCase subclass: #ClassMigrationTest
	instanceVariableNames: 'ctx1 ctx2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Tests'!

!ClassMigrationTest methodsFor: 'as yet unclassified' stamp: 'ewe 11/2/2012 09:31'!
setUp
	ctx1 := Page1Context new.
	ctx2 := Page2Context ancestor: ctx1.  
	CurrentContext prevMe: ctx1.
	CurrentContext nextMe: ctx2.
	
	ctx1 bind: #Page to: Page1.
	ctx2 bind: #Page to: Page2.
	ctx1 bind: #HtmlPage to: HtmlPage1.
	ctx2 bind: #HtmlPage to: HtmlPage2.! !

!ClassMigrationTest methodsFor: 'as yet unclassified' stamp: 'ewe 11/23/2012 11:26'!
tearDown

	"Release contet and garbage collect array, dictionary, etc."
	ctx1 release.
	ctx1 := nil.
	ctx2 := nil.
	CurrentContext prevMe: nil.
	CurrentContext nextMe: nil.
	
	"Release object globalized manually"
	{ Page1 . Page2 . HtmlPage1 . HtmlPage2 } do: [ :cls |
		cls allInstances do: [ :o | VirtualField instance unbind: o ].
		VirtualField instance unbind: cls.
	].

	"In case the current context (the process of the running test) has been set"
	CurrentContext instance: nil.
	
	VirtualField instance binding finalizeValues.
	Smalltalk garbageCollect.
	
	VirtualField instance binding finalizeValues.
	Smalltalk garbageCollect! !

!ClassMigrationTest methodsFor: 'as yet unclassified' stamp: 'ewe 11/6/2012 11:56'!
testHtmlPageInstanceMigration

	ctx1 do: [
		| p1 |
		p1 := HtmlPage1 new.
		p1 name: 'TestPage'.
		p1 html: '<header>h</header><body>b</body>'.
		self assert: p1 class = HtmlPage1.
		ctx2 do: [ :p2 |
			self assert: p2 class = HtmlPage2. 
			self assert: p2 name = 'TestPage'.
			self assert: p2 header = '<header>h</header>'.
			self assert: p2 body = '<body>b</body>'.
		] with: p1..
	].
! !

!ClassMigrationTest methodsFor: 'as yet unclassified' stamp: 'ewe 11/6/2012 11:56'!
testPageClassMigration

	ctx1 do: [
		| p1 |
		p1 := Page1. "( ctx1 resolveClass: #Page )."
		self assert: p1 = Page1.
		ctx2 do: [ :p2 |
			self assert: p2 = Page2. 	
		] with: p1..
	].
! !

!ClassMigrationTest methodsFor: 'as yet unclassified' stamp: 'ewe 11/6/2012 11:56'!
testPageInstanceMigration

	ctx1 do: [
		| p1 |
		p1 := Page1 new.
		p1 name: 'TestPage'.
		self assert: p1 class = Page1.
		ctx2 do: [ :p2 |
			self assert: p2 class = Page2. 	
			self assert: p2 name = 'TestPage'.
		] with: p1..
	].
! !

!ClassMigrationTest methodsFor: 'as yet unclassified' stamp: 'ewe 11/6/2012 11:51'!
testSingletonMigration

	|  a1 a2 a  |
	
	ctx1 := Context new.
	ctx2 := SingletonContext ancestor: ctx1.  
	
	CurrentContext prevMe: ctx1.
	CurrentContext nextMe: ctx2.
	
	ctx1 bind: #Singleton to: Singleton1.
	ctx2 bind: #Singleton to: Singleton2. 
	
	"a1 := Example1 new.
	a1 migrateToNextIfNecessary .
	a2 := a1 nextMe. "
	
	CurrentContext instance: ctx2.
	a2 := Example2 new.
	a2 register. 
	 
	"self assert: a2 isCtxGlobal."
	self assert: (Singleton2 ctxReadInstance ) = a2.    
	self assert: (Singleton2 dirtyBit: 15) not.       
	self assert: (Singleton1 dirtyBit: 15).    
	
	CurrentContext instance: ctx1.
	a1 := Singleton1 instance.
	
	self assert: a1 isCtxGlobal.
	self assert: (a2 == a1) not.      
	self assert: a1 isRegistered.
	self assert: (Singleton1 dirtyBit: 15) not.       
	self assert: (Singleton2 dirtyBit: 15) not.

		"Release contet and garbage collect array, dictionary, etc."
	ctx1 release.
	ctx1 := nil.
	ctx2 := nil.
	CurrentContext prevMe: nil.
	CurrentContext nextMe: nil.
	CurrentContext instance: nil.
	   ! !

!ClassMigrationTest methodsFor: 'as yet unclassified' stamp: 'ewe 11/6/2012 10:09'!
testSingletonThreadSafety

	|  a1 a2 a  |
	
	ctx1 := Context new.
	ctx2 := SingletonContext ancestor: ctx1.  
	
	CurrentContext prevMe: ctx1.
	CurrentContext nextMe: ctx2.
	
	ctx1 bind: #Singleton to: Singleton1.
	ctx2 bind: #Singleton to: Singleton2. 
	
	
	CurrentContext instance: ctx2.
	a2 := DictionaryL2 new.
	
	self assert: a2 isThreadSafe not.
	self assert: a2 isCtxGlobal not.
	
	Singleton2 instance: a2. 
	 
	"self assert: a2 isCtxGlobal."
	self assert: (Singleton2 ctxReadInstance ) = a2.    
	self assert: a2 isThreadSafe.
	self assert: a2 isCtxGlobal not.
	 
	CurrentContext instance: ctx1.
	a1 := Singleton1 instance.
	
	self assert: (a2 == a1) not.      
	self assert: a1 isThreadSafe.
	self assert: a1 isCtxGlobal .
 
	"Release contet and garbage collect array, dictionary, etc."
	ctx1 release.
	ctx1 := nil.
	ctx2 := nil.
	CurrentContext prevMe: nil.
	CurrentContext nextMe: nil.
	CurrentContext instance: nil.
	   ! !

!ClassMigrationTest methodsFor: 'as yet unclassified' stamp: 'ewe 11/5/2012 17:24'!
testSingletonWithOneContext! !

TestCase subclass: #ClosureTest
	instanceVariableNames: 'ctx1 ctx2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Tests'!

!ClosureTest commentStamp: 'ewe 10/29/2012 07:45' prior: 0!
Test the kernel classes

First, arrays are always ClTl. At the end they are CgTg. 
Test are named according to the intermediate state: ClTg or CgTl. 

Then comes the description of the migration, M p | n| z. Letters p and n stand for prev and next. Letter z stand for zero, when the migrated version not accessed. !

!ClosureTest methodsFor: 'as yet unclassified' stamp: 'ewe 8/18/2011 11:01'!
_testClassSideResolution
	self assert: ( WebMessage statusCodeAt: 303 ) = 'See Other'.
	! !

!ClosureTest methodsFor: 'as yet unclassified' stamp: 'ewe 8/18/2011 11:01'!
_testClassSideResolutionInheritance
	self assert: ( WebRequest statusCodeAt: 303 ) = 'See Other'.
	! !

!ClosureTest methodsFor: 'as yet unclassified' stamp: 'ewe 11/22/2012 14:14'!
setUp
	ctx1 := TestContext new.
	ctx2 := TestContext ancestor: ctx1.  
	CurrentContext prevMe: ctx1.
	CurrentContext nextMe: ctx2.! !

!ClosureTest methodsFor: 'as yet unclassified' stamp: 'ewe 11/2/2012 16:11'!
tearDown
	
	"Release contet and garbage collect array, dictionary, etc."
	ctx1 release.
	ctx1 := nil.
	ctx2 := nil.
	CurrentContext prevMe: nil.
	CurrentContext nextMe: nil.
	"In case the current context (the process of the running test) has been set"
	CurrentContext instance: nil.
! !

!ClosureTest methodsFor: 'as yet unclassified' stamp: 'ewe 11/1/2012 09:32'!
testBlockClosureCaptureSelf

	| a1 a2 b1 b2 |
	
	a1 := Example1 new.
	a1 migrateToNextIfNecessary. 
	a2 := a1 nextMe. 
	
	b1 := a1 closureWithSelf.
	self assert: ( b1 isCtxGlobal not).
	self assert: ( b1 value = a1 identityHash ).
	
	a1 f: b1. 
	"self assert: (b1 isCtxGlobal ).  "
	self assert: ( b1 value = a1 identityHash ).
	b2:= a2 f. 
	self assert: ( b2 value = a2 identityHash ).
	
	self assert:
	 	b1 outerContext method methodClass = Example1 .
	self assert: 
		b2 outerContext method methodClass = Example2 .! !

!ClosureTest methodsFor: 'as yet unclassified' stamp: 'ewe 11/1/2012 09:32'!
testBlockClosureNoVar

	| a1 a2 b1 b2 |
	
	a1 := Example1 new.
	a1 migrateToNextIfNecessary. 
	a2 := a1 nextMe. 
	
	b1 := a1 closureNoCapture.
	self assert: ( b1 isCtxGlobal not).
	self assert: ( b1 value = 42 ).
	
	a1 f: b1. 
	"self assert: (b1 isCtxGlobal ).  "
	self assert: ( b1 value = 42 ).
	b2:= a2 f. 
	self assert: ( b2 value = 42 ).
	
	self assert:
	 	b1 outerContext method methodClass = Example1 .
	self assert: 
		b2 outerContext method methodClass = Example2 .! !

TestCase subclass: #CollectionTest
	instanceVariableNames: 'ctx1 ctx2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Tests'!

!CollectionTest methodsFor: 'as yet unclassified' stamp: 'ewe 11/1/2012 08:01'!
runColCgTlMn: localClass

	| a1 a2 b1 b2 x1 x2 |
	
	a1 := localClass new: 1.
	 
	self assert: a1 isCtxGlobal not. 
	self assert: a1 isThreadSafe not. 
	
	b1 := Example1 new. 
	b1 f: 'hello'.
	a1 set: b1. 
	
	
	self assert: a1 isThreadSafe not. 
	self assert: a1 isCtxGlobal not. 
	self assert: b1 isThreadSafe. 
	self assert: b1 isCtxGlobal not. 
	 
	a1 migrateToNextIfNecessary. 
	a2 := a1 nextMe. 
	
	self assert: a1 isThreadSafe not. 
	self assert: a1 isCtxGlobal. 
	self assert: b1 isThreadSafe. 
	self assert: b1 isCtxGlobal not. 
	
	self assert: a2 isThreadSafe not.  
	self assert: a2 isCtxGlobal. 
	
	b2 := a2 get. 
	self assert: b2 f = 'hello'.
		
	self assert: a1 isThreadSafe not. 
	self assert: a1 isCtxGlobal. 
	self assert: b1 isThreadSafe. 
	self assert: b1 isCtxGlobal. 
	
	self assert: a2 isThreadSafe not.  
	self assert: a2 isCtxGlobal. 
	self assert: b2 isThreadSafe.  
	self assert: b2 isCtxGlobal.  
	
	x1 := Example1 new. 
	x1 f:  a1. 
	
	self assert: a1 isThreadSafe. 
	self assert: a1 isCtxGlobal. 
	self assert: b1 isThreadSafe. 
	self assert: b1 isCtxGlobal. 
	
	self assert: a2 isThreadSafe.  
	self assert: a2 isCtxGlobal. 
	self assert: b2 isThreadSafe.  
	self assert: b2 isCtxGlobal.  
	
	x1 migrateToNextIfNecessary. 
	x2 := x1 nextMe. 
	
	self assert: x2 f == a2.! !

!CollectionTest methodsFor: 'as yet unclassified' stamp: 'ewe 11/6/2012 13:35'!
runColCgTlMp: localClass

	| a1 a2 b1 b2 x1 x2 |
	
	a1 := localClass new: 1.
	 
	self assert: a1 isCtxGlobal not. 
	self assert: a1 isThreadSafe not. 
	
	a1 migrateToNextIfNecessary. 
	a2 := a1 nextMe. 
	
	b2 := Example2 new.  
	b2 f: 'hello'.
	
	a2 set: b2. 

	self assert: a1 isThreadSafe not.  
	self assert: a1 isCtxGlobal. 	
	self assert: a2 isThreadSafe not. 
	self assert: a2 isCtxGlobal. 
	self assert: b2 isThreadSafe.  
	self assert: b2 isCtxGlobal not. 
	 
	b1 := a1 get. 
	self assert: b1 f = 'hello'.
		
	self assert: a1 isThreadSafe not. 
	self assert: a1 isCtxGlobal. 
	self assert: b1 isThreadSafe. 
	self assert: b1 isCtxGlobal. 
	
	self assert: a2 isThreadSafe not.  
	self assert: a2 isCtxGlobal. 
	self assert: b2 isThreadSafe.  
	self assert: b2 isCtxGlobal.  
	
	x1 := Example1 new. 
	x1 f:  a1. 
	
	self assert: a1 isThreadSafe. 
	self assert: a1 isCtxGlobal. 
	self assert: b1 isThreadSafe. 
	self assert: b1 isCtxGlobal. 
	
	self assert: a2 isThreadSafe.  
	self assert: a2 isCtxGlobal. 
	self assert: b2 isThreadSafe.  
	self assert: b2 isCtxGlobal.  
	
	self assert: a1 class nextMe = a2 class.
	
	x1 migrateToNextIfNecessary.  
	x2 := x1 nextMe. 
	
	self assert: x2 f == a2.! !

!CollectionTest methodsFor: 'as yet unclassified' stamp: 'ewe 11/1/2012 08:03'!
runColClTgMn: localClass

	| a1 a2 b1 b2 |
	
	a1 := Example1 new. 
	self assert: a1 isCtxGlobal not. 
	a1 migrateToNextIfNecessary. 
	a2 := a1 nextMe. 
	
	b1 := localClass new: 1.
	b1 set: 'a'.
	self assert: ( b1 isCtxGlobal not).
	self assert: ( b1 isThreadSafe not).
	
	a1 f: b1.
	self assert: (b1 isCtxGlobal not ). 
	self assert: (b1 isThreadSafe).
		
	b2:= a2 f.

	self assert: (b2 isCtxGlobal ). 
	self assert: (b2 isThreadSafe).
 
	self assert: (b2 get = 'a' ).! !

!CollectionTest methodsFor: 'as yet unclassified' stamp: 'ewe 11/1/2012 08:04'!
runColClTgMnTrans2: localClass

	| a1 a2 b1 c1 d1 |
	
	a1 := Example1 new. 
	self assert: a1 isCtxGlobal not. 
	a1 migrateToNextIfNecessary. 
	a2 := a1 nextMe. 
	
	b1 := localClass new: 1.
	c1 := localClass new: 1.
	
	d1 := Example1 new.
	d1 f: 'hello'.
	c1 set: d1.
	b1 set: c1. 
	 
	self assert: d1 isThreadSafe. 
	self assert: c1 isThreadSafe not. 
	self assert: b1 isThreadSafe not. 
	self assert: a1 isThreadSafe. 
	
	a1 f: b1.
	"Thread globality is eager, but context gloability is lazy"
	self assert: d1 isThreadSafe. 
	self assert: c1 isThreadSafe. 
	self assert: b1 isThreadSafe. 
	self assert: a1 isThreadSafe. 
	
	self assert: b1 isCtxGlobal not.
	self assert: c1 isCtxGlobal not.  
	self assert: d1 isCtxGlobal not.  
		  
	self assert: ( a2 f get get f = 'hello' ). 
	self assert: b1 isCtxGlobal.
	self assert: c1 isCtxGlobal.  
	self assert: d1 isCtxGlobal.    ! !

!CollectionTest methodsFor: 'as yet unclassified' stamp: 'ewe 11/1/2012 08:04'!
runColClTgMnTrans: localClass

	| a1 a2 b1 c1 |
	
	a1 := Example1 new. 
	self assert: a1 isCtxGlobal not. 
	a1 migrateToNextIfNecessary. 
	a2 := a1 nextMe. 
	
	b1 := localClass new: 1.
	
	c1 := Example1 new.
	c1 f: 'hello'.
	b1 set: c1.
	
	self assert: b1 isThreadSafe not. 
	self assert: c1 isThreadSafe. 
	self assert: a1 isThreadSafe. 
	
	a1 f: b1.
	"Thread globality is eager, but context gloability is lazy"
	self assert: b1 isThreadSafe. 
	self assert: c1 isThreadSafe. 
	self assert: a1 isThreadSafe. 
	 
	self assert: b1 isCtxGlobal not.
	self assert: c1 isCtxGlobal not.  
	  
	self assert: ( ( a2 f get ) f = 'hello' ). 
	self assert: b1 isCtxGlobal.
	self assert: c1 isCtxGlobal.    ! !

!CollectionTest methodsFor: 'as yet unclassified' stamp: 'ewe 11/6/2012 13:35'!
runColClTgMp: localClass

	| a1 a2 b1 b2 |
	
	a1 := Example1 new. 
	self assert: a1 isCtxGlobal not. 
	a1 migrateToNextIfNecessary. 
	a2 := a1 nextMe. 
	
	b2 := localClass nextMe new: 1.
	b2 set: 'a'.
	self assert: ( b2 isCtxGlobal not).
	self assert: ( b2 isThreadSafe not).
	
	a2 f: b2.
	self assert: (b2 isCtxGlobal not ). 
	self assert: (b2 isThreadSafe).
		
	b1:= a1 f.

	self assert: (b1 isCtxGlobal ). 
	self assert: (b1 isThreadSafe).
 
	self assert: (b1 get = 'a' ).! !

!CollectionTest methodsFor: 'as yet unclassified' stamp: 'ewe 11/1/2012 09:07'!
runGrow: localClass

	| col1 col2 |
	
	col1 := localClass new. 
	
	1 to: 100 do: [ :item | col1 add: item ].
	
	col1 migrateToNextIfNecessary. 
	col2 := col1 nextMe. 
	
	self assert: col2 size = 100. 
	
	101 to: 200 do: [ :item | col2 add: item ].
	col2 remove: 1. 
	
	self assert: col2 size = 199.
	self assert: (col2 includes: 1) = false.
	self assert: (col2 includes: 2) = true.  
	
	! !

!CollectionTest methodsFor: 'as yet unclassified' stamp: 'ewe 11/22/2012 14:14'!
setUp
	ctx1 := TestContext new.
	ctx2 := TestContext ancestor: ctx1.  
	CurrentContext prevMe: ctx1.
	CurrentContext nextMe: ctx2.
	CurrentContext instance: nil. ! !

!CollectionTest methodsFor: 'as yet unclassified' stamp: 'ewe 10/30/2012 08:37'!
tearDown
	
	"Release contet and garbage collect array, dictionary, etc."
	ctx1 release.
	ctx1 := nil.
	ctx2 := nil.
	CurrentContext prevMe: nil.
	CurrentContext nextMe: nil.! !

!CollectionTest methodsFor: 'as yet unclassified' stamp: 'ewe 10/30/2012 08:39'!
testArray

	self runColCgTlMn: ArrayL1 .
	self runColCgTlMp: ArrayL1 .
	self runColClTgMn: ArrayL1 . 
	self runColClTgMp: ArrayL1 .
	self runColClTgMnTrans: ArrayL1 .
	self runColClTgMnTrans2: ArrayL1 .! !

!CollectionTest methodsFor: 'as yet unclassified' stamp: 'ewe 10/30/2012 08:56'!
testDictionary

	self runColCgTlMn: DictionaryL1  .
	self runColCgTlMp: DictionaryL1 .
	self runColClTgMn: DictionaryL1 . 
	self runColClTgMp: DictionaryL1 .
	self runColClTgMnTrans: DictionaryL1 .
	self runColClTgMnTrans2: DictionaryL1 .! !

!CollectionTest methodsFor: 'as yet unclassified' stamp: 'ewe 11/1/2012 07:04'!
testIdentityDictionary

	self runColCgTlMn: IdentityDictionaryL1  .
	self runColCgTlMp: IdentityDictionaryL1 .
	self runColClTgMn: IdentityDictionaryL1 . 
	self runColClTgMp: IdentityDictionaryL1 .
	self runColClTgMnTrans: IdentityDictionaryL1 .
	self runColClTgMnTrans2: IdentityDictionaryL1 .! !

!CollectionTest methodsFor: 'as yet unclassified' stamp: 'ewe 11/1/2012 09:07'!
testOrderedCollection

	self runColCgTlMn: OrderedCollectionL1  .
	self runColCgTlMp: OrderedCollectionL1 .
	self runColClTgMn: OrderedCollectionL1 . 
	self runColClTgMp: OrderedCollectionL1 .
	self runColClTgMnTrans: OrderedCollectionL1 .
	self runColClTgMnTrans2: OrderedCollectionL1 .
	
	self runGrow: OrderedCollectionL1.   ! !

!CollectionTest methodsFor: 'as yet unclassified' stamp: 'ewe 11/1/2012 09:06'!
testSet

	self runColCgTlMn: SetL1  .
	self runColCgTlMp: SetL1 .
	self runColClTgMn: SetL1 . 
	self runColClTgMp: SetL1 .
	self runColClTgMnTrans: SetL1 .
	self runColClTgMnTrans2: SetL1 .
	
	self runGrow: SetL1.   ! !

TestCase subclass: #ContextCoexistenceTest
	instanceVariableNames: 'ctx1 ctx2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Tests'!

!ContextCoexistenceTest methodsFor: 'as yet unclassified' stamp: 'ewe 11/22/2012 14:15'!
setUp
	ctx1 := TestContext new.
	ctx2 := TestContext ancestor: ctx1.  
	CurrentContext prevMe: ctx1.
	CurrentContext nextMe: ctx2.! !

!ContextCoexistenceTest methodsFor: 'as yet unclassified' stamp: 'ewe 11/23/2012 11:26'!
tearDown
	
	"Release contet and garbage collect array, dictionary, etc."
	ctx1 release.
	ctx1 := nil.
	ctx2 := nil.
	
	Singleton1 instance: nil.
	Singleton2 instance: nil.
	
	CurrentContext prevMe: nil.
	CurrentContext nextMe: nil.
	
	CurrentContext instance: nil.
	
	VirtualField instance binding finalizeValues.
	Smalltalk garbageCollect.
	
	VirtualField instance binding finalizeValues.
	Smalltalk garbageCollect! !

!ContextCoexistenceTest methodsFor: 'as yet unclassified' stamp: 'ewe 11/5/2012 10:55'!
testClassLocalBecomesGlobalNew

	| a1 a2 a  |
	
	self assert: Singleton1 nextMe = Singleton2. 
	self assert: Singleton2 prevMe = Singleton1. 
	
	ctx1 bind: #Singleton to: Singleton1.
	ctx2 bind: #Singleton to: Singleton2.
	
	CurrentContext instance: ctx1.
	a1 := Example1 new.
	a1 register. 
	 
	"self assert: a1 isCtxGlobal."
	self assert: (Singleton1 ctxReadInstance ) = a1.    
	self assert: (Singleton1 dirtyBit: 15) not.       
	self assert: (Singleton2 dirtyBit: 15).    
	
	CurrentContext instance: ctx2.
	a2 := Singleton2 instance.
	
	self assert: a2 isCtxGlobal.
	self assert: (a2 = a1) not.      
	self assert: a2 isRegistered.
	self assert: (Singleton1 dirtyBit: 15) not.       
	self assert: (Singleton2 dirtyBit: 15) not.

	
	
	   ! !

!ContextCoexistenceTest methodsFor: 'as yet unclassified' stamp: 'ewe 11/6/2012 15:10'!
testClassLocalBecomesGlobalOld

	| a1 a2 a  |
	
	self assert: Singleton1 nextMe = Singleton2. 
	self assert: Singleton2 prevMe = Singleton1. 
	
	ctx1 bind: #Singleton to: Singleton1.
	ctx2 bind: #Singleton to: Singleton2.
	
	CurrentContext instance: ctx2.
	a2 := Example2 new.
	a2 register. 
	 
	"self assert: a2 isCtxGlobal."
	self assert: (Singleton2 ctxReadInstance ) = a2.    
	self assert: (Singleton2 dirtyBit: 15) not.       
	self assert: (Singleton1 dirtyBit: 15).    
	
	CurrentContext instance: ctx1.
	a1 := Singleton1 instance.
	
	self assert: a1 isCtxGlobal.
	self assert: (a2 = a1) not.      
	self assert: a1 isRegistered.
	self assert: (Singleton1 dirtyBit: 15) not.       
	self assert: (Singleton2 dirtyBit: 15) not.

	
	
	   ! !

!ContextCoexistenceTest methodsFor: 'as yet unclassified' stamp: 'ewe 11/6/2012 15:09'!
testClassResolutionContextDo

	| a1 a2 a  |
	
	self assert: Singleton1 nextMe = Singleton2. 
	self assert: Singleton2 prevMe = Singleton1. 
	
	ctx1 bind: #Singleton to: Singleton1.
	ctx2 bind: #Singleton to: Singleton2.
	
	a1 := Example1 new.
	a2 := Example2 new. 
	
	a2 migrateToPrevIfNecessary .
	a1 := a2 prevMe. 
	
	ctx1 do: [ a1 register. ].

	self assert: Singleton1 instanceDirtyBit not.       
	self assert: Singleton2 instanceDirtyBit.    
	
	ctx2 do: [ self assert: a2 isRegistered ].
	
	self assert: Singleton1 instanceDirtyBit not.       
	self assert: Singleton2 instanceDirtyBit not.

	
	
	   ! !

!ContextCoexistenceTest methodsFor: 'as yet unclassified' stamp: 'ewe 11/6/2012 15:10'!
testClassResolutionManual

	| a1 a2 a  |
	
	self assert: Singleton1 nextMe = Singleton2. 
	self assert: Singleton2 prevMe = Singleton1. 
	
	ctx1 bind: #Singleton to: Singleton1.
	ctx2 bind: #Singleton to: Singleton2.
	
	a1 := Example1 new.
	a2 := Example2 new. 
	
	a2 migrateToPrevIfNecessary .
	a1 := a2 prevMe. 
	
	CurrentContext instance: ctx1.
	Singleton1 instance: a1. 
	
	self assert: Singleton1 instanceDirtyBit  not.       
	self assert: Singleton2 instanceDirtyBit.    
	
	CurrentContext instance: ctx2.
	a := Singleton2  instance. 
	
	self assert: Singleton1 instanceDirtyBit not.       
	self assert: Singleton2 instanceDirtyBit not.
	self assert: (a = a2).
	
	
	   ! !

!ContextCoexistenceTest methodsFor: 'as yet unclassified' stamp: 'ewe 11/6/2012 15:10'!
testClassResolutionRegister

	| a1 a2 a  |
	
	self assert: Singleton1 nextMe = Singleton2. 
	self assert: Singleton2 prevMe = Singleton1. 
	
	ctx1 bind: #Singleton to: Singleton1.
	ctx2 bind: #Singleton to: Singleton2.
	
	a1 := Example1 new.
	a2 := Example2 new. 
	
	a2 migrateToPrevIfNecessary .
	a1 := a2 prevMe. 
	
	CurrentContext instance: ctx1.
	a1 register.  
	
	self assert: Singleton1 instanceDirtyBit  not.       
	self assert: Singleton2 instanceDirtyBit.    
	
	CurrentContext instance: ctx2.
	self assert: a2 isRegistered.
	
	self assert: Singleton1 instanceDirtyBit not.       
	self assert: Singleton2 instanceDirtyBit not.

	
	
	   ! !

!ContextCoexistenceTest methodsFor: 'as yet unclassified' stamp: 'ewe 11/6/2012 15:10'!
testConcurrentCounter

	| a1 a2 b1 b2 sem1 sem2 sem3  |
	
	
	a1 := Counter1 new.
	a2 := Counter2 new. 
	
	a2 migrateToPrevIfNecessary.
	a1 := a2 prevMe. 
	
	sem1 := Semaphore new.
	sem2 := Semaphore new.
	sem3 := Semaphore forMutualExclusion.
	
	[ 
		CurrentContext instance: ctx1.  
		sem3 critical: [  a1 increment ]. 
		sem3 critical: [  a1 increment ]. 
		 sem1 signal. 
	] fork.

	[ 
		CurrentContext instance: ctx2.  
		sem3 critical: [  a2  increment ]. 
		sem3 critical: [  a2 increment ]. 
		 sem2 signal. 
	] fork.
	
	sem2  wait. 
	sem1  wait.

	self assert: (a1 value = 4  ).
	self assert: (a2 value = 4 ).! !

!ContextCoexistenceTest methodsFor: 'as yet unclassified' stamp: 'ewe 11/5/2012 11:20'!
testContextCloseover

	ctx1 do: [ | a1 |
			a1 := Example1  new.
			a1 f: 3.
			self assert: a1 isCtxGlobal not.
			ctx2 do: [ :a2 |				
					self assert: a1 isCtxGlobal.
					self assert: a2 isCtxGlobal .
					self assert: ( a1 = a2 ) not.
					self assert: a1 uuid = a2 uuid .      
					self assert: a2 f = 3.  
					a2 f: 4.
				] with: a1.
			self assert: a1 f = 4.     
		].
	
	self assert: ctx1 captures size = 1.
	self assert: ctx2 captures size = 1.
	! !

!ContextCoexistenceTest methodsFor: 'as yet unclassified' stamp: 'ewe 11/5/2012 11:22'!
testContextCloseoverDirty
	  
	ctx1 do: [ | a1 |
			a1 := Example1  new.
			a1 f: 3.
			ctx2 do: [ :a2 |				
					self assert: ctx1 captures anyOne hasDirtyBit not.
					self assert: ctx2 captures anyOne hasDirtyBit .  
					self assert: ctx1 captures anyOne isThreadSafe.
					self assert: ctx2 captures anyOne isThreadSafe.
					a2 f: 4.
				] with: a1.
			self assert: a1 f = 4.     
		].
	
	self assert: ctx1 captures size = 1.
	self assert: ctx2 captures size = 1.
	! !

!ContextCoexistenceTest methodsFor: 'as yet unclassified' stamp: 'ewe 11/5/2012 11:24'!
testContextCloseoverSelf
	  
	ctx1 do: [ | a1 |
			a1 := Example1  new.
			a1 f: 3.
		
			a1 do: [ :a2 |				
					self assert: ctx1 captures anyOne hasDirtyBit not.
					self assert: ctx2 captures anyOne hasDirtyBit.  
					a2 f: 4.
				] withSelfIn: ctx2. .
			self assert: a1 f = 4.     
		].
	
	self assert: ctx1 captures size = 1.
	self assert: ctx2 captures size = 1.
	! !

!ContextCoexistenceTest methodsFor: 'as yet unclassified' stamp: 'ewe 11/5/2012 11:25'!
testContextReenter
	  
	ctx1 do: [ | a1 |
			a1 := Example1  new.
			a1 f: 3.
			self assert: a1 isCtxGlobal not.
			ctx1 do: [ :a2 |				
					self assert: a1 isCtxGlobal not.
					self assert: a2 isCtxGlobal not..
					self assert: a1 = a2.   
					self assert: a2 f = 3.  
					a2 f: 4.
				] with: a1.
			self assert: a1 f = 4.     
		].
	
	self assert: ctx1 captures size = 0.
	! !

TestCase subclass: #GarbageCollectionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Tests'!

!GarbageCollectionTest methodsFor: 'counting' stamp: 'ewe 11/5/2012 17:22'!
allInstancesOf: aSet
	^ aSet inject: 0 into: [ :acc :each | acc + each allSubInstances size ]! !

!GarbageCollectionTest methodsFor: 'counting' stamp: 'ewe 11/5/2012 16:51'!
countArray
	^ self allInstancesOf: { ArrayL1 . ArrayL2 . ArrayS1 . ArrayS2 }. ! !

!GarbageCollectionTest methodsFor: 'counting' stamp: 'ewe 11/5/2012 16:52'!
countAssociation
		^ self allInstancesOf: { AssociationL1 . AssociationL2 . AssociationS1 . AssociationS2 }. ! !

!GarbageCollectionTest methodsFor: 'counting' stamp: 'ewe 11/23/2012 11:26'!
countBindKey
	^ VirtualField instance binding keys size! !

!GarbageCollectionTest methodsFor: 'counting' stamp: 'ewe 8/16/2011 14:51'!
countBinding
	^ ContextualInfo allSubInstances size.! !

!GarbageCollectionTest methodsFor: 'counting' stamp: 'ewe 8/16/2011 13:31'!
countContext
	^  Context allSubInstances size. ! !

!GarbageCollectionTest methodsFor: 'counting' stamp: 'ewe 11/5/2012 16:52'!
countDictionary
		^ self allInstancesOf: { DictionaryL1 . DictionaryL2 . DictionaryS1 . DictionaryS2 }. ! !

!GarbageCollectionTest methodsFor: 'counting' stamp: 'ewe 11/5/2012 16:53'!
countExample
		^ self allInstancesOf: { Example1 . Example2 }. ! !

!GarbageCollectionTest methodsFor: 'gc' stamp: 'ewe 11/22/2012 11:14'!
forceGC
	
	self gc; gc; gc. 
	self gcRestartProcesses.! !

!GarbageCollectionTest methodsFor: 'gc' stamp: 'ewe 11/22/2012 11:56'!
gc

self gcFinalizeObjects.
self gcResetReferences.! !

!GarbageCollectionTest methodsFor: 'gc' stamp: 'ewe 11/23/2012 11:26'!
gcFinalizeObjects

WeakRegistry default finalizeValues.
VirtualField instance binding finalizeValues.
Smalltalk garbageCollect.! !

!GarbageCollectionTest methodsFor: 'gc' stamp: 'ewe 11/23/2012 11:26'!
gcResetReferences
ContextStatistics resetAll.

CurrentContext instance: Context new.
CurrentContext nextMe: CurrentContext instance.
CurrentContext prevMe: CurrentContext instance.

Singleton1 instance: nil.
Singleton2 instance: nil.
SubClassVars resetAll. 

CurrentContext instance: nil .
CurrentContext nextMe: nil.
CurrentContext prevMe: nil.

(WeakFinalizerItem allInstances select: [ :i | i executor isKindOf: Context  ]) do: [ :i | i instVarNamed: #executor put: Object new. i at: 1 put: nil ].

( Process allInstances select: [ :p | | e | e := (p instVarNamed: #env). e isNil not and: [ (e at: #activeContext ifAbsent: [nil] ) isNil not ] ] ) do: [ :p | p environmentRemoveKey: #activeContext ].

VirtualField instance binding removeAll. 
Smalltalk garbageCollect.! !

!GarbageCollectionTest methodsFor: 'gc' stamp: 'ewe 11/22/2012 11:12'!
gcRestartProcesses
	" low space + idel  "
	ProcessorScheduler startUp .
	"event loop"
	InputEventFetcher startUp .
	"finalization"
	WeakArray restartFinalizationProcess.
	"UI"
	"SimpleMorphicUIManager"! !

!GarbageCollectionTest methodsFor: 'setup' stamp: 'ewe 11/6/2012 15:12'!
tearDown
	self forceGC! !

!GarbageCollectionTest methodsFor: 'release-binding' stamp: 'ewe 11/22/2012 14:16'!
testCreateAndGarbageAll

	|  ctx1 ctx2  countExample countBinding countBindKey countCtx countDict countArray countAssoc  |
	
	self forceGC. 
	
	countExample := self countExample.
	countBindKey := self countBindKey.
	countBinding := self countBinding.
	countCtx := self countContext .
	countDict := self countDictionary.
	countArray := self countArray .
	countAssoc := self countAssociation .

	ctx1 := TestContext new.
	"A dictionary has an internal array as well"
	self assert: self countDictionary = (countDict ). 
	"self assert: self countBinding = (countBinding +2).    
	self assert: self countBindKey  = (countBindKey + 2). "
			
	ctx2 := TestContext ancestor: ctx1.
	self assert: self countDictionary = (countDict). 
	"self assert: self countBinding = (countBinding +4).  
	self assert: self countBindKey  = (countBindKey + 4). "
	
	CurrentContext  prevMe: ctx1.
	CurrentContext  nextMe: ctx2. 
	
	ctx1 do: [ | a1 |
			a1 := Example1  new.
			a1 f: 3.
			
			"Object is local"
			self assert: a1 isCtxGlobal not.
			"self assert: self countBinding = (countBinding + 4).  
			self assert: self countBindKey  = (countBindKey + 4). "
			self assert: self countExample = (countExample + 1).
		
			ctx2 do: [ :a2 |		 
					a2 f: 4.
					"Object is global and has two representations now"
					"In addition, it creates two asociation in the dictionaries"
					self assert: a2 isCtxGlobal.
					"self assert: self countBinding = (countBinding + 4 + 2).   binding instances might not be acurate unless with force GC"
					"self assert: self countBindKey  = (countBindKey + 6 + 2). "
					self assert: self countExample = (countExample + 2).
				] with: a1.
			self assert: a1 f = 4.   
			
			"Superfluous. To be really sure object can be GC'ed 
			even if tmp var is moved out of the closure"  
			a1 := nil.
		].
	
	ctx1 release.
	
	ctx1 := nil.
	ctx2 := nil.
	CurrentContext  prevMe: nil.
	CurrentContext  nextMe: nil. 

	self forceGC. 
	
	"Everything should have been GC'ed"
	self assert: self countContext = countCtx .
	self assert: self countDictionary = countDict. 
	self assert: self countExample = countExample .
	self assert: self countBinding =  countBinding . 
	self assert: self countBindKey  =  countBindKey.  
	
	"Few more sanity checks"
	self assert: self countAssociation = countAssoc.
	self assert: self countArray = countArray .    ! !

!GarbageCollectionTest methodsFor: 'release-binding' stamp: 'ewe 11/22/2012 14:16'!
testCreateAndGarbageCyclic

	|  ctx1 ctx2  countExample countBinding countBindKey countCtx countDict countArray countAssoc  |
	
	self forceGC. 
		
	countExample := self countExample.
	countBindKey := self countBindKey..  
	countBinding := self countBinding.
	countCtx := self countContext .. 
	countDict := self countDictionary..
	countArray := self countArray ..
	countAssoc := self countAssociation .
		
	ctx1 := TestContext new.
	"A dictionary has an internal array as well"
	self assert: self countDictionary = (countDict ). 
"	self assert: self countBinding = (countBinding +2).    
	self assert: self countBindKey  = (countBindKey + 2). "
			
	ctx2 := TestContext ancestor: ctx1.
	self assert: self countDictionary = (countDict). 
	"self assert: self countBinding = (countBinding +4).  
	self assert: self countBindKey  = (countBindKey + 4). "
	
	CurrentContext  prevMe: ctx1.
	CurrentContext  nextMe: ctx2. 
	
	ctx1 do: [ | a1 a11  |
			a1 := Example1  new.
			a11 := Example1 new.
			a11 f: a1.
			a1 f: a11.
			
			"Object is local"
			self assert: a1 isCtxGlobal not.
			self assert: self countExample = (countExample + 2).
		
			ctx2 do: [ :a2 |
					| a21 |		 
					a21 := a2 f.
					"Object is global and has two representations now"
					"In addition, it creates two asociation in the dictionaries"
					self assert: a21 isCtxGlobal.
					self assert: self countExample = (countExample + 4).
				] with: a1.
			self assert: a1 f = a11.   
			
			"Superfluous. To be really sure object can be GC'ed 
			even if tmp var is moved out of the closure"  
			a1 := nil.
			a11 := nil.
		].
	
	ctx1 release.
	
	ctx1 := nil.
	ctx2 := nil.
	CurrentContext  prevMe: nil.
	CurrentContext  nextMe: nil. 

	self forceGC. 
	
	"Everything should have been GC'ed"
	self assert: self countContext = countCtx .
	self assert: self countDictionary = countDict. 
	self assert: self countExample = countExample .
	self assert: self countBinding =  countBinding . 
	self assert: self countBindKey  =  countBindKey.  
	
	"Few more sanity checks"
	self assert: self countAssociation = countAssoc.
	self assert: self countArray = countArray .    ! !

!GarbageCollectionTest methodsFor: 'release-binding' stamp: 'ewe 11/22/2012 14:16'!
testCreateAndGarbageOne

	|  ctx1 ctx2 countExample countBinding countBindKey countCtx countDict countArray countAssoc  |
	
	self forceGC. 
	
	countExample := self countExample.
	countBindKey := self countBindKey. 
	countBinding := self countBinding.
	countCtx := self countContext .
	countDict := self countDictionary.
	countArray := self countArray .
	countAssoc := self countAssociation .
	
	self assert: Singleton1 isCtxGlobal. 
	
	ctx1 := TestContext new.
	ctx2 := TestContext ancestor: ctx1.
	
	CurrentContext  prevMe: ctx1.
	CurrentContext  nextMe: ctx2. 
	
	self assert: self countDictionary = (countDict). 
	
	"Singleton1 was globalized and bound to #Singleton".
	ctx1 bind: #Singleton to: Singleton1 .
	"self assert: Singleton1 isCtxGlobal."
	"The global dictionary in the context has 3 additional object (array/assoc)"
	"self assert: self countBinding =( countBinding + 4). 
	self assert: self countBindKey  = (countBindKey + 4). "
	
	ctx1 do: [
		| o |
		o := Example1 new. 
		" Object is local"
		self assert: o isCtxGlobal not.
		"self assert: self countBinding = (countBinding + 4).  
		self assert: self countBindKey  = (countBindKey + 4). "
		self assert: self countExample = (countExample + 1).
		
		Singleton1 instance: o.
		" Object is global"	
		"self assert: o isCtxGlobal."
		"self assert: self countBinding = (countBinding + 4 + 1). 
		self assert: self countBindKey  = (countBindKey + 4 + 1).  "	 			
		self assert: self countExample = (countExample + 1).
		
		"Release the global ref"
		Singleton1 instance: nil.
		
		"Superfluous. To be really sure object can be GC'ed 
		even if tmp var o is moved out of the closure"
		o := nil. 
	].	
	
	ctx1 release.
	
	ctx1 := nil.
	ctx2 := nil.
	CurrentContext  prevMe: nil.
	CurrentContext  nextMe: nil. 

	self forceGC. 
	
	"The context, the global dictionary, the object should be GC'ed"
	self assert: self countContext = countCtx .
	self assert: self countDictionary = countDict. 
	self assert: self countExample = countExample .
	self assert: self countBinding = countBinding. 
	self assert: self countBindKey  = countBindKey.  
	
	"Few more sanity checks"
	self assert: self countDictionary = countDict.
	self assert: self countAssociation = countAssoc.
	self assert: self countArray = countArray .    ! !

!GarbageCollectionTest methodsFor: 'release-binding' stamp: 'ewe 11/22/2012 14:16'!
testCreateAndGarbageOneTwo

	|  ctx1 ctx2  countExample countBinding countBindKey countCtx countDict countArray countAssoc  |
	
	self forceGC. 
		
	countExample := self countExample.
	countBindKey := self countBindKey..  
	countBinding := self countBinding.
	countCtx := self countContext .. 
	countDict := self countDictionary..
	countArray := self countArray ..
	countAssoc := self countAssociation .
		
	ctx1 := TestContext new.
	"A dictionary has an internal array as well"
	self assert: self countDictionary = (countDict ). 
	"self assert: self countBinding = (countBinding +2).    
	self assert: self countBindKey  = (countBindKey + 2). "
			
	ctx2 := TestContext ancestor: ctx1.
	self assert: self countDictionary = (countDict ). 
	"self assert: self countBinding = (countBinding +4).  
	self assert: self countBindKey  = (countBindKey + 4). "
	
	CurrentContext  prevMe: ctx1.
	CurrentContext  nextMe: ctx2. 
	
	ctx1 do: [ | a1 |
			a1 := Example1  new.
			a1 f: 3.
			
			"Object is local"
			self assert: a1 isCtxGlobal not.
			"self assert: self countBinding = (countBinding + 4).  
			self assert: self countBindKey  = (countBindKey + 4). "
			self assert: self countExample = (countExample + 1).
		
			ctx2 do: [ :a2 |		 
					a2 f: 4.
					"Object is global and has two representations now"
					"In addition, it creates two asociation in the dictionaries"
					self assert: a2 isCtxGlobal.
					"self assert: self countBinding = (countBinding + 4 + 2).   binding instances might not be acurate unless with force GC"
					"self assert: self countBindKey  = (countBindKey + 6 + 2). "
					self assert: self countExample = (countExample + 2).
				] with: a1.
			self assert: a1 f = 4.   
			
			"Superfluous. To be really sure object can be GC'ed 
			even if tmp var is moved out of the closure"  
			a1 := nil.
		].
	
	ctx2 releaseAncestor.
	ctx1 := nil.
	ctx2 := nil.
	
	CurrentContext  prevMe: nil.
	CurrentContext  nextMe: nil. 

	self forceGC. 
	
	"Everything should have been GC'ed"
	self assert: self countContext = countCtx .
	self assert: self countDictionary = countDict. 
	self assert: self countExample = countExample .
	self assert: self countBinding =  countBinding . 
	self assert: self countBindKey  =  countBindKey.  
	
	"Few more sanity checks"
	self assert: self countAssociation = countAssoc.
	self assert: self countArray = countArray .    ! !

!GarbageCollectionTest methodsFor: 'release-binding' stamp: 'ewe 11/22/2012 14:17'!
testCreateAndGarbageUnreferenced

	|  ctx1 ctx2  countExample countBinding countBindKey countCtx countDict countArray countAssoc  |
	
	self forceGC. 
	
	countExample := self countExample.
		
	ctx1 := TestContext new.
	ctx2 := TestContext ancestor: ctx1.
	
	CurrentContext  prevMe: ctx1.
	CurrentContext  nextMe: ctx2. 
	
	ctx1 do: [ | a1 a11 a11bis  |
			a1 := ExampleA1  new.
			a11 := ExampleB1 new.
			a1 f: a11.
			
			"Object is local"
			self assert: a1 isCtxGlobal not.
			self assert: self countExample = (countExample + 2).
		
			ctx2 do: [ :a2 |
					| a21 |		 
					a21 := a2 f.
					"Object is global and has two representations now"
					"In addition, it creates two asociation in the dictionaries"
					self assert: a21 isCtxGlobal.
					self assert: self countExample = (countExample + 4).
					
					"Now we replace the nested example"
					a21 := ExampleC2 new. 
					a2 f: a21.
					self assert: self countExample = (countExample + 5).
					
				] with: a1.
			
			a11bis := a1 f.

			self assert: ( a11bis isNil not and: [ (a11bis = a11) not ] ).
			self assert: self countExample = (countExample + 6).
			
			
			"Superfluous. To be really sure object can be GC'ed 
			even if tmp var is moved out of the closure"  
			a1 := nil.
			a11 := nil.
			a11bis := nil.
		].
	
	ctx2 releaseAncestor.
	ctx1 := nil.
	ctx2 := nil.
	
	CurrentContext  prevMe: nil.
	CurrentContext  nextMe: nil. 

	self forceGC. 

	"Everything should have been GC'ed, except the detached example"
	self assert: self countExample = (countExample + 2)
	
	"Now we garbage exampleB".
	ExampleB1 allInstances do: [ :o | o nextMe: nil ; prevMe: nil. ].
	self gc.
	self gc.
	self assert: self countExample = (countExample )! !

!GarbageCollectionTest methodsFor: 'release-force' stamp: 'ewe 11/22/2012 13:41'!
testForceReleaseSimple

	|  ctx1 ctx2  a1 a2 d2 sem |
	
	self forceGC. 

	ctx1 := Context new.
	ctx2 := Context ancestor: ctx1.
	
	CurrentContext instance: ctx1.
	CurrentContext  prevMe: ctx1.
	CurrentContext  nextMe: ctx2. 
	
	sem := Semaphore new. 
	
	ctx1 do: [ | b1 c1 d1 |
		
			d1 := Example1 new. 
			d1 f: sem.
			c1 := Example1 new. 
			c1 f: d1. 
			b1 := Example1 new. 
			b1 f: c1. 
			a1 := Example1 new. 
			a1 f: b1.   		
	].
	
	ctx2 do: [ :t2 |
			 | b1 c1 d1 |
			d2 := t2 f f f.   		
	] with: a1. 

	self assert: d2 isCtxGlobal.
	.self assert: (d2 instVarAt: 3) = nil. 
	
	ctx1 := nil. 
	
	CurrentContext instance: ctx2.
	CurrentContext  prevMe: ctx2.
	CurrentContext  nextMe: ctx2. 
	
	self gcFinalizeObjects. 
	sem wait. 
	
	self assert: d2 isCtxGlobal not.
	self assert: (d2 instVarAt: 3) = sem. ! !

!GarbageCollectionTest methodsFor: 'release-force' stamp: 'ewe 11/6/2012 09:38'!
testGarbageDynamicAlias
	self fail! !

!GarbageCollectionTest methodsFor: 'release-force' stamp: 'ewe 11/5/2012 17:24'!
testGarbageOnlyAncestor
	self fail! !

!GarbageCollectionTest methodsFor: 'weak-refrence' stamp: 'ewe 11/5/2012 17:22'!
testWeakGarbage2

	|  weak o1 o2 inf1 inf2  |
	
	weak:= WeakIdentityKeyDictionary new. 
	 
	o1 := Example1 new.
	o2 := Example1 new. 
	
	o1 f: o2.
	o2 f: o1.

	weak at: o1 put: #o1.
	weak at: o2 put: #o2.
		
	o1 := nil.
	o2 := nil.

	weak finalizeValues .
	Smalltalk garbageCollect.
	
	weak finalizeValues .
	Smalltalk garbageCollect.
	
	self assert: weak keys size = 0. 
	! !

TestCase subclass: #LanguageTest
	instanceVariableNames: 'ctx1 ctx2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Tests'!

!LanguageTest methodsFor: 'as yet unclassified' stamp: 'ewe 11/22/2012 14:18'!
setUp
	ctx1 := TestContext new.
	ctx2 := TestContext ancestor: ctx1.  
	CurrentContext prevMe: ctx1.
	CurrentContext nextMe: ctx2.
! !

!LanguageTest methodsFor: 'as yet unclassified' stamp: 'ewe 11/19/2012 10:00'!
tearDown
	
	"Release contet and garbage collect array, dictionary, etc."
	ctx1 release.
	ctx1 := nil.
	ctx2 := nil.
	CurrentContext prevMe: nil.
	CurrentContext nextMe: nil.! !

!LanguageTest methodsFor: 'as yet unclassified' stamp: 'ewe 11/6/2012 15:08'!
testArraySyntax
	| a |
	a := Syntax1 new returnArray.
	self assert: a class = ArrayL1. 
	self assert: a last = 4. ! !

!LanguageTest methodsFor: 'as yet unclassified' stamp: 'ewe 11/6/2012 15:04'!
testAssociationSyntax
	CurrentContext instance: ctx1.   
	self assert: Syntax1 new returnAssociation class = AssociationL1. 
	CurrentContext instance: ctx2.   
	self assert: Syntax1 new returnAssociation class = AssociationL2. ! !

!LanguageTest methodsFor: 'as yet unclassified' stamp: 'ewe 11/19/2012 17:29'!
testCopy
	
	| a1 a2 a2clone |

	a1 := Example1 new.
	 
	self assert: a1 isCtxGlobal not. 
	self assert: a1 isThreadSafe. 
	
	a1 f: #hello .
	
	self assert: a1 f = #hello. 
	 
	a1 migrateToNextIfNecessary. 
	a2 := a1 nextMe. 
	
	a2clone := a2 copy. 
	
	self assert: a2 f = #hello. 
	self assert: a2 isCtxGlobal. 
	self assert: a2 isThreadSafe. 
	
	self assert: a2clone f = #hello. 
	self assert: a2clone isCtxGlobal not. 
	self assert: a2clone isThreadSafe. ! !

!LanguageTest methodsFor: 'as yet unclassified' stamp: 'ewe 11/20/2012 08:48'!
testCopyFrom
	
	| a1 a2 a2clone |

	a1 := Example1 new.
	 
	self assert: a1 isCtxGlobal not. 
	self assert: a1 isThreadSafe. 
	
	a1 f: #hello .
	
	self assert: a1 f = #hello. 
	 
	a1 migrateToNextIfNecessary. 
	a2 := a1 nextMe. 
	
	a2clone := Example2 new. 
	a2clone copyFrom: a2. 
	
	self assert: a2 f = #hello. 
	self assert: a2 isCtxGlobal. 
	self assert: a2 isThreadSafe. 
	
	self assert: a2clone f = #hello. 
	self assert: a2clone isCtxGlobal not. 
	self assert: a2clone isThreadSafe. ! !

!LanguageTest methodsFor: 'as yet unclassified' stamp: 'ewe 11/19/2012 12:07'!
testIdentityHash
	
	| a1 a2 b1 b2 |

	a1 := DictionaryL1 new.
	 
	self assert: a1 isCtxGlobal not. 
	self assert: a1 isThreadSafe not. 
	
	1 to: 20 do: [:index |
		b1 := Example1 new. 
		b1 f: index.
		a1 at:  b1 put: index .  	
	].
	
	self assert: ( a1 at: b1 ) = 20. 
	 
	a1 migrateToNextIfNecessary. 
	a2 := a1 nextMe. 
	
	b1 migrateToNextIfNecessary .
	b2 := b1 nextMe. 
	
	self assert: ( a2 at: b2 ) = 20. ! !

!LanguageTest methodsFor: 'as yet unclassified' stamp: 'ewe 11/2/2012 16:13'!
testInstAndClassVars

	self assert: ClassVars sumAll = 42.  
	self assert: ClassVars new sumAll = 42. 
	self assert: SubClassVars sumAll = 84. 
	self assert: SubClassVars new sumAll = 84. ! !

!LanguageTest methodsFor: 'as yet unclassified' stamp: 'ewe 11/12/2012 16:20'!
testLiteralArraySyntax
	self assert: Syntax1 new returnLiteralArray class = ArrayL1. 
	self assert: Syntax1 new returnLiteralArrayWithSub first class = ArrayL1. ! !

!LanguageTest methodsFor: 'as yet unclassified' stamp: 'ewe 11/12/2012 11:06'!
testNameSyntax
	| a |
	a := Syntax1 new returnName.
	self assert: a = 'Base'! !

!DictionaryS2 methodsFor: '*activecontext' stamp: 'ewe 11/27/2012 13:35'!
ctxWritearray: v2 __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: 2 . self markOtherAsDirty: 2 ]. ^ array := v2  ! !

!DictionaryS2 methodsFor: '*activecontext' stamp: 'ewe 10/31/2012 05:54'!
isThreadSafe 
	^true ! !

!DictionaryS2 methodsFor: '*activecontext' stamp: 'ewe 11/1/2012 07:41'!
secureSelf
 ! !

!Class methodsFor: '*activecontext' stamp: 'ewe 11/12/2012 12:09'!
addFirstInstVarNamed: aString
	"Add the argument, aString, as one of the receiver's instance variables."
	^(ClassBuilder new)
		name: self name
		inEnvironment: self environment
		subclassOf: self superclass
		type: self typeOfClass
		instanceVariableNames: aString , ' ' , self instanceVariablesString
		classVariableNames: self classVariablesString
		poolDictionaries: self sharedPoolsString
		category: self category
! !

!Class methodsFor: '*activecontext' stamp: 'ewe 11/22/2012 16:09'!
allContextInstVarsDo: aBlock 
	| instVarz |
	"TODO could be avoided if vars were always first positions"
	instVarz := self class allInstVarNames. 
	14 to: self class instSize do: [ :pos |
		| varName |
		varName := instVarz at: pos. 
		varName isContextReservedVar ifFalse: [
			aBlock value: varName value: pos. 
		]		
	].! !

!Class methodsFor: '*activecontext' stamp: 'ewe 11/6/2012 13:48'!
canonicalName 
	^ self trimLorS: ( self trimDigitRight: self name ) ! !

!Class methodsFor: '*activecontext' stamp: 'ewe 11/22/2012 14:37'!
contextIdentity
	^ self contextInfo uuid. ! !

!Class methodsFor: '*activecontext' stamp: 'ewe 11/22/2012 14:51'!
contextIdentity: aValue
	self error: 'Identity of class is stored in context uuid'! !

!Class methodsFor: '*activecontext' stamp: 'ewe 9/28/2012 14:35'!
contextInfo
	^__ctxInfo__! !

!Class methodsFor: '*activecontext' stamp: 'ewe 9/28/2012 14:35'!
contextInfo: info
	__ctxInfo__ := info! !

!Class methodsFor: '*activecontext' stamp: 'ewe 9/28/2012 14:36'!
isCtxGlobal 
	^ __ctxInfo__ isNil not. ! !

!Class methodsFor: '*activecontext' stamp: 'ewe 11/12/2012 13:17'!
name
	"Answer the name of the receiver."

	name == nil
		ifTrue: [^super name]
		ifFalse: [^  name ]! !

!Class methodsFor: '*activecontext' stamp: 'ewe 11/22/2012 16:15'!
traverseAndDo: aBlock exclude: visited 
	
	self isPrimitive ifTrue: [ ^ self ].  
	( visited includes: self ) ifTrue: [ ^ self ].  
	visited add: self.
	aBlock value: self. 
	self allContextInstVarsDo: [ :nameVar :pos |
		 ( self instVarAt: pos ) traverseAndDo: aBlock exclude:  visited  ].! !

Object subclass: #BaseContextualObject
	instanceVariableNames: '__ctxInfo__ __ctxIdentity__'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Tests'!

!BaseContextualObject class methodsFor: 'as yet unclassified' stamp: 'ewe 5/20/2011 15:41'!
beep
	Transcript show: 'beep' ! !

!BaseContextualObject class methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
isPrimitive ^ false! !

!BaseContextualObject methodsFor: 'accessing' stamp: 'ewe 5/19/2011 18:02'!
asString 
	^ self contextInfo isNil ifFalse: [ self contextInfo uuid ]. ! !

!BaseContextualObject methodsFor: 'as yet unclassified' stamp: 'ewe 5/19/2011 18:02'!
beep Transcript show: 'beep'    ! !

!BaseContextualObject methodsFor: 'as yet unclassified' stamp: 'ewe 11/12/2012 11:05'!
canonicalName
	^ 'Base'! !

!BaseContextualObject methodsFor: 'as yet unclassified' stamp: 'ewe 11/19/2012 15:40'!
contextIdentity ^__ctxIdentity__! !

!BaseContextualObject methodsFor: 'as yet unclassified' stamp: 'ewe 11/19/2012 15:40'!
contextIdentity: id __ctxIdentity__ := id! !

!BaseContextualObject methodsFor: 'as yet unclassified' stamp: 'ewe 10/11/2012 16:41'!
contextInfo 
	^ __ctxInfo__! !

!BaseContextualObject methodsFor: 'as yet unclassified' stamp: 'ewe 10/11/2012 16:41'!
contextInfo: v
	^ __ctxInfo__ := v! !

!BaseContextualObject methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
ctxRead__ctxInfo__ self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 1 ]. ^  __ctxInfo__! !

!BaseContextualObject methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
ctxWrite__ctxInfo__: v2 self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary: 1 . self markOtherAsDirty: 1 ].  ^ __ctxInfo__ := v2 secure  ! !

!BaseContextualObject methodsFor: 'as yet unclassified' stamp: 'ewe 11/19/2012 15:40'!
identityHash ^ self contextIdentityHash! !

!BaseContextualObject methodsFor: 'as yet unclassified' stamp: 'ewe 10/11/2012 16:41'!
isCtxGlobal 
	^ __ctxInfo__ isNil not! !

!BaseContextualObject methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
isPrimitive ^ false! !

!BaseContextualObject methodsFor: 'as yet unclassified' stamp: 'ewe 5/19/2011 17:52'!
uuid
	^ self contextInfo uuid. ! !

!BaseContextualObject methodsFor: 'as yet unclassified' stamp: 'ewe 5/19/2011 17:50'!
uuid: u
	self contextInfo uuid: u. ! !

BaseContextualObject subclass: #ClassVars
	instanceVariableNames: 'instVar'
	classVariableNames: 'ClassVar'
	poolDictionaries: ''
	category: 'ActiveContext-Tests'!

ClassVars class
	instanceVariableNames: 'classSideInstVar __classVar'!

ClassVars class
	instanceVariableNames: 'classSideInstVar __classVar'!

!ClassVars class methodsFor: 'as yet unclassified' stamp: 'ewe 11/27/2012 13:35'!
ctxReadClassVar __ctxInfo__ ifNotNil: [ self synchronizeIfNecessary: 16 ]. ^  __classVar! !

!ClassVars class methodsFor: 'as yet unclassified' stamp: 'ewe 11/27/2012 13:35'!
ctxRead__classVar __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: 16 ]. ^  __classVar! !

!ClassVars class methodsFor: 'as yet unclassified' stamp: 'ewe 11/27/2012 13:35'!
ctxReadclassSideInstVar __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: 15 ]. ^  classSideInstVar! !

!ClassVars class methodsFor: 'as yet unclassified' stamp: 'ewe 11/27/2012 13:35'!
ctxWriteClassVar: v2 __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: 16 . self markOtherAsDirty: 16 ]. ^ __classVar := v2   ! !

!ClassVars class methodsFor: 'as yet unclassified' stamp: 'ewe 11/27/2012 13:35'!
ctxWrite__classVar: v2 __ctxInfo__ ifNotNil: [ self synchronizeIfNecessary: 16 . self markOtherAsDirty: 16 ]. ^ __classVar := v2   ! !

!ClassVars class methodsFor: 'as yet unclassified' stamp: 'ewe 11/27/2012 13:35'!
ctxWriteclassSideInstVar: v2 __ctxInfo__ ifNotNil: [ self synchronizeIfNecessary: 15 . self markOtherAsDirty: 15 ]. ^ classSideInstVar := v2   ! !

!ClassVars class methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
isPrimitive ^ false! !

!ClassVars class methodsFor: 'as yet unclassified' stamp: 'ewe 9/27/2012 16:42'!
readClassSideInstVar
	classSideInstVar := 42. ! !

!ClassVars class methodsFor: 'as yet unclassified' stamp: 'ewe 9/27/2012 16:41'!
readClassVar
	ClassVar := 42. ! !

!ClassVars class methodsFor: 'as yet unclassified' stamp: 'ewe 11/2/2012 15:47'!
sumAll
	classSideInstVar :=21.
	ClassVar := 21.
	^ classSideInstVar + ClassVar .! !

!ClassVars methodsFor: 'as yet unclassified' stamp: 'ewe 11/27/2012 13:35'!
ctxReadinstVar __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: 3 ]. ^  instVar! !

!ClassVars methodsFor: 'as yet unclassified' stamp: 'ewe 11/27/2012 13:35'!
ctxWriteinstVar: v2 __ctxInfo__ ifNotNil: [ self synchronizeIfNecessary: 3 . self markOtherAsDirty: 3 ]. ^ instVar := v2   ! !

!ClassVars methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
isPrimitive ^ false! !

!ClassVars methodsFor: 'as yet unclassified' stamp: 'ewe 11/2/2012 15:46'!
sumAll
	instVar :=21.
	ClassVar := 21.
	^ instVar + ClassVar .! !

ClassVars subclass: #SubClassVars
	instanceVariableNames: 'instVarSub'
	classVariableNames: 'ClassVarSub'
	poolDictionaries: ''
	category: 'ActiveContext-Tests'!

SubClassVars class
	instanceVariableNames: 'classSideInstVarSub __classVarSub'!

SubClassVars class
	instanceVariableNames: 'classSideInstVarSub __classVarSub'!

!SubClassVars class methodsFor: 'as yet unclassified' stamp: 'ewe 11/27/2012 13:35'!
ctxReadClassVarSub __ctxInfo__ ifNotNil: [ self synchronizeIfNecessary: 18 ]. ^  __classVarSub! !

!SubClassVars class methodsFor: 'as yet unclassified' stamp: 'ewe 11/27/2012 13:35'!
ctxRead__classVarSub __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: 18 ]. ^  __classVarSub! !

!SubClassVars class methodsFor: 'as yet unclassified' stamp: 'ewe 11/27/2012 13:35'!
ctxReadclassSideInstVarSub __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: 17 ]. ^  classSideInstVarSub! !

!SubClassVars class methodsFor: 'as yet unclassified' stamp: 'ewe 11/27/2012 13:35'!
ctxWriteClassVarSub: v2 __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: 18 . self markOtherAsDirty: 18 ]. ^ __classVarSub := v2   ! !

!SubClassVars class methodsFor: 'as yet unclassified' stamp: 'ewe 11/27/2012 13:35'!
ctxWrite__classVarSub: v2 __ctxInfo__ ifNotNil: [ self synchronizeIfNecessary: 18 . self markOtherAsDirty: 18 ]. ^ __classVarSub := v2   ! !

!SubClassVars class methodsFor: 'as yet unclassified' stamp: 'ewe 11/27/2012 13:35'!
ctxWriteclassSideInstVarSub: v2 __ctxInfo__ ifNotNil: [ self synchronizeIfNecessary: 17 . self markOtherAsDirty: 17 ]. ^ classSideInstVarSub := v2   ! !

!SubClassVars class methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
isPrimitive ^ false! !

!SubClassVars class methodsFor: 'as yet unclassified' stamp: 'ewe 11/5/2012 13:26'!
resetAll
	<ctxMeta>
	__classVar := nil.
	__classVarSub := nil.
	classSideInstVar := nil.
	classSideInstVarSub := nil.! !

!SubClassVars class methodsFor: 'as yet unclassified' stamp: 'ewe 11/2/2012 15:48'!
sumAll
	classSideInstVar  :=21.
	classSideInstVarSub  := 21.
	ClassVar := 21.
	ClassVarSub := 21. 
	^ classSideInstVar + ClassVar + classSideInstVarSub + ClassVarSub  .! !

!SubClassVars methodsFor: 'as yet unclassified' stamp: 'ewe 11/27/2012 13:33'!
ctxReadinstVarSub __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: 4 ]. ^  instVarSub! !

!SubClassVars methodsFor: 'as yet unclassified' stamp: 'ewe 11/27/2012 13:33'!
ctxWriteinstVarSub: v2 __ctxInfo__ ifNotNil: [ self synchronizeIfNecessary: 4 . self markOtherAsDirty: 4 ]. ^ instVarSub := v2   ! !

!SubClassVars methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
isPrimitive ^ false! !

!SubClassVars methodsFor: 'as yet unclassified' stamp: 'ewe 11/2/2012 15:48'!
sumAll
	instVar :=21.
	instVarSub := 21.
	ClassVar := 21.
	ClassVarSub := 21. 
	^ instVar + ClassVar + instVarSub + ClassVarSub  .! !

BaseContextualObject subclass: #Counter1
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Tests'!

!Counter1 class methodsFor: 'as yet unclassified' stamp: 'ewe 5/19/2011 17:59'!
beep  Transcript show: 'beep'        ! !

!Counter1 class methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
isPrimitive ^ false! !

!Counter1 methodsFor: 'as yet unclassified' stamp: 'ewe 11/27/2012 13:34'!
ctxReadvalue __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: 3 ]. ^  value! !

!Counter1 methodsFor: 'as yet unclassified' stamp: 'ewe 11/27/2012 13:34'!
ctxWritevalue: v2 __ctxInfo__ ifNotNil: [ self synchronizeIfNecessary: 3 . self markOtherAsDirty: 3 ]. ^ value := v2   ! !

!Counter1 methodsFor: 'as yet unclassified' stamp: 'ewe 5/19/2011 13:44'!
increment
	value := value + 1.
	Transcript show: ('counter is now ', value asString ) ; cr.! !

!Counter1 methodsFor: 'as yet unclassified' stamp: 'ewe 5/19/2011 16:12'!
initialize 
	super initialize .
	value := 0. ! !

!Counter1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
isPrimitive ^ false! !

!Counter1 methodsFor: 'as yet unclassified' stamp: 'ewe 5/19/2011 17:51'!
value
	^ value   ! !

BaseContextualObject subclass: #Counter2
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Tests'!

!Counter2 class methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 15:59'!
beep  Transcript show: 'beep'        ! !

!Counter2 class methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 15:59'!
isPrimitive ^ false! !

!Counter2 methodsFor: 'as yet unclassified' stamp: 'ewe 11/27/2012 13:35'!
ctxReadvalue __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: 3 ]. ^  value! !

!Counter2 methodsFor: 'as yet unclassified' stamp: 'ewe 11/27/2012 13:35'!
ctxWritevalue: v2 __ctxInfo__ ifNotNil: [ self synchronizeIfNecessary: 3 . self markOtherAsDirty: 3 ]. ^ value := v2   ! !

!Counter2 methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 15:59'!
increment
	value := value + 1.
	Transcript show: ('counter is now ', value asString ) ; cr.! !

!Counter2 methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 15:59'!
initialize 
	super initialize .
	value := 0. ! !

!Counter2 methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 15:59'!
isPrimitive ^ false! !

!Counter2 methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 15:59'!
value
	^ value   ! !

BaseContextualObject subclass: #Example1
	instanceVariableNames: 'f'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Tests'!

!Example1 class methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
isPrimitive ^ false! !

!Example1 methodsFor: 'as yet unclassified' stamp: 'ewe 11/1/2012 09:27'!
closureNoCapture

	^ [ 42 ]! !

!Example1 methodsFor: 'as yet unclassified' stamp: 'ewe 11/1/2012 09:27'!
closureWithSelf

	^ [ self identityHash ]! !

!Example1 methodsFor: 'as yet unclassified' stamp: 'ewe 11/27/2012 13:34'!
ctxReadf __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: 3 ]. ^  f! !

!Example1 methodsFor: 'as yet unclassified' stamp: 'ewe 11/27/2012 13:34'!
ctxWritef: v2 __ctxInfo__ ifNotNil: [ self synchronizeIfNecessary: 3 . self markOtherAsDirty: 3 ]. ^ f := v2   ! !

!Example1 methodsFor: 'as yet unclassified' stamp: 'ewe 11/22/2012 12:21'!
detachNext 
	<ctxMeta>
	Transcript show: 'Detach '; show: self asString ; cr. 
	super detachNext.
	( f isKindOf: Semaphore ) ifTrue: [
		f signal. 
	]! !

!Example1 methodsFor: 'as yet unclassified' stamp: 'ewe 7/7/2011 15:49'!
do: aBlock withSelfIn: aContext

^ aContext do: aBlock with: self. ! !

!Example1 methodsFor: 'as yet unclassified' stamp: 'ewe 5/19/2011 10:20'!
f 
	^f    ! !

!Example1 methodsFor: 'as yet unclassified' stamp: 'ewe 5/19/2011 10:20'!
f: v
f:= v.  ! !

!Example1 methodsFor: 'as yet unclassified' stamp: 'ewe 11/22/2012 12:26'!
forceLoad
	<ctxMeta>
	Transcript show: 'For load '; show: self asString ; cr. 
	super forceLoad.
! !

!Example1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
isPrimitive ^ false! !

!Example1 methodsFor: 'as yet unclassified' stamp: 'ewe 5/20/2011 15:01'!
isRegistered
	^ Singleton instance = self.! !

!Example1 methodsFor: 'as yet unclassified' stamp: 'ewe 7/5/2011 14:29'!
register
	Singleton  instance: self.    ! !

Example1 subclass: #ExampleA1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Tests'!

!ExampleA1 class methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
isPrimitive ^ false! !

!ExampleA1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
isPrimitive ^ false! !

Example1 subclass: #ExampleB1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Tests'!

!ExampleB1 class methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
isPrimitive ^ false! !

!ExampleB1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
isPrimitive ^ false! !

Example1 subclass: #ExampleC1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Tests'!

!ExampleC1 class methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
isPrimitive ^ false! !

!ExampleC1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
isPrimitive ^ false! !

BaseContextualObject subclass: #Example2
	instanceVariableNames: 'f'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Tests'!

!Example2 class methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
isPrimitive ^ false! !

!Example2 methodsFor: 'as yet unclassified' stamp: 'ewe 11/1/2012 09:26'!
closureNoCapture

	^ [ 42 ]! !

!Example2 methodsFor: 'as yet unclassified' stamp: 'ewe 11/1/2012 09:26'!
closureWithSelf

	^ [ self identityHash ]! !

!Example2 methodsFor: 'as yet unclassified' stamp: 'ewe 11/27/2012 13:34'!
ctxReadf __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: 3 ]. ^  f! !

!Example2 methodsFor: 'as yet unclassified' stamp: 'ewe 11/27/2012 13:34'!
ctxWritef: v2 __ctxInfo__ ifNotNil: [ self synchronizeIfNecessary: 3 . self markOtherAsDirty: 3 ]. ^ f := v2   ! !

!Example2 methodsFor: 'as yet unclassified' stamp: 'ewe 11/22/2012 12:21'!
detachNext 
	<ctxMeta>
	Transcript show: 'Detach '; show: self asString ; cr. 
	super detachNext.
	( f isKindOf: Semaphore ) ifTrue: [
		f signal. 
	]! !

!Example2 methodsFor: 'as yet unclassified' stamp: 'ewe 10/11/2012 14:38'!
do: aBlock withSelfIn: aContext

^ aContext do: aBlock with: self. ! !

!Example2 methodsFor: 'as yet unclassified' stamp: 'ewe 10/11/2012 14:38'!
f 
	^f    ! !

!Example2 methodsFor: 'as yet unclassified' stamp: 'ewe 10/11/2012 14:38'!
f: v
f:= v.  ! !

!Example2 methodsFor: 'as yet unclassified' stamp: 'ewe 11/22/2012 12:26'!
forceLoad
	<ctxMeta>
	Transcript show: 'For load '; show: self asString ; cr. 
	super forceLoad.
! !

!Example2 methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
isPrimitive ^ false! !

!Example2 methodsFor: 'as yet unclassified' stamp: 'ewe 10/11/2012 14:38'!
isRegistered
	^ Singleton instance = self.! !

!Example2 methodsFor: 'as yet unclassified' stamp: 'ewe 10/11/2012 14:38'!
register
	Singleton  instance: self.    ! !

Example2 subclass: #ExampleA2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Tests'!

!ExampleA2 class methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
isPrimitive ^ false! !

!ExampleA2 methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
isPrimitive ^ false! !

Example2 subclass: #ExampleB2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Tests'!

!ExampleB2 class methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
isPrimitive ^ false! !

!ExampleB2 methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
isPrimitive ^ false! !

Example2 subclass: #ExampleC2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Tests'!

!ExampleC2 class methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
isPrimitive ^ false! !

!ExampleC2 methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
isPrimitive ^ false! !

BaseContextualObject subclass: #Page1
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Tests'!

Page1 subclass: #HtmlPage1
	instanceVariableNames: 'html'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Tests'!

!HtmlPage1 class methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
isPrimitive ^ false! !

!HtmlPage1 methodsFor: 'as yet unclassified' stamp: 'ewe 11/27/2012 13:34'!
ctxReadhtml __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: 4 ]. ^  html! !

!HtmlPage1 methodsFor: 'as yet unclassified' stamp: 'ewe 11/27/2012 13:34'!
ctxWritehtml: v2 __ctxInfo__ ifNotNil: [ self synchronizeIfNecessary: 4 . self markOtherAsDirty: 4 ]. ^ html := v2   ! !

!HtmlPage1 methodsFor: 'as yet unclassified' stamp: 'ewe 8/19/2011 11:09'!
html
	^ html! !

!HtmlPage1 methodsFor: 'as yet unclassified' stamp: 'ewe 8/19/2011 11:09'!
html: value
	html := value.! !

!HtmlPage1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
isPrimitive ^ false! !

!Page1 class methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
isPrimitive ^ false! !

!Page1 methodsFor: 'as yet unclassified' stamp: 'ewe 11/27/2012 13:33'!
ctxReadname __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: 3 ]. ^  name! !

!Page1 methodsFor: 'as yet unclassified' stamp: 'ewe 11/27/2012 13:33'!
ctxWritename: v2 __ctxInfo__ ifNotNil: [ self synchronizeIfNecessary: 3 . self markOtherAsDirty: 3 ]. ^ name := v2   ! !

!Page1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
isPrimitive ^ false! !

!Page1 methodsFor: 'accessing' stamp: 'ewe 8/19/2011 11:13'!
name
	^ name! !

!Page1 methodsFor: 'accessing' stamp: 'ewe 8/19/2011 11:09'!
name: anObject
	name := anObject! !

BaseContextualObject subclass: #Page2
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Tests'!

Page2 subclass: #HtmlPage2
	instanceVariableNames: 'body header'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Tests'!

!HtmlPage2 class methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
isPrimitive ^ false! !

!HtmlPage2 methodsFor: 'as yet unclassified' stamp: 'ewe 8/19/2011 11:10'!
body
	^ body! !

!HtmlPage2 methodsFor: 'as yet unclassified' stamp: 'ewe 8/19/2011 11:10'!
body: value
	body := value.! !

!HtmlPage2 methodsFor: 'as yet unclassified' stamp: 'ewe 11/27/2012 13:33'!
ctxReadbody __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: 4 ]. ^  body! !

!HtmlPage2 methodsFor: 'as yet unclassified' stamp: 'ewe 11/27/2012 13:33'!
ctxReadheader __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: 5 ]. ^  header! !

!HtmlPage2 methodsFor: 'as yet unclassified' stamp: 'ewe 11/27/2012 13:33'!
ctxWritebody: v2 __ctxInfo__ ifNotNil: [ self synchronizeIfNecessary: 4 . self markOtherAsDirty: 4 ]. ^ body := v2   ! !

!HtmlPage2 methodsFor: 'as yet unclassified' stamp: 'ewe 11/27/2012 13:33'!
ctxWriteheader: v2 __ctxInfo__ ifNotNil: [ self synchronizeIfNecessary: 5 . self markOtherAsDirty: 5 ]. ^ header := v2   ! !

!HtmlPage2 methodsFor: 'as yet unclassified' stamp: 'ewe 8/19/2011 11:10'!
header
	^ header ! !

!HtmlPage2 methodsFor: 'as yet unclassified' stamp: 'ewe 8/19/2011 11:10'!
header: value
	header := value! !

!HtmlPage2 methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
isPrimitive ^ false! !

!Page2 class methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
isPrimitive ^ false! !

!Page2 methodsFor: 'as yet unclassified' stamp: 'ewe 11/27/2012 13:33'!
ctxReadname __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: 3 ]. ^  name! !

!Page2 methodsFor: 'as yet unclassified' stamp: 'ewe 11/27/2012 13:33'!
ctxWritename: v2 __ctxInfo__ ifNotNil: [ self synchronizeIfNecessary: 3 . self markOtherAsDirty: 3 ]. ^ name := v2   ! !

!Page2 methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
isPrimitive ^ false! !

!Page2 methodsFor: 'accessing' stamp: 'ewe 8/19/2011 11:14'!
name
	^ name! !

!Page2 methodsFor: 'accessing' stamp: 'ewe 8/19/2011 11:09'!
name: anObject
	name := anObject! !

BaseContextualObject subclass: #Singleton1
	instanceVariableNames: ''
	classVariableNames: 'Instance'
	poolDictionaries: ''
	category: 'ActiveContext-Tests'!

Singleton1 class
	instanceVariableNames: '__instance'!

Singleton1 class
	instanceVariableNames: '__instance'!

!Singleton1 class methodsFor: 'as yet unclassified' stamp: 'ewe 11/27/2012 13:33'!
ctxReadInstance __ctxInfo__ ifNotNil: [ self synchronizeIfNecessary: 15 ]. ^  __instance! !

!Singleton1 class methodsFor: 'as yet unclassified' stamp: 'ewe 11/27/2012 13:33'!
ctxRead__instance __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: 15 ]. ^  __instance! !

!Singleton1 class methodsFor: 'as yet unclassified' stamp: 'ewe 11/27/2012 13:33'!
ctxWriteInstance: v2 __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: 15 . self markOtherAsDirty: 15 ]. ^ __instance := v2   ! !

!Singleton1 class methodsFor: 'as yet unclassified' stamp: 'ewe 11/27/2012 13:33'!
ctxWrite__instance: v2 __ctxInfo__ ifNotNil: [ self synchronizeIfNecessary: 15 . self markOtherAsDirty: 15 ]. ^ __instance := v2   ! !

!Singleton1 class methodsFor: 'as yet unclassified' stamp: 'ewe 5/23/2011 10:08'!
instance
	^ Instance       ! !

!Singleton1 class methodsFor: 'as yet unclassified' stamp: 'ewe 5/23/2011 10:08'!
instance: anObject
	Instance:= anObject . ! !

!Singleton1 class methodsFor: 'as yet unclassified' stamp: 'ewe 11/5/2012 11:15'!
instanceDirtyBit
	<ctxMeta>
	^self dirtyBit: 15  ! !

!Singleton1 class methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
isPrimitive ^ false! !

!Singleton1 methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
isPrimitive ^ false! !

!Singleton1 methodsFor: 'as yet unclassified' stamp: 'ewe 8/30/2011 09:35'!
isTheSingleton
	^ Instance = self. ! !

BaseContextualObject subclass: #Singleton2
	instanceVariableNames: ''
	classVariableNames: 'Instance'
	poolDictionaries: ''
	category: 'ActiveContext-Tests'!

Singleton2 class
	instanceVariableNames: '__instance'!

Singleton2 class
	instanceVariableNames: '__instance'!

!Singleton2 class methodsFor: 'as yet unclassified' stamp: 'ewe 11/27/2012 13:35'!
ctxReadInstance __ctxInfo__ ifNotNil: [ self synchronizeIfNecessary: 15 ]. ^  __instance! !

!Singleton2 class methodsFor: 'as yet unclassified' stamp: 'ewe 11/27/2012 13:35'!
ctxRead__instance __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: 15 ]. ^  __instance! !

!Singleton2 class methodsFor: 'as yet unclassified' stamp: 'ewe 11/27/2012 13:35'!
ctxWriteInstance: v2 __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: 15 . self markOtherAsDirty: 15 ]. ^ __instance := v2   ! !

!Singleton2 class methodsFor: 'as yet unclassified' stamp: 'ewe 11/27/2012 13:35'!
ctxWrite__instance: v2 __ctxInfo__ ifNotNil: [ self synchronizeIfNecessary: 15 . self markOtherAsDirty: 15 ]. ^ __instance := v2   ! !

!Singleton2 class methodsFor: 'as yet unclassified' stamp: 'ewe 5/23/2011 10:00'!
instance
	^ Instance       ! !

!Singleton2 class methodsFor: 'as yet unclassified' stamp: 'ewe 5/23/2011 14:56'!
instance: anObject
	 Instance:= anObject .   ! !

!Singleton2 class methodsFor: 'as yet unclassified' stamp: 'ewe 11/5/2012 11:15'!
instanceDirtyBit
	<ctxMeta>
	^self dirtyBit: 15  ! !

!Singleton2 class methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
isPrimitive ^ false! !

!Singleton2 methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 11:35'!
isPrimitive ^ false! !

!Singleton2 methodsFor: 'as yet unclassified' stamp: 'ewe 8/30/2011 09:48'!
isTheSingleton
	^ Instance = self.! !

BaseContextualObject subclass: #Syntax1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Tests'!

!Syntax1 methodsFor: 'as yet unclassified' stamp: 'ewe 11/6/2012 15:07'!
returnArray
	^ { 1. .2 .3 . 2+2}! !

!Syntax1 methodsFor: 'as yet unclassified' stamp: 'ewe 11/6/2012 14:17'!
returnAssociation
	^ 1 -> 2 ! !

!Syntax1 methodsFor: 'as yet unclassified' stamp: 'ewe 11/6/2012 09:51'!
returnLiteralArray
	^#(1 2 3)! !

!Syntax1 methodsFor: 'as yet unclassified' stamp: 'ewe 11/12/2012 16:19'!
returnLiteralArrayWithSub
	^ #(('efi' 'Efik') ('egy' 'Egyptian (Ancient)') ('eka' 'Ekajuk') ('elx' 'Elamite') ('en' 'eng' 'English') ('enm' 'English, Middle (1100-1500)') ('eo' 'epo' 'Esperanto') ('et' 'est' 'Estonian') ('ee' 'ewe' 'Ewe') ('ewo' 'Ewondo') )! !

!Syntax1 methodsFor: 'as yet unclassified' stamp: 'ewe 11/12/2012 15:36'!
returnName
	^ self name ! !

Object subclass: #ClassesUtils
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Utils'!

!ClassesUtils class methodsFor: 'compilation-optimization' stamp: 'ewe 11/19/2012 09:20'!
addCtxIdentityVar: cls
	
	self assert: cls isMeta not. 
	
	( cls instVarNames includes: '__ctxIdentity__' ) ifFalse: [
		cls addInstVarNamed: '__ctxIdentity__'.  
	]
	! !

!ClassesUtils class methodsFor: 'compilation-optimization' stamp: 'ewe 11/12/2012 13:13'!
addCtxInfoVar: cls
	
	self assert: cls isMeta not. 
	
	( cls instVarNames includes: '__ctxInfo__' ) ifFalse: [
		cls addInstVarNamed: '__ctxInfo__'.  
	]
	! !

!ClassesUtils class methodsFor: 'compilation-optimization' stamp: 'ewe 11/12/2012 13:04'!
addSyntheticClassVar: cls
	
	(cls isMeta) ifTrue: [
		cls theNonMetaClass classPool keys do: [ :classVar |
			| adaptedClassVar |
			adaptedClassVar := '__' , classVar withFirstCharacterDownshifted .
			self assert: classVar first isUppercase .
			( cls instVarNames includes: adaptedClassVar ) ifFalse: [
					cls addInstVarNamed: adaptedClassVar.  
			]
		]
	]! !

!ClassesUtils class methodsFor: 'backup-restore' stamp: 'ewe 9/26/2011 15:57'!
backupMethodsFor: aClass

	aClass methodDict values do: [ :m |
		| src |
		src := m getSource. 
		(src first = $_ or: [ (src beginsWith: 'ctx'  ) ] ) ifFalse: [	
				 ( src first  isAlphaNumeric  ) ifTrue: [ aClass compile: '_' , src  ]
			].
		]! !

!ClassesUtils class methodsFor: 'compilation-listing' stamp: 'ewe 11/9/2012 16:35'!
baseClassesOf: aSet
	^ aSet select: [ :cls |  (aSet includes: cls superclass) not ]! !

!ClassesUtils class methodsFor: 'compilation-listing' stamp: 'ewe 11/9/2012 16:37'!
baseClassesOfPackage: aPackageName 

	^ self baseClassesOf: ( PackageInfo named: aPackageName ) classes 
	! !

!ClassesUtils class methodsFor: 'compilation-listing' stamp: 'ewe 11/19/2012 09:51'!
baseClassesOfPackages: aSet 
	^ aSet inject: OrderedCollection new into: [ :set :pckg | set addAll: (self baseClassesOfPackage: pckg) ; yourself ]  
	! !

!ClassesUtils class methodsFor: 'compilation-listing' stamp: 'ewe 9/28/2012 15:41'!
classesMetaOfKernelNext
	^ self classesOfKernelNext collect: [ :c | c class ].! !

!ClassesUtils class methodsFor: 'compilation-listing' stamp: 'ewe 9/28/2012 15:41'!
classesMetaOfKernelPrev
	^ self classesOfKernelPrev collect: [ :c | c class ]! !

!ClassesUtils class methodsFor: 'compilation-listing' stamp: 'ewe 11/14/2012 10:08'!
classesMetaOfWebNext 
	^ self classesOfWebNext collect: [ :c | c class ].! !

!ClassesUtils class methodsFor: 'compilation-listing' stamp: 'ewe 11/12/2012 12:02'!
classesMetaOfWebPrev
	^ self classesOfWebPrev collect: [ :c | c class ].! !

!ClassesUtils class methodsFor: 'compilation-listing' stamp: 'ewe 10/11/2012 14:44'!
classesOfKernelNext
	|  base col |
	col := OrderedCollection new. 
	base := 
	{ HashedCollectionL2 .
	  OrderedCollectionL2 .
	  LookupKeyL2 .  
	  ArrayL2 . } .  
	
	base do: [ :cls |
		col  add: cls . 
		col addAll: cls  allSubclasses.
	].
	^ col  select: [ :cls | cls isObsolete not ].! !

!ClassesUtils class methodsFor: 'compilation-listing' stamp: 'ewe 10/11/2012 14:44'!
classesOfKernelPrev
	|  base col |
	col := OrderedCollection new. 
	base := 
	{ HashedCollectionL1 .
	  OrderedCollectionL1 .
	  LookupKeyL1 .  
	  ArrayL1  } . 
	
	base do: [ :cls |
		col  add: cls . 
		col addAll: cls  allSubclasses.
	].
	^ col  select: [ :cls | cls isObsolete not ].! !

!ClassesUtils class methodsFor: 'compilation-listing' stamp: 'ewe 11/12/2012 12:06'!
classesOfPackage: aPackageName 

	^ ( PackageInfo named: aPackageName ) classes 
	! !

!ClassesUtils class methodsFor: 'compilation-listing' stamp: 'ewe 11/19/2012 14:22'!
classesOfPackages: aSet 
	^ aSet inject: OrderedCollection new into: [ :set :pckg | set addAll: (self classesOfPackage: pckg) ; yourself ]  
	! !

!ClassesUtils class methodsFor: 'compilation-listing' stamp: 'ewe 9/21/2012 15:58'!
classesOfTests
	|  base col |
	col := OrderedCollection new. 
	base := 
	{ BaseContextualObject } .
	
	base do: [ :cls |
		col  add: cls . 
		col addAll: cls  allSubclasses.
		col  add: cls class  . 
		col addAll: cls class  allSubclasses.
	].
	^ col  select: [ :cls | cls isObsolete not ].! !

!ClassesUtils class methodsFor: 'compilation-listing' stamp: 'ewe 11/14/2012 10:08'!
classesOfWebNext
	|  base col |
	col := OrderedCollection new. 
	col addAll: (ClassesUtils classesOfPackage: 'ConsolidatedWeb2').
	^ col  select: [ :cls | cls isObsolete not ].! !

!ClassesUtils class methodsFor: 'compilation-listing' stamp: 'ewe 11/12/2012 12:06'!
classesOfWebPrev
	|  base col |
	col := OrderedCollection new. 
	col addAll: (ClassesUtils classesOfPackage: 'ConsolidatedWeb1').
	^ col  select: [ :cls | cls isObsolete not ].! !

!ClassesUtils class methodsFor: 'copy-class' stamp: 'ewe 9/6/2011 13:21'!
copyClass: oldClass as: newName 
	| oldDefinition newDefinition |
	(oldClass environment hasClassNamed: newName) 
		ifTrue: [^ self error: newName , ' already exists'].
	oldDefinition := oldClass definition.
	newDefinition := oldDefinition 
				copyReplaceAll: '#' , oldClass name asString
				with: '#' , newName asString.
	^ Cursor wait showWhile: 
			[| newClass |
			newClass := Compiler evaluate: newDefinition logged: true.
			oldClass class instVarNames
				do: [ :each | newClass class addInstVarNamed: each ].
			newClass copyAllCategoriesFrom: oldClass.
			newClass class copyAllCategoriesFrom: oldClass class.
			newClass]! !

!ClassesUtils class methodsFor: 'copy-class' stamp: 'ewe 9/28/2012 11:56'!
copyClassAndSubclassOf: class suffix: suffix
	| o |
	o := OrderedCollection new.
	o add: class.
	o addAll: class allSubclasses .
	self copyClasses: o suffix: suffix .! !

!ClassesUtils class methodsFor: 'copy-class' stamp: 'ewe 10/10/2012 12:00'!
copyClasses: unordered suffix: suffix

	| ordered map  |
	ordered  := self orderClasses: unordered.
	 map := Dictionary new.
	ordered do: [ :cls | | cls2 pk2 |
		cls2 := self copyClass: cls  as: cls canonicalName , suffix.
		pk2 := self packageName:  cls  package packageName withSuffix:  suffix.  
		map at: cls put: cls2. 
		cls2 superclass removeSubclass: cls2 . 
		cls2 superclass: ( map at: cls2 superclass ifAbsent: [ cls2 superclass ]).	
		cls2 superclass addSubclass: cls2. 
		cls2 class superclass removeSubclass: cls2 class . 
		cls2 class superclass: ( map at: cls2 superclass ifAbsent: [ cls2 superclass ]) class.	
		cls2 class superclass addSubclass: cls2 class . 
		cls2 environment organization classify: cls2 name under: pk2	
		 ].
	! !

!ClassesUtils class methodsFor: 'copy-class' stamp: 'ewe 9/22/2011 09:10'!
copyPackage: packageName suffix: suffix

	self copyClasses: ( (PackageInfo named: packageName ) classes) suffix: suffix .! !

!ClassesUtils class methodsFor: 'backup-restore' stamp: 'ewe 9/23/2011 12:38'!
decompileSourceFor: aClass
	aClass methodDict keys do: [ :sel |
		(sel first = $_ or: [sel beginsWith: 'ctx'] ) ifFalse: [ 
			aClass compile: (aClass>>sel) decompileString. 
		]
	]! !

!ClassesUtils class methodsFor: 'diff' stamp: 'ewe 9/8/2011 11:31'!
diffClass: aClass with: anotherClass 

	| reporter |
	reporter := DiffReporter new from: aClass to: anotherClass .
	self diffInstVarsFor: aClass with: anotherClass using: reporter. 
	self diffMethodsFor: aClass with: anotherClass using: reporter.
	self diffInstVarsFor: aClass class with: anotherClass class using: reporter. 
	self diffMethodsFor: aClass class with: anotherClass class using: reporter! !

!ClassesUtils class methodsFor: 'diff' stamp: 'ewe 7/29/2011 15:56'!
diffClass: aClass with: anotherClass using: aReporter

	self diffInstVarsFor: aClass with: anotherClass using: aReporter. 
	self diffMethodsFor: aClass with: anotherClass using: aReporter! !

!ClassesUtils class methodsFor: 'diff' stamp: 'ewe 7/29/2011 15:58'!
diffInstVarsFor: aClass with: anotherClass using: aReporter 

	| setFrom setTo |
	setFrom := aClass allInstVarNames.
	setTo := anotherClass allInstVarNames .
	
	setFrom do: [ :instVar |  ( setTo includes: instVar ) ifFalse: [ aReporter notifyInstVarRemoved: instVar ]   ].
	setTo do: [ :instVar |  ( setFrom includes: instVar ) ifFalse: [ aReporter notifyInstVarAdded: instVar ]   ]! !

!ClassesUtils class methodsFor: 'diff' stamp: 'ewe 7/29/2011 16:18'!
diffMethodsFor: aClass with: anotherClass using: aReporter

	| setFrom setTo |
	setFrom := aClass methodDict.
	setTo := anotherClass methodDict .
	
	setFrom keysAndValuesDo: [ :selector :method   | 
		 ( anotherClass selectors includes: selector ) ifFalse: [ aReporter notifyMethodRemoved: selector body: method getSource   ]   ].
	
	setTo keysAndValuesDo: [ :selector :method   | 
		 ( aClass selectors includes: selector ) ifFalse: [ aReporter notifyMethodAdded: selector body: method getSource   ] 
			ifTrue: [ 
				| bodyFrom bodyTo |
				bodyFrom :=  (setFrom at: selector ) getSource.
				bodyTo := method getSource.  
				bodyFrom = bodyTo ifFalse: [
						aReporter notifyMethodChanged: selector from: bodyFrom to: bodyTo .   
					] .
			].  
		].
	
! !

!ClassesUtils class methodsFor: 'compilation-admin' stamp: 'ewe 11/14/2012 10:08'!
fillContextualClasses
	CurrentContext resetCache. 
	CurrentContext contextualClasses addAll: self classesOfKernelPrev .
	CurrentContext contextualClasses addAll: self classesOfKernelNext .
	CurrentContext contextualClasses addAll: self classesMetaOfKernelPrev . 
	CurrentContext contextualClasses addAll: self classesMetaOfKernelNext .
	CurrentContext contextualClasses addAll: self classesOfTests .
	CurrentContext contextualClasses addAll: self classesOfWebPrev .
	CurrentContext contextualClasses addAll: self classesOfWebNext .
	CurrentContext contextualClasses addAll: self classesMetaOfWebPrev .
	CurrentContext contextualClasses addAll: self classesMetaOfWebNext .	! !

!ClassesUtils class methodsFor: 'compilation-admin' stamp: 'ewe 11/19/2012 14:40'!
fixKernelAccessors
	| kernelToFix |

	"We need to fix the setter for the local optimized kernel classes (L1 or L2)"
	kernelToFix := OrderedCollection new.
	kernelToFix addAll: ( ClassesUtils classesOfPackage: 'ActiveContext2-Kernel' ). 
	kernelToFix addAll: ( ClassesUtils classesOfPackage: 'ActiveContext-Kernel' ).
	
	kernelToFix do: [ :cls |  ClassesUtils fixKernelAccessorsFor: cls ].
! !

!ClassesUtils class methodsFor: 'compilation-admin' stamp: 'ewe 11/27/2012 13:33'!
fixKernelAccessorsFor: aClass
	
	aClass allContextualInstVarNames do: [ :n | 
		| index set |
		index := aClass indexOfContextualInstVar: n.  
		(index>0 and: [ (aClass name endsWith: 'L1' ) or: [aClass name endsWith: 'L2'] ]) ifTrue: [
			set := 'ctxWrite', n , ': v2 __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: ' , index  asString  
			,' . self markOtherAsDirty: ' , index  asString , ' ]. ^ ' , n ,' := v2  '.	
			aClass compile: set . 
		].
		(index>0 and: [ (aClass name endsWith: 'S1' ) or: [aClass name endsWith: 'S2'] ]) ifTrue: [
			set := 'ctxWrite', n, ': v2 __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: ' , index  asString  
			,' . self markOtherAsDirty: ' , index  asString , ' ]. ^ ' , n ,' := v2  '.	
			aClass compile: set . 
		].
	]
! !

!ClassesUtils class methodsFor: 'compilation-admin' stamp: 'ewe 12/4/2012 14:59'!
generateAllAccessors
	
	CurrentContext contextualClasses do: [ :cls | 
		cls compilerClass = OptimizedContextualCompiler ifTrue: [
			self generateOptimizedAccessorsFor:  cls .
		].
	].
! !

!ClassesUtils class methodsFor: 'compilation-optimization' stamp: 'ewe 11/19/2012 15:39'!
generateCtxIdentityAccessor: cls
	
	self assert: cls isMeta not. 
	self assert: ( cls instVarNames includes: '__ctxIdentity__' ).
	cls compile: 'contextIdentity ^__ctxIdentity__'.
	cls compile: 'contextIdentity: id __ctxIdentity__ := id'.
	cls compile: 'identityHash ^ self contextIdentityHash'.! !

!ClassesUtils class methodsFor: 'compilation-optimization' stamp: 'ewe 11/16/2012 10:51'!
generateCtxInfoAccessor: cls
	
	self assert: cls isMeta not. 
	self assert: ( cls instVarNames includes: '__ctxInfo__' ).
	cls compile: 'contextInfo ^__ctxInfo__'.
	cls compile: 'contextInfo: info __ctxInfo__ := info'.! !

!ClassesUtils class methodsFor: 'compilation-optimization' stamp: 'ewe 11/16/2012 12:15'!
generateIsPrimitiveFalseFor: aClass
	aClass compile: 'isPrimitive ^ false'.! !

!ClassesUtils class methodsFor: 'compilation-optimization' stamp: 'ewe 11/16/2012 12:16'!
generateIsPrimitiveTrueFor: aClass
	aClass compile: 'isPrimitive ^ true'.! !

!ClassesUtils class methodsFor: 'compilation-optimization' stamp: 'ewe 12/4/2012 14:57'!
generateOptimizedAccessorsFor: aClass
	self generateOptimizedPerFieldAccessorsWithStatFor: aClass     ! !

!ClassesUtils class methodsFor: 'compilation-optimization' stamp: 'ewe 11/27/2012 13:32'!
generateOptimizedPerFieldAccessorsFor: aClass
	aClass contextualInstVarNames do: [
		:n | 
			| get set index | 
			index := aClass indexOfContextualInstVar: n.  
			(index>0) ifTrue: [
				get := 'ctxRead', n , ' __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: ' , index asString  , ' ]. ^  ', n.
				set := 'ctxWrite', n , ': v2 __ctxInfo__ ifNotNil: [ self synchronizeIfNecessary: ' , index  asString  ,' . self markOtherAsDirty: ' , index  asString , ' ]. ^ ' , n ,' := v2   '.	
			]
			ifFalse: [
				| nameWithAdaptedCase |
				nameWithAdaptedCase := '__',  n withFirstCharacterDownshifted.
				aClass isMeta ifFalse: [
					self error: 'Only meta class should have class variables'.
				] ifTrue: [
					| indexOfAdaptedVar |
					indexOfAdaptedVar := aClass indexOfContextualInstVar: nameWithAdaptedCase.  
					self assert: indexOfAdaptedVar >0. 
					get := 'ctxRead', n , ' __ctxInfo__ ifNotNil: [ self synchronizeIfNecessary: ' , indexOfAdaptedVar asString  , ' ]. ^  ', nameWithAdaptedCase.
					set := 'ctxWrite', n , ': v2 __ctxInfo__ ifNotNil:  [ self synchronizeIfNecessary: ' , indexOfAdaptedVar  asString  ,' . self markOtherAsDirty: ' , indexOfAdaptedVar  asString , ' ]. ^ ' , nameWithAdaptedCase ,' := v2   '.				
				].			
			].		
			aClass compile: get.
			aClass compile: set. 		
	]! !

!ClassesUtils class methodsFor: 'compilation-optimization' stamp: 'ewe 12/4/2012 14:56'!
generateOptimizedPerFieldAccessorsWithStatFor: aClass
	aClass contextualInstVarNames do: [
		:n | 
			| get set index | 
			index := aClass indexOfContextualInstVar: n.  
			(index>0) ifTrue: [
				
				get := 'ctxRead', n , ' 
				ContextStatistics trackLocalRead: self. 
				__ctxInfo__ ifNotNil:  [ 
					ContextStatistics trackSharedRead: self. 
					self synchronizeIfNecessary: ' , index asString  , ' ]. 
				^  ', n.
				
				set := 'ctxWrite', n , ': v2 
				ContextStatistics trackLocalWrite: self. 
				__ctxInfo__ ifNotNil: [ 
					ContextStatistics trackSharedWrite: self. 
					self synchronizeIfNecessary: ' , index  asString  ,' . 
					self markOtherAsDirty: ' , index  asString , ' ]. 
				^ ' , n ,' := v2   '.	
			]
			ifFalse: [
				| nameWithAdaptedCase |
				nameWithAdaptedCase := '__',  n withFirstCharacterDownshifted.
				aClass isMeta ifFalse: [
					self error: 'Only meta class should have class variables'.
				] ifTrue: [
					| indexOfAdaptedVar |
					indexOfAdaptedVar := aClass indexOfContextualInstVar: nameWithAdaptedCase.  
					self assert: indexOfAdaptedVar >0. 
					
					get := 'ctxRead', n , ' 
					ContextStatistics trackLocalRead: self.
					__ctxInfo__ ifNotNil: [ 
						ContextStatistics trackSharedRead: self. 
						self synchronizeIfNecessary: ' , indexOfAdaptedVar asString  , ' ]. 
					^  ', nameWithAdaptedCase.
					
					set := 'ctxWrite', n , ': v2
					ContextStatistics trackLocalWrite: self.
					__ctxInfo__ ifNotNil:  [ 
						ContextStatistics trackSharedWrite: self. 
						self synchronizeIfNecessary: ' , indexOfAdaptedVar  asString  ,' . 
						self markOtherAsDirty: ' , indexOfAdaptedVar  asString , ' ]. 
					^ ' , nameWithAdaptedCase ,' := v2   '.				
				].			
			].		
			aClass compile: get.
			aClass compile: set. 		
	]! !

!ClassesUtils class methodsFor: 'compilation-optimization' stamp: 'ewe 9/27/2012 15:52'!
generateOptimizedPerObjectAccessorsFor: aClass
	aClass contextualInstVarNames do: [
		:n | 
			| get set | 
			get := 'ctxRead', n , ' self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary ]. ^  ', n.
			set := 'ctxWrite', n , ': v2 self isCtxGlobal
			 ifTrue: [ self synchronizeIfNecessary; markOtherAsDirty ].  ^ ' , n ,' := v2  '.	
			aClass compile: get.
			aClass compile: set. 		
	]! !

!ClassesUtils class methodsFor: 'compilation-admin' stamp: 'ewe 11/2/2012 15:06'!
generateRecompileClass: cls
	
	ClassesUtils removeAccessorsFor: cls.   
	ClassesUtils generateOptimizedAccessorsFor:  cls .
	cls recompileAll . ! !

!ClassesUtils class methodsFor: 'compilation-optimization' stamp: 'ewe 9/27/2012 15:52'!
generateRegularAccessorsFor: aClass
	aClass contextualInstVarNames do: [
		:n |
			| get set |
			get := 'ctxRead', n , ' ^ ', n. 
			set := 'ctxWrite', n , ': v ^ ' , n ,' := v globalizeNoop '.	
			aClass compile: get.
			aClass compile: set. 		
	]! !

!ClassesUtils class methodsFor: 'initialize-release' stamp: 'ewe 12/4/2012 16:10'!
initalizeClasses
	| ctx1 ctx2 col |
	ctx1 := Context new.
	ctx2 := Context ancestor: ctx1.  
	CurrentContext prevMe: ctx1.
	CurrentContext nextMe: ctx2.
	ctx1 do: [
		( ClassesUtils classesOfPackage: 'ConsolidatedWeb1' ) do: [ :cls |
			"cls classPool removeAll. "
			 cls allContextInstVarsDo:   [ :varName :pos | 
				cls instVarNamed: varName put: nil. 	
			]
		].
	
		GRPharoPlatform1 initialize. 
		WASharedConfiguration1 initialize. 
		GRNumberPrinter1 initialize .
		
		col := Set new.  
		( ClassesUtils classesOfPackage: 'ConsolidatedWeb1' ) do: [ :cls |
			( cls class methodDict includesKey: #initialize ) ifTrue: [ 
				col add: cls. 
				col addAll: cls allSubclasses.
			]
		].
		col do: [ :cls | cls initialize ].
	].

	ctx1 release.
	ctx1 := nil.
	ctx2 := nil.	
	CurrentContext prevMe: nil.
	CurrentContext nextMe: nil.
	CurrentContext instance: nil.! !

!ClassesUtils class methodsFor: 'initialize-release' stamp: 'ewe 12/3/2012 12:59'!
initializeClassesNextAsDirty
	
		( ClassesUtils classesOfPackage: 'ConsolidatedWeb2' ) do: [ :cls |
			 cls contextInfo allDirtyBit: true. 
			cls classPool removeAll. 
			 cls allContextInstVarsDo:   [ :varName :pos | 
				cls instVarNamed: varName put: nil. 	
			]
		].! !

!ClassesUtils class methodsFor: 'compilation-inline' stamp: 'ewe 9/26/2011 15:27'!
inlineAccessorsFor: aClass
	aClass allContextualInstVarNames do: [ :s |
		| refRead refWrite |
		refRead := InlineAllSendersRefactoring 
		sendersOf:  ( #ctxRead , s ) asSymbol 
		in: aClass .
		refRead setOption: #inlineExpression
		toUse: [ :a :b | true ].
		[ refRead execute ] on: RBRefactoringError do: [] .
		refWrite := InlineAllSendersRefactoring 
		sendersOf:  ( #ctxWrite , s , ':' ) asSymbol 
		in: aClass .
		refWrite setOption: #inlineExpression
		toUse: [ :a :b | true ].
		[ refWrite execute ] on: RBRefactoringError do: [] .. 
	].
RefactoryChangeManager nuke.
RefactoringManager nuke .
	! !

!ClassesUtils class methodsFor: 'link' stamp: 'ewe 11/8/2012 10:46'!
linkClassPrev: prevSet withNext: nextSet 
	
	| map |
	(prevSet size = nextSet size) ifFalse: [
		self error: 'Sets have different sizes'.
	].
	map := Dictionary new.
	prevSet do: [ :prev |
		( map includesKey: prev canonicalNameWithSorL ) ifTrue: [ self error: 'Collision on prev set' ].
		map at: prev canonicalNameWithSorL put: prev.
	].
	nextSet do: [ :next |
		| prev |
		prev := map at: next canonicalNameWithSorL ifAbsent: [ self error: 'No valid prev class found'].
		self linkTheClassPrev: prev withNext:  next .
		map removeKey: next canonicalNameWithSorL .
	].



	
	! !

!ClassesUtils class methodsFor: 'link' stamp: 'ewe 11/14/2012 10:28'!
linkPackagePrev: prevName withNext: nextName  
	
	self linkClassPrev:
	( PackageInfo named: prevName) classes 
	withNext: 
	( PackageInfo named: nextName) classes .! !

!ClassesUtils class methodsFor: 'link' stamp: 'ewe 11/2/2012 14:23'!
linkTheClassPrev: prevClass withNext: nextClass
	
	| prevInfo nextInfo |
	
	( prevClass canonicalName = nextClass canonicalName ) ifFalse: [
		self error: 'Classes are not a valid pair of prev/next'	
	].
	
	prevInfo := ContextualInfo new.
	prevInfo global: true.
	prevInfo allDirtyBit: false. 
	prevInfo uuid: ( ContextualUUID newNamed: prevClass canonicalName ).
	prevInfo nextMe: nextClass. 
	prevClass contextInfo: prevInfo. 
	
	nextInfo := ContextualInfo new.
	nextInfo global: true.
	nextInfo allDirtyBit: false. 
	nextInfo uuid: ( ContextualUUID newNamed: nextClass canonicalName ).
	nextInfo prevMe: prevClass. 
	nextClass contextInfo: nextInfo. ! !

!ClassesUtils class methodsFor: 'rename' stamp: 'ewe 11/8/2012 11:16'!
movePackage: aPackageName inPackage: anotherPackageName

( PackageInfo named: aPackageName ) classes do: [ :cls | 
	cls environment organization classify: cls name under: anotherPackageName
	]! !

!ClassesUtils class methodsFor: 'rename' stamp: 'ewe 11/8/2012 16:52'!
movePackage: aPackageName inPackage: anotherPackageName rename: aBlock

( PackageInfo named: aPackageName ) classes do: [ :cls | 
	cls rename:  ( aBlock value: cls name ).
	cls environment organization classify: cls name under: anotherPackageName
	]! !

!ClassesUtils class methodsFor: 'compilation-optimization' stamp: 'ewe 8/31/2011 12:04'!
optimizeClass: aClass
	self generateOptimizedAccessorsFor: aClass .
	aClass class compile: 'compilerClass ^ OptimizedContextualCompiler '.
	aClass recompileAll.     ! !

!ClassesUtils class methodsFor: 'copy-class' stamp: 'ewe 9/6/2011 13:29'!
orderClasses: original
	| ordered unordered t |
	
	ordered := OrderedCollection new.
	unordered := OrderedCollection new.
	unordered addAll: original .
	
	[ unordered size > 0 ] whileTrue: [  
		t := unordered copy.
		t do: [ :cls |
			( t includes: cls superclass ) ifFalse: [ ordered add: cls. unordered  remove: cls  ].  
		].
	].

	^ ordered. ! !

!ClassesUtils class methodsFor: 'copy-class' stamp: 'ewe 9/22/2011 09:18'!
packageName: originalName withSuffix: suffix

| items |
 items := '-' split: originalName. 
items at: 1 put: ( items at: 1) , suffix. 
^ '-' join: items . ! !

!ClassesUtils class methodsFor: 'initialize-release' stamp: 'ewe 12/3/2012 12:09'!
reclaimPrev
	| semaphore |
	semaphore := Semaphore new.
	[
		[ CurrentContext prevMe releaseRoots ]  
		ensure: [semaphore signal]
	] forkAt: Processor userBackgroundPriority.
	semaphore wait.! !

!ClassesUtils class methodsFor: 'compilation-admin' stamp: 'ewe 11/12/2012 13:46'!
recompileAllClasses
	self recompileClasses: CurrentContext contextualClasses.! !

!ClassesUtils class methodsFor: 'compilation-admin' stamp: 'ewe 11/12/2012 13:57'!
recompileAllClassesOfPackage: aName 
	self recompileClasses: ( PackageInfo named: aName ) classes .
	self recompileClasses: (( PackageInfo named: aName ) classes collect: [:cls | cls class]).! !

!ClassesUtils class methodsFor: 'compilation-admin' stamp: 'ewe 11/12/2012 13:46'!
recompileClasses: aSet 
	aSet do: [ :cls | cls recompileAll  ].! !

!ClassesUtils class methodsFor: 'compilation-optimization' stamp: 'ewe 9/26/2012 11:41'!
removeAccessorsFor: aClass
	aClass allContextualInstVarNames do: [
		:n |
			| get set |
			get := 'ctxRead', n . 
			set := 'ctxWrite', n , ':'.	
			aClass removeSelector: get asSymbol.  		
			aClass removeSelector: set asSymbol. 
	]! !

!ClassesUtils class methodsFor: 'compilation-admin' stamp: 'ewe 9/27/2012 15:49'!
removeAllAccessors
	CurrentContext contextualClasses do: [ :cls | 		
		self removeAccessorsFor: cls.   
	].  ! !

!ClassesUtils class methodsFor: 'compilation-admin' stamp: 'ewe 9/27/2012 15:50'!
removeGenerateRecompileAllClasses
	self removeAllAccessors .
	self generateAllAccessors .
	self recompileAllClasses .! !

!ClassesUtils class methodsFor: 'backup-restore' stamp: 'ewe 9/23/2011 12:40'!
restoreMethodsFor: aClass

	aClass methodDict values do: [ :m |
		| src |
		src := m getSource. 
		(src first = $_ )  ifTrue: [	aClass compile:  ( src copyFrom: 2 to: src size ).  ].
	]! !

!ClassesUtils class methodsFor: 'initialize-release' stamp: 'ewe 12/3/2012 12:23'!
sizeOfPrevGlobalGraph
| roots all |
all:= IdentitySet new.
roots := CurrentContext prevMe roots. 
roots do: [ :root | root traverseAndDo: [:prev | ] exclude: all. ].
^ ( all select: [ :o | o isCtxGlobal ] ) size ! !

!ClassesUtils class methodsFor: 'rename' stamp: 'ewe 7/29/2011 16:45'!
suffixPackage: aPackageName with:  aSuffix

| newPackage |

newPackage := aPackageName , aSuffix .

( PackageInfo named: aPackageName ) classes do: [ :cls | 
	cls rename: ( cls name , aSuffix  ).
	cls environment organization classify: cls name under: newPackage
	]! !

Object subclass: #Context
	instanceVariableNames: 'ancestor classes captures lock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Core'!

!Context class methodsFor: 'as yet unclassified' stamp: 'ewe 7/5/2011 16:36'!
ancestor: anAncestor
	^ self new ancestor: anAncestor .  ! !

!Context class methodsFor: 'as yet unclassified' stamp: 'ewe 9/6/2011 21:03'!
newRoot
	^ self new postInitialize .! !

!Context methodsFor: 'gc' stamp: 'ewe 11/26/2012 13:17'!
addCapture: anObject
	^ captures add: anObject. 
! !

!Context methodsFor: 'initialize-release' stamp: 'ewe 9/7/2011 14:09'!
ancestor
		^ ancestor get.! !

!Context methodsFor: 'initialize-release' stamp: 'ewe 11/2/2012 14:10'!
ancestor: anAncestor
	ancestor set: anAncestor .
	
	self flag: 'Not elegant'.
	CurrentContext prevMe: anAncestor..
	CurrentContext nextMe: self .

	"anAncestor captures migrateToNextIfNecessary.
	captures := anAncestor captures nextMe."
	
	"self postInitialize. "
	
	anAncestor classes keysAndValuesDo: [ 
		:key :value | classes at: key put: value ]  ! !

!Context methodsFor: 'initialize-release' stamp: 'ewe 11/22/2012 14:41'!
bind: aUuid to: aContextualObject 
	| identity |
	identity := ContextualUUID newNamed: aUuid .  
	(aContextualObject isCtxGlobal and: [ aContextualObject contextIdentity ~=  identity ]) ifTrue: [ Abort signal: 'binding a global to an invalid UUID'].
	classes at: aUuid put: aContextualObject.
! !

!Context methodsFor: 'gc' stamp: 'ewe 11/2/2012 12:08'!
captures
	^ captures 
! !

!Context methodsFor: 'gc' stamp: 'ewe 11/2/2012 12:20'!
classes
	^classes! !

!Context methodsFor: 'dynamic-scoping' stamp: 'ewe 9/13/2011 17:13'!
do: aBlock
	| oldCtx |
	oldCtx := CurrentContext instance.
	CurrentContext instance: self.
	[ 
		^ [  aBlock value ] 
		   on: CurrentContextNotification 
		   do: [ :ex |
				 "Transcript show: 'Resume exception' ; cr. "
				ex resume: self ].
	] ensure: 
	[ CurrentContext instance: oldCtx   ]  	! !

!Context methodsFor: 'dynamic-scoping' stamp: 'ewe 7/6/2011 09:22'!
do: aBlock with: anObject
	| adaptedObject |
	adaptedObject := self globalizeAndAdaptReference: anObject.  
	^ self do:  [ aBlock value: adaptedObject   ].

  ! !

!Context methodsFor: 'dynamic-scoping' stamp: 'ewe 7/6/2011 09:30'!
do: aBlock with: anObject with: anObject2
	| adaptedObject  adaptedObject2  |
	adaptedObject := self globalizeAndAdaptReference: anObject.  
	adaptedObject2 := self globalizeAndAdaptReference: anObject2.  
	^ self do:  [ aBlock value: adaptedObject  value: adaptedObject2  ].
  ! !

!Context methodsFor: 'dynamic-scoping' stamp: 'ewe 7/6/2011 09:30'!
do: aBlock with: anObject with: anObject2 with: anObject3
	| adaptedObject  adaptedObject2 adaptedObject3  |
	adaptedObject := self globalizeAndAdaptReference: anObject.  
	adaptedObject2 := self globalizeAndAdaptReference: anObject2.  
	adaptedObject3 := self globalizeAndAdaptReference: anObject3.  
	^ self do:  [ aBlock value: adaptedObject  value: adaptedObject2 value: adaptedObject3  ].! !

!Context methodsFor: 'dynamic-scoping' stamp: 'ewe 7/6/2011 09:31'!
do: aBlock with: anObject with: anObject2 with: anObject3 with: anObject4
	| adaptedObject  adaptedObject2 adaptedObject3 adaptedObject4  |
	adaptedObject := self globalizeAndAdaptReference: anObject.  
	adaptedObject2 := self globalizeAndAdaptReference: anObject2.  
	adaptedObject3 := self globalizeAndAdaptReference: anObject3.  
	adaptedObject4 := self globalizeAndAdaptReference: anObject4. 
	^ self do:  [ aBlock value: adaptedObject  value: adaptedObject2 value: adaptedObject3 value: adaptedObject4  ].
  ! !

!Context methodsFor: 'gc' stamp: 'ewe 9/7/2011 14:20'!
executor
	^ super executor. ! !

!Context methodsFor: 'gc' stamp: 'ewe 11/22/2012 15:06'!
finalize
	Transcript show: 'Finalize ', self class name, ' ', self identityHash asString ;cr.
	^ self release.! !

!Context methodsFor: 'internal' stamp: 'ewe 11/15/2012 10:10'!
globalizeAndAdaptReference: anObject
	| uuid ctx  |
	
	anObject isPrimitive ifTrue: [ ^ anObject ].
	CurrentContext instance = self ifTrue: [ ^ anObject ].
	
	anObject migrateToNextIfNecessary.
	uuid := anObject uuid.   
	
	"CurrentContext is the caller context, we put the object there. It's normally the ancestor of this context."
	"ctx := CurrentContext instance."
	( self ancestor = CurrentContext instance )ifFalse: [ self halt. ].
	ctx := self ancestor. 
	
	ctx captures add: anObject.   
	self captures add: anObject nextMe.
	

	self flag: 'The UUID can be removed from the list of global after the do:with: has completed. Indeed, object globalized because of closre 
	are not reachable like other global. The object remains global, but not reachable .' .

	^  anObject nextMe. 
! !

!Context methodsFor: 'initialize-release' stamp: 'ewe 11/26/2012 13:33'!
initialize 
	captures := OrderedCollection new.
	classes := Dictionary new. 
	ancestor := WeakReference new.
	lock := Semaphore forMutualExclusion. 
	WeakRegistry default add: self.! !

!Context methodsFor: 'public-api' stamp: 'ewe 10/12/2012 15:49'!
invalidateNext: aPrev index: index
aPrev  nextMe dirtyBit: index set: true. ! !

!Context methodsFor: 'public-api' stamp: 'ewe 10/12/2012 15:49'!
invalidatePrev: aNext index: index
aNext  prevMe dirtyBit: index set: true. ! !

!Context methodsFor: 'public-api' stamp: 'ewe 8/19/2011 11:26'!
migrateToNext: anObject
	
	^ anObject defMigrateToNext ! !

!Context methodsFor: 'public-api' stamp: 'ewe 8/19/2011 11:27'!
migrateToPrev: anObject

	^ anObject defMigrateToPrev ! !

!Context methodsFor: 'initialize-release' stamp: 'ewe 9/6/2011 14:32'!
postInitialize ! !

!Context methodsFor: 'gc' stamp: 'ewe 11/23/2012 14:33'!
release
	"Needs to be done in two steps. Indeed migration checks if next/prev is nil to know if object was migrated or not, which interfers with the process of nuking references next/prev."
	
	| visited |
	visited := IdentitySet new.
	self captures do: [ :obj | obj forceSynchronization: visited  ].
	visited := IdentitySet new.
	self captures do: [ :obj | obj forceRelease: visited  ]. 
! !

!Context methodsFor: 'gc' stamp: 'ewe 8/17/2011 16:00'!
releaseAncestor
	ancestor release. 
	ancestor := nil.! !

!Context methodsFor: 'gc' stamp: 'ewe 12/3/2012 12:16'!
releaseRoots
	"Needs to be done in two steps. Indeed migration checks if next/prev is nil to know if object was migrated or not, which interfers with the process of nuking references next/prev."
	| roots visited |
	
	roots := self roots. 	
	visited := IdentitySet new.
	roots do: [ :obj | obj forceSynchronization: visited ].
	visited := IdentitySet new.
	roots do: [ :obj | obj forceRelease: visited ]. 
! !

!Context methodsFor: 'internal' stamp: 'ewe 11/2/2012 14:05'!
resolve: aUuid ifAbsent: aBlock
	^ classes at: aUuid ifAbsent: aBlock. ! !

!Context methodsFor: 'public-api' stamp: 'ewe 11/6/2012 10:49'!
resolveClass: aClassName self halt.
	^ self resolve: aClassName ifAbsent:   [ Smalltalk at: aClassName ].! !

!Context methodsFor: 'gc' stamp: 'ewe 12/3/2012 12:15'!
roots
	| roots  |
	roots := OrderedCollection new. 
	roots addAll: self captures. 
	roots addAll: ( ClassesUtils classesOfPackage: 'ConsolidatedWeb1' ).
	^roots. ! !

!Context methodsFor: 'public-api' stamp: 'ewe 10/12/2012 15:15'!
synchronizeFromNext: aPrev index: index
	^ aPrev defSynchronizeFromNext: index! !

!Context methodsFor: 'public-api' stamp: 'ewe 10/12/2012 15:16'!
synchronizeFromPrev: aNext index: index
	^ aNext defSynchronizeFromPrev: index! !

Context subclass: #TestContext
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Tests'!

TestContext subclass: #Page1Context
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Tests'!

!Page1Context methodsFor: 'as yet unclassified' stamp: 'ewe 8/19/2011 11:39'!
migrateToNext: anObject
	self fail: 'Should not be called'.  ! !

!Page1Context methodsFor: 'as yet unclassified' stamp: 'ewe 8/19/2011 09:50'!
migrateToPrev: anObject
	self fail: 'Should not be called'.  ! !

!Page1Context methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 15:14'!
synchronizeFromNext: anObject index: anObject1
	self fail: 'Should not be called'.  ! !

!Page1Context methodsFor: 'as yet unclassified' stamp: 'ewe 10/12/2012 15:13'!
synchronizeFromPrev: anObject index: anObject1
	self fail: 'Should not be called'.  ! !

TestContext subclass: #Page2Context
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Tests'!

!Page2Context methodsFor: 'as yet unclassified' stamp: 'ewe 8/19/2011 11:38'!
migrateToNext: anObject
	( anObject class = Page1) ifTrue: [
		^ Page2 basicNew globalize: anObject uuid. 	
	]  .
	( anObject = Page1 ) ifTrue: [
		^ Page2.
	].
	( anObject class = HtmlPage1) ifTrue: [
		^ HtmlPage2 basicNew globalize: anObject uuid. 	
	]  .
	( anObject = HtmlPage1 ) ifTrue: [
		^ HtmlPage2.
	].
	^ super migrateToNext: anObject 
	    ! !

!Page2Context methodsFor: 'as yet unclassified' stamp: 'ewe 8/19/2011 10:54'!
migrateToPrev: anObject
	( anObject class = Page2) ifTrue: [
		^ Page1 basicNew globalize: anObject uuid. 	
	]  .
	( anObject = Page2 ) ifTrue: [
		^ Page1
	].
	( anObject class = HtmlPage2) ifTrue: [
		^ HtmlPage1 basicNew globalize: anObject uuid. 	
	]  .
	( anObject = HtmlPage2 ) ifTrue: [
		^ HtmlPage1.
	].
	^ super migrateToPrev: anObject 
	    
	  ! !

!Page2Context methodsFor: 'as yet unclassified' stamp: 'ewe 11/2/2012 11:33'!
synchronizeFromNext: anObject index: index
	anObject class = HtmlPage1
		ifTrue: [ 
			| p2 header body |
			p2 := anObject nextMe.
			header := p2 instVarNamed: #header.
			body := p2 instVarNamed: #body.
			anObject instVarNamed: #html put: header , body.
			anObject instVarNamed: #name put: (p2 instVarNamed: #name).
			^ self ].
	^ super synchronizeFromNext: anObject index: index! !

!Page2Context methodsFor: 'as yet unclassified' stamp: 'ewe 11/2/2012 11:32'!
synchronizeFromPrev: anObject index: index
	anObject class = HtmlPage2
		ifTrue: [ 
			| p1 html header body |
			p1 := anObject prevMe.
			html := p1 instVarNamed: #html.
			header := (html allRegexMatches: '<header>(.*)</header>') at: 1.
			body := (html allRegexMatches: '<body>(.*)</body>') at: 1.
			anObject instVarNamed: #header put: header.
			anObject instVarNamed: #body put: body.
			anObject instVarNamed: #name put: (p1 instVarNamed: #name).
			^ self ].
	^ super synchronizeFromPrev: anObject index: index! !

TestContext subclass: #SingletonContext
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Tests'!

!SingletonContext methodsFor: 'as yet unclassified' stamp: 'ewe 9/6/2011 16:29'!
migrateToNext: anObject
	( anObject = Singleton1 ) ifTrue: [
		^ Singleton2.
	].
	^ super migrateToNext: anObject 
	    ! !

!SingletonContext methodsFor: 'as yet unclassified' stamp: 'ewe 9/6/2011 14:41'!
migrateToPrev: anObject
	( anObject = Singleton2 ) ifTrue: [
		^ Singleton1
	].
	^ super migrateToPrev: anObject 
	    
	  ! !

!SingletonContext methodsFor: 'as yet unclassified' stamp: 'ewe 11/2/2012 17:13'!
synchronizeFromNext: anObject index: index
	^ super synchronizeFromNext: anObject index: index! !

!SingletonContext methodsFor: 'as yet unclassified' stamp: 'ewe 11/6/2012 11:49'!
synchronizeFromPrev: anObject index: index
	^ super synchronizeFromPrev: anObject index: index! !

!TestContext methodsFor: 'as yet unclassified' stamp: 'ewe 11/22/2012 14:13'!
release
	"no op"! !

Object subclass: #ContextStatistics
	instanceVariableNames: 'counters'
	classVariableNames: 'Invoked LocalRead LocalWrite Resolve SharedRead SharedWrite Track'
	poolDictionaries: ''
	category: 'ActiveContext-Core'!

!ContextStatistics class methodsFor: 'accessors' stamp: 'ewe 12/4/2012 14:14'!
invokationStatistics
	Invoked ifNil: [ Invoked := self new ].
	^ Invoked.! !

!ContextStatistics class methodsFor: 'accessors' stamp: 'ewe 12/4/2012 14:05'!
localReadStatistics
	LocalRead ifNil: [ LocalRead := self new ].
	^ LocalRead. ! !

!ContextStatistics class methodsFor: 'accessors' stamp: 'ewe 12/4/2012 14:06'!
localWriteStatistics
	LocalWrite ifNil: [ LocalWrite := self new ].
	^ LocalWrite. ! !

!ContextStatistics class methodsFor: 'initialize-release' stamp: 'ewe 12/4/2012 14:15'!
resetAll
	SharedRead := nil.
	SharedWrite := nil.
	LocalWrite := nil.
	LocalRead := nil.
	Invoked := nil.
	Resolve := nil. 
	
"	self sharedReadStatistics reset.
	self sharedWriteStatistics reset.
	self localWriteStatistics reset.
	self localReadStatistics reset. 
	self resolveStatistics reset.  
	self invokationStatistics reset. "! !

!ContextStatistics class methodsFor: 'as yet unclassified' stamp: 'ewe 8/31/2011 10:24'!
resolveStatistics
	Resolve ifNil: [ Resolve := self new ].
	^ Resolve.! !

!ContextStatistics class methodsFor: 'accessors' stamp: 'ewe 12/4/2012 14:09'!
sharedReadStatistics
	SharedRead ifNil: [ SharedRead := self new ].
	^ SharedRead. ! !

!ContextStatistics class methodsFor: 'accessors' stamp: 'ewe 12/4/2012 14:05'!
sharedWriteStatistics
	SharedWrite ifNil: [ SharedWrite := self new ].
	^ SharedWrite. ! !

!ContextStatistics class methodsFor: 'track' stamp: 'ewe 12/4/2012 14:12'!
trackInvocation: anObject
	self invokationStatistics increment: anObject .! !

!ContextStatistics class methodsFor: 'track' stamp: 'ewe 12/4/2012 14:52'!
trackLocalRead: anObject
	self localReadStatistics  increment: anObject .! !

!ContextStatistics class methodsFor: 'track' stamp: 'ewe 12/4/2012 14:53'!
trackLocalWrite: anObject
	self localWriteStatistics increment: anObject .! !

!ContextStatistics class methodsFor: 'track' stamp: 'ewe 12/4/2012 14:52'!
trackSharedRead: anObject
	self sharedReadStatistics  increment: anObject .! !

!ContextStatistics class methodsFor: 'track' stamp: 'ewe 12/4/2012 14:52'!
trackSharedWrite: anObject
	self sharedWriteStatistics increment: anObject .! !

!ContextStatistics methodsFor: 'as yet unclassified' stamp: 'ewe 8/31/2011 10:22'!
counter: key
	^ counters at: key ifAbsent: [ 0 ].! !

!ContextStatistics methodsFor: 'as yet unclassified' stamp: 'ewe 8/31/2011 10:22'!
decrement: key
	| value |
	value :=  counters at: key ifAbsent: [ 1 ].
	 counters at: key put: value - 1.  ! !

!ContextStatistics methodsFor: 'as yet unclassified' stamp: 'ewe 8/31/2011 10:22'!
increment: key
	| value |
	value := counters at: key ifAbsent: [ 0 ].
	counters at: key put: value + 1.  ! !

!ContextStatistics methodsFor: 'as yet unclassified' stamp: 'ewe 12/4/2012 14:03'!
initialize 
	counters := IdentityDictionary  new.! !

!ContextStatistics methodsFor: 'as yet unclassified' stamp: 'ewe 8/31/2011 10:23'!
reset
	counters := Dictionary new.! !

!ContextStatistics methodsFor: 'as yet unclassified' stamp: 'ewe 8/31/2011 10:23'!
statistics
	^ counters associations sorted: [ :a :b | a value <= b value ].! !

!ContextStatistics methodsFor: 'as yet unclassified' stamp: 'ewe 9/13/2011 19:11'!
sum
	| s|
	s := 0.
	counters valuesDo: [ :v| s := s + v ].
	^ s.   ! !

Object subclass: #ContextualInfo
	instanceVariableNames: 'prev next dirtyBits global uuid'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Core'!

!ContextualInfo methodsFor: 'accessing' stamp: 'ewe 10/11/2012 15:12'!
allDirtyBit: anObject
"16rFF bitAnd: (1 bitShift: 3)"
	dirtyBits := Array new: 20.
	anObject ifTrue: [
		dirtyBits fillWith: true   ]
	ifFalse: [ 
		dirtyBits fillWith: false   ]! !

!ContextualInfo methodsFor: 'accessing' stamp: 'ewe 10/11/2012 15:12'!
clear
	prev:=nil.
	next:=nil.
	"uuid:=nil. "
	self allDirtyBit: false. 
	! !

!ContextualInfo methodsFor: 'accessing' stamp: 'ewe 1/15/2012 15:33'!
dirtyBit: index
	^ dirtyBits at: index! !

!ContextualInfo methodsFor: 'accessing' stamp: 'ewe 1/15/2012 15:34'!
dirtyBit: index set: bit
	^ dirtyBits at: index put: bit! !

!ContextualInfo methodsFor: 'accessing' stamp: 'ewe 1/16/2012 14:12'!
dirtyBits
	^ dirtyBits! !

!ContextualInfo methodsFor: 'accessing' stamp: 'ewe 1/16/2012 14:12'!
dirtyBits: anObject
	dirtyBits := anObject! !

!ContextualInfo methodsFor: 'accessing' stamp: 'ewe 5/19/2011 14:18'!
global
	self flag: 'to remove'.
	^ global! !

!ContextualInfo methodsFor: 'accessing' stamp: 'ewe 5/19/2011 14:18'!
global: anObject
	self flag: 'to remove'.
	global := anObject! !

!ContextualInfo methodsFor: 'accessing' stamp: 'ewe 10/11/2012 15:13'!
hasDirtyBit
	^ dirtyBits at: 1! !

!ContextualInfo methodsFor: 'accessing' stamp: 'ewe 8/24/2011 15:06'!
nextMe
	^ next! !

!ContextualInfo methodsFor: 'accessing' stamp: 'ewe 8/24/2011 15:07'!
nextMe: anObject
	next := anObject! !

!ContextualInfo methodsFor: 'accessing' stamp: 'ewe 8/24/2011 15:08'!
prevMe
	^ prev! !

!ContextualInfo methodsFor: 'accessing' stamp: 'ewe 8/24/2011 15:07'!
prevMe: anObject
	prev := anObject! !

!ContextualInfo methodsFor: 'accessing' stamp: 'ewe 5/19/2011 14:01'!
uuid
	^ uuid! !

!ContextualInfo methodsFor: 'accessing' stamp: 'ewe 5/19/2011 14:01'!
uuid: anObject
	uuid := anObject! !

Object subclass: #ContextualUUID
	instanceVariableNames: 'uuid lock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Core'!

!ContextualUUID class methodsFor: 'as yet unclassified' stamp: 'ewe 11/22/2012 14:43'!
newFor: anObject
	^ self new uuid: anObject primIdentityHash. ! !

!ContextualUUID class methodsFor: 'as yet unclassified' stamp: 'ewe 1/16/2012 14:32'!
newNamed: aName
	^ self new uuid: aName. ! !

!ContextualUUID methodsFor: 'as yet unclassified' stamp: 'ewe 1/16/2012 14:26'!
= anotherObject
 ^ uuid = anotherObject uuid. ! !

!ContextualUUID methodsFor: 'as yet unclassified' stamp: 'ewe 1/16/2012 14:28'!
hash
	^ uuid hash. ! !

!ContextualUUID methodsFor: 'as yet unclassified' stamp: 'ewe 1/16/2012 14:32'!
initialize
	lock := Semaphore forMutualExclusion.  ! !

!ContextualUUID methodsFor: 'as yet unclassified' stamp: 'ewe 1/16/2012 14:27'!
lock
	^ lock.! !

!ContextualUUID methodsFor: 'as yet unclassified' stamp: 'ewe 1/16/2012 14:27'!
uuid 
	^ uuid.! !

!ContextualUUID methodsFor: 'as yet unclassified' stamp: 'ewe 1/16/2012 14:33'!
uuid: aUuid
	uuid := aUuid .! !

Object subclass: #CurrentContext
	instanceVariableNames: ''
	classVariableNames: 'Contextual Latest Lock Next Normalized Prev'
	poolDictionaries: ''
	category: 'ActiveContext-Core'!

!CurrentContext class methodsFor: 'as yet unclassified' stamp: 'ewe 9/2/2011 15:36'!
contextualClasses 
	^ Contextual ifNil: [ Set new ]! !

!CurrentContext class methodsFor: 'as yet unclassified' stamp: 'ewe 6/6/2012 12:19'!
initLock
	Lock := Semaphore  forMutualExclusion .! !

!CurrentContext class methodsFor: 'as yet unclassified' stamp: 'ewe 9/7/2011 14:17'!
initialize 
	Prev := WeakReference new. ! !

!CurrentContext class methodsFor: 'as yet unclassified' stamp: 'ewe 9/13/2011 17:19'!
instance
	^ Processor activeProcess environmentAt: #activeContext ifAbsent: [ CurrentContextNotification signal ] 
	"^ CurrentContextNotification signal. "! !

!CurrentContext class methodsFor: 'as yet unclassified' stamp: 'ewe 9/14/2011 10:37'!
instance: anObject
	Processor activeProcess environmentAt: #activeContext put: anObject .
	! !

!CurrentContext class methodsFor: 'as yet unclassified' stamp: 'ewe 8/15/2011 17:13'!
latest
	^ Latest  ! !

!CurrentContext class methodsFor: 'as yet unclassified' stamp: 'ewe 8/15/2011 17:13'!
latest: aContext
	Latest := aContext .! !

!CurrentContext class methodsFor: 'as yet unclassified' stamp: 'ewe 6/6/2012 12:18'!
lock
	^ Lock! !

!CurrentContext class methodsFor: 'as yet unclassified' stamp: 'ewe 8/24/2011 15:06'!
nextMe
	^ Next ! !

!CurrentContext class methodsFor: 'as yet unclassified' stamp: 'ewe 8/24/2011 15:07'!
nextMe: aContext
	Next := aContext .! !

!CurrentContext class methodsFor: 'as yet unclassified' stamp: 'ewe 9/2/2011 15:36'!
normalizedClasses 
	^ Normalized  ifNil: [ Set new ]! !

!CurrentContext class methodsFor: 'as yet unclassified' stamp: 'ewe 9/7/2011 14:17'!
prevMe
	^ Prev get.! !

!CurrentContext class methodsFor: 'as yet unclassified' stamp: 'ewe 11/13/2012 15:05'!
prevMe: aContext
	Prev set: aContext.! !

!CurrentContext class methodsFor: 'as yet unclassified' stamp: 'ewe 9/22/2011 13:51'!
resetCache
	
	Contextual := Set new.. 
	Normalized  := Set new. .! !

Object subclass: #DebugUtils
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Utils'!

DebugUtils class
	instanceVariableNames: 'flag'!

DebugUtils class
	instanceVariableNames: 'flag'!

!DebugUtils class methodsFor: 'as yet unclassified' stamp: 'ewe 11/23/2012 11:18'!
doOnce: aBlock andThe: anotherBlock
	flag isNil
		ifTrue: [ 
			flag := true.
			[ ^ aBlock value ] ensure: [ flag := nil ] ]
		ifFalse: [ ^ anotherBlock value ]	

"    (Processor activeProcess environmentAt: #level ifAbsent: [ nil ] ) isNil ifTrue:    
   [
	Processor activeProcess environmentAt: #level put: #meta .
	[ ^ aBlock value.  ] ensure:
	[ Processor activeProcess environmentAt: #level put: nil. ].
   ]  ifFalse: 
   [
   	^ anotherBlock value.
   ]. "! !

Object subclass: #DiffReporter
	instanceVariableNames: 'from to'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Utils'!

!DiffReporter methodsFor: 'as yet unclassified' stamp: 'ewe 7/29/2011 15:57'!
from: aClass to: anotherClass
	from := aClass .
	to := anotherClass .! !

!DiffReporter methodsFor: 'as yet unclassified' stamp: 'ewe 7/29/2011 16:14'!
notifyInstVarAdded: anInstVar  

	Transcript show: ( to name , '. ' ,  anInstVar , ' added' )  ; cr.
	! !

!DiffReporter methodsFor: 'as yet unclassified' stamp: 'ewe 7/29/2011 16:14'!
notifyInstVarRemoved: anInstVar  

	Transcript show: ( from name , '. ' ,  anInstVar , ' removed' )  ; cr.! !

!DiffReporter methodsFor: 'as yet unclassified' stamp: 'ewe 7/29/2011 16:13'!
notifyMethodAdded: selector body: body  

		Transcript show: ( to name , '>> ' ,  selector , ' added' ) ; cr.! !

!DiffReporter methodsFor: 'as yet unclassified' stamp: 'ewe 7/29/2011 16:14'!
notifyMethodChanged: selector from: oldBody to: newBody   

			Transcript show: ( from name , '>> ' ,  selector , ' and ' , to name , '>>' , selector,   ' differ' ) ; cr.! !

!DiffReporter methodsFor: 'as yet unclassified' stamp: 'ewe 7/29/2011 16:14'!
notifyMethodRemoved: selector body: body

		Transcript show: ( from name , '>> ' ,  selector , ' removed' ) ; cr.! !

Object subclass: #MemoryUtils
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Utils'!

!MemoryUtils class methodsFor: 'as yet unclassified' stamp: 'ewe 12/4/2012 13:53'!
sizeOfObject: anObject
	| headerSize instanceSize variableSize |
	headerSize := anObject class indexIfCompact > 0
		ifTrue: [ 4 ]
		ifFalse: [ 8 ].
	instanceSize := anObject class instSize.
	variableSize := anObject class isBytes
		ifTrue: [ anObject basicSize ]
		ifFalse: [
			anObject class isWords
				ifTrue: [ Smalltalk wordSize * anObject basicSize ]
				ifFalse: [ Smalltalk wordSize * anObject basicSize // 2 ] ].
	^ headerSize + instanceSize + variableSize! !

!Object class methodsFor: '*ActiveContext' stamp: 'ewe 11/12/2012 16:46'!
compilerClass 
	
	( CurrentContext contextualClasses  includes: self  ) ifTrue: [
		"Transcript show:( 'Contextual compiler for ',  self asString  ); cr. "
		  ^OptimizedContextualCompiler 
	].
	(  CurrentContext normalizedClasses includes: self  ) ifTrue: [
		Transcript show:( 'Normalized compiler for ',  self asString  ); cr.
		  ^NormalizedCompiler.
	].
	((PackageInfo named: 'ExcludedWeb1') classes includes: self  ) ifTrue: [
		^ StaticResolutionCompiler. 	
	].
	^ super compilerClass .! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 11/6/2012 09:59'!
--> anObject
	"Answer an Association between self and anObject"

	^ (self ctxClass: #Association) basicNew key: self value: anObject! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 12/4/2012 14:09'!
_ctxRead: f 
		"ContextStatistics readStatistics increment: self class. "
		
		self isCtxGlobal  ifTrue: [    
			"self dirty ifTrue: [  Transcript show: 'ctxRead ', f , '[', Processor activeProcess identityHash , ']' ;cr.   ]."
			self synchronizeIfNecessary.
			^ self ctxInstVarNamed: f.  
		]
		ifFalse: [
			^ self ctxInstVarNamed: f .   	
		]  
	! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 12/4/2012 14:09'!
_ctxWrite: f value: v
		"ContextStatistics writeStatistics increment: self class. "
		  
		self isCtxGlobal  ifTrue: [    
			"self dirty ifTrue: [  Transcript show: 'ctxWrite ', f,  '[', Processor activeProcess identityHash , ']' ;cr.   ]."
			self synchronizeIfNecessary.
			self markOtherAsDirty .
			^ self ctxInstVarNamed: f put: v globalize. 
		]
		ifFalse: [
			^ self ctxInstVarNamed: f put: v.   	
		]
	! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 11/22/2012 16:09'!
allContextInstVarsDo: aBlock 
	| instVarz |
	"TODO could be avoided if vars were always first positions"
	instVarz := self class allInstVarNames. 
	1 to: self class instSize do: [ :pos |
		| varName |
		varName := instVarz at: pos. 
		varName isContextReservedVar ifFalse: [
			aBlock value: varName value: pos. 
		]		
	].! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 10/11/2012 15:12'!
allDirtyBit: flag
	( self contextInfo isNil and: [ flag = true ])  ifTrue: [
			Abort signal: 'Local object can not be dirty.'.
	]. 
	"if contextInfo is nil object and flag it false it's ok' "
	( self contextInfo isNil not )  ifTrue: [
			self contextInfo allDirtyBit: flag.
	]  .
	! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 11/12/2012 10:59'!
canonicalName 
	^ self name. ! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 11/13/2012 15:50'!
className
	"Answer a string characterizing the receiver's class, for use in list views for example"

	^ self class canonicalName asString! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 11/22/2012 14:25'!
contextIdentity
	self subclassResponsibility! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 11/22/2012 14:50'!
contextIdentity: aValue
	self subclassResponsibility! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 11/22/2012 14:50'!
contextIdentityHash
	self ensureIdentity.
	^ self contextIdentity hash. ! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 11/22/2012 14:50'!
contextIdentityLock
	self ensureIdentity.
	^ self contextIdentity lock. ! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 11/23/2012 11:17'!
contextInfo
	 self subclassResponsibility! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 11/23/2012 11:17'!
contextInfo: info
 	self subclassResponsibility! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 11/19/2012 17:28'!
copy
	"Answer another instance just like the receiver. Subclasses typically override postCopy; they typically do not override shallowCopy. Copy is a template method in the sense of Design Patterns. So do not override it. Override postCopy instead. Pay attention that normally you should call postCopy of your superclass too."
	self isPrimitive ifTrue: [
		^self shallowCopy postCopy
	] ifFalse: [
		^self forceLoad shallowCopy makeFreshLocal postCopy. 
	]! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 11/20/2012 08:24'!
copyFrom: anotherObject
	
	| info identity lock |
	
	self isPrimitive ifTrue: [ 
		^ self primCopyFrom: anotherObject. 
	].

	anotherObject forceLoad.
	
	info := self contextInfo.
	identity := self contextIdentity.
	"TODO: lock"
	
	self primCopyFrom: anotherObject. 
	
	self contextInfo: info.
	self contextIdentity: identity. ! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 10/12/2012 15:00'!
countChildrenObjects
	| visited potentialGlobal effectivelyGlobalDirty effectivelyGlobalClean |
	visited := IdentitySet new.
	potentialGlobal := IdentitySet new.
	effectivelyGlobalDirty := IdentitySet new.
	effectivelyGlobalClean := IdentitySet new. 
	self traverseAndDo:  [ :prev | 
		prev isClass ifFalse:  [
			prev isCtxGlobal 
				ifTrue: [ 
					prev hasDirtyBit ifTrue: [ effectivelyGlobalDirty add: prev ] 
							  ifFalse: [ effectivelyGlobalClean add: prev ]. ]
				ifFalse: [ potentialGlobal add: prev ].    
			].
		 ] exclude: visited .
	{  potentialGlobal  . effectivelyGlobalDirty . effectivelyGlobalClean   } inspect. 
	^ {  #potential -> potentialGlobal size . #hasDirtyBit -> effectivelyGlobalDirty size . #clean -> effectivelyGlobalClean size }.  

! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 11/13/2012 14:37'!
ctxClass: c
	| sym cc |
	
	cc := CurrentContext instance. "easier to debug if store in temp"
	(c = #Association ) ifTrue: [
		( cc = CurrentContext prevMe ) ifTrue: [ ^ AssociationL1 ].	
		( cc = CurrentContext nextMe ) ifTrue: [ ^ AssociationL2 ].
	].
	
	self error: 'Should now be replaced by static resolution at compile-time'.
	
	sym := c asSymbol .		  
	CurrentContext instance isNil ifTrue: [
		
		( sym =  #Delay ) ifTrue: [ ^ Delay ].	
		( sym =  #Array ) ifTrue: [ ^ ArrayL1 ].
		( sym =  #Association ) ifTrue: [ ^ AssociationL1  ].
		( sym =  #BlockClosure ) ifTrue: [ ^ BlockClosure ].
		( sym =  #HashedCollection ) ifTrue: [ ^ HashedCollectionL1 ].
		( sym =  #Dictionary ) ifTrue: [ ^ DictionaryL1 ].
		( sym =  #IdentityDictionary ) ifTrue: [ ^ IdentityDictionaryL1 ].
		( sym =  #Set ) ifTrue: [ ^ SetL1 ].
		( sym =  #LookupKey ) ifTrue: [ ^ LookupKeyL1  ].
		( sym =  #OrderedCollection ) ifTrue: [ ^ OrderedCollectionL1 ].
	
		self flag: 'should be remove afterwards when we always have a context'.
		
		^ Smalltalk at: sym. 
			
	] ifFalse:       
	[  
		^ CurrentContext instance resolveClass: sym.    
	]! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 9/27/2012 15:17'!
ctxInstVarNamed: name
	"ugly hack because I can not apparently name a method on instance and class side with same name"
	( self isClass and: [ name first isUppercase ]) ifTrue: [
		^ self classPool at: name asSymbol ifAbsent: [ self superclass  ctxInstVarNamed: name ]  .
	]  ifFalse: [   
		^ self instVarNamed: name.  
	]! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 9/27/2012 15:18'!
ctxInstVarNamed: name put: value
	"ugly hack because I can not apparently name a method on instance and class side with same name"
	( self isClass and: [ name first isUppercase ])  ifTrue: [
		self flag: 'Should handle inheritance, if the class var is not in this class but an upper one'.
		self classPool at: name asSymbol ifAbsent: [ ^ self superclass  ctxInstVarNamed: name put: value ]  .
		^ self classPool at: name asSymbol put: value.
	]  ifFalse: [   
		^ self instVarNamed: name put: value.
	]
	! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 11/6/2012 12:15'!
defMigrateToNext
	self isClass ifTrue: [
		self error: 'Should not migrate class this way'
		"^ (Smalltalk at: (self canonicalName , '2') asSymbol) globalize: self uuid."
	] ifFalse: [  
		"self class migrateToNextIfNecessary.."
		self assert: self class nextMe isNil not. 
		^ self class nextMe basicNew globalize: self uuid. 
	]  ! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 11/6/2012 12:15'!
defMigrateToPrev
	self isClass ifTrue: [
		self error: 'Should not migrate class this way'
		"^ (Smalltalk at: self canonicalName) globalize: self uuid."
	] ifFalse: [ 
		"self class migrateToPrevIfNecessary.."
		self assert: self class prevMe isNil not. 
		^ self class prevMe basicNew globalize: self uuid. 
	]  ! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 12/4/2012 14:08'!
defSynchronizeFromNext: index
	  
	self isClass ifTrue: [ self defSynchronizeFromNextClass: index ]
	ifFalse: [ self defSynchronizeFromNextObj: index ].  
	! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 11/2/2012 17:19'!
defSynchronizeFromNextClass: index
 
	| p pos |
	pos := index.
	p := self nextMe instVarAt: pos.   
	( p isPrimitive not )  ifTrue: [
		"lazy migration after update"
		p migrateToPrevIfNecessary. 
		self instVarAt: pos put: p prevMe. 
		"Transcript show: ( self uuid, '.' , field, ' := ', p next asString ); cr."
	] ifFalse: [
		self instVarAt: pos  put: p.  
		"Transcript show: ( self uuid, '.' , field, ' := ', p asString ); cr."
	]. 
! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 10/12/2012 15:19'!
defSynchronizeFromNextObj: pos

	| p |
	p := self nextMe instVarAt: pos.   
	( p isPrimitive not )  ifTrue: [
		"lazy migration after update"
		p migrateToPrevIfNecessary. 
		self instVarAt: pos put: p prevMe. 
		"Transcript show: ( self uuid, '.' , field, ' := ', p next asString ); cr."
	] ifFalse: [
		self instVarAt: pos  put: p.  
		"Transcript show: ( self uuid, '.' , field, ' := ', p asString ); cr."
	]. 
! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 12/4/2012 14:08'!
defSynchronizeFromPrev: index
	  
	self isClass ifTrue: [ self defSynchronizeFromPrevClass: index ]
	ifFalse: [ self defSynchronizeFromPrevObj: index ].  ! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 11/2/2012 17:20'!
defSynchronizeFromPrevClass: index

	| p pos |
	pos := index. 
	p := self prevMe instVarAt: pos.   
	( p isPrimitive not )  ifTrue: [
		"lazy migration after update"
		p migrateToNextIfNecessary.
		self instVarAt: pos put: p nextMe. .
		"Transcript show: ( self uuid, '.' , field, ' := ', p next asString ); cr."
	] ifFalse: [
		self instVarAt: pos  put: p.  
		"Transcript show: ( self uuid, '.' , field, ' := ', p asString ); cr."
	]. ! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 10/12/2012 15:19'!
defSynchronizeFromPrevObj: pos

	| p |
	p := self prevMe instVarAt: pos.   
	( p isPrimitive not )  ifTrue: [
		"lazy migration after update"
		p migrateToNextIfNecessary.
		self instVarAt: pos put: p nextMe. .
		"Transcript show: ( self uuid, '.' , field, ' := ', p next asString ); cr."
	] ifFalse: [
		self instVarAt: pos  put: p.  
		"Transcript show: ( self uuid, '.' , field, ' := ', p asString ); cr."
	]. 
! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 11/22/2012 12:18'!
detachNext
	|next|
	next := self nextMe. 
	self contextInfo: nil.
	next contextInfo: nil.  ! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 1/15/2012 15:50'!
dirtyBit: index
	| info flag |
	info := self contextInfo .
	info isNil ifTrue: [ self halt. ].
	flag := info dirtyBit: index.
	flag class = QuanticBoolean ifTrue: [ self halt. ].
	^ flag. ! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 1/15/2012 15:50'!
dirtyBit: index set: flag
	( self contextInfo isNil and: [ flag = true ])  ifTrue: [
			Abort signal: 'Local object can not be dirty.'.
	]. 
	"if contextInfo is nil object and flag it false it's ok' "
	( self contextInfo isNil not )  ifTrue: [
			self contextInfo dirtyBit: index set: flag.
	]  . 
	! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 11/26/2012 13:51'!
ensureIdentity
	"self contextIdentity isNumber ifTrue: [
		self contextIdentity: (ContextualUUID newFor: self). 	
	]."

	self contextIdentity ifNil: [
		self contextIdentity: (ContextualUUID newFor: self). 	
	]! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 11/22/2012 11:29'!
forceLoad

	self isCtxGlobal ifFalse: [ ^self ].

	self allContextInstVarsDo: [ :name :pos | 
		(self contextInfo dirtyBit: pos ) ifTrue: [ self synchronize: pos. ]
	].
! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 11/23/2012 16:27'!
forceRelease: visited

	self traverseAndDo:  [ :prev |
	"	(prev isKindOf: WAPluggableSite1 ) ifTrue: [ prev halt. ]."
		prev isClass ifFalse: [ prev detachNext. ].
		Processor yield. 
	] exclude: visited. 
! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 11/23/2012 16:27'!
forceSynchronization: visited 	

	self traverseAndDo:  [ :prev |
		"(prev isKindOf: WAPluggableSite1 ) ifTrue: [ prev halt. ]."
		prev isClass ifFalse: [
			prev contextIdentityLock critical: [  
				prev migrateToNextIfNecessary.
				prev nextMe forceLoad. 
			]
		].
		Processor yield. 
	] exclude: visited.  

! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 11/22/2012 14:47'!
globalize
	self isPrimitive ifTrue: [
		^ self. 
	].   
	self isClass ifTrue: [
		self halt: 'you should not call globalize on class'
	].
	self isCtxGlobal ifFalse: [   
		
		"Transcript show: ( 'Globalize ', self class , '@', self identityHash  ) ; cr."
		
		self contextInfo: ContextualInfo new.
		self contextInfo global: true.
		self contextInfo allDirtyBit: false.

	].
	^ self.
! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 10/11/2012 15:12'!
globalize: uuid
	self isPrimitive ifTrue: [
		^ self. 
	].   
	self isClass ifTrue: [
		self halt: 'you should not call globalize on class'
	].
	self isCtxGlobal ifFalse: [   
		
		"Transcript show: ( 'Globalize ', self class , '@', self identityHash  ) ; cr."
		
		self contextInfo: ContextualInfo new.
		self contextInfo global: true.
		self contextInfo allDirtyBit: false.
		self contextInfo uuid: uuid.

	].
	^ self.
! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 10/11/2012 15:13'!
hasDirtyBit
	| info flag |
	info := self contextInfo .
	info isNil ifTrue: [ self halt. ].
	flag := info hasDirtyBit.
	flag class = QuanticBoolean ifTrue: [ self halt. ].
	^ flag. ! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 11/23/2012 11:16'!
initialize 
	super initialize.! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 5/23/2011 10:15'!
isClass
	^ false! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 1/15/2012 15:53'!
isCtxGlobal
"	ContextStatistics checkStatistics  increment: self class. "

	self isPrimitive ifTrue: [
		^ false. 
	]. 
"	((self class = Array_ ) or: [ self class = BlockClosure_ ]) ifTrue: [ ^ true ]."
	(self class = Array ) ifTrue: [ ^ false ].
	^ self contextInfo isNil not.
	! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 11/19/2012 17:24'!
isPrimitive
	| names |
	
	^ true ! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 10/29/2012 07:19'!
isThreadSafe 
	^true ! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 11/19/2012 17:20'!
makeFreshLocal
	"TODO add __lock__"
	self contextIdentity: nil.
	self contextInfo: nil.
	! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 10/12/2012 15:48'!
markOtherAsDirty: index
	self prevMe
		ifNotNil: [ CurrentContext nextMe invalidatePrev: self index: index ]
		ifNil: [ self nextMe ifNotNil: [ CurrentContext nextMe invalidateNext: self index: index ]	"if there is only one context, there is not next/prev even if the object is global" ]! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 11/26/2012 13:51'!
migrateToNext
	| clone |
	clone :=  CurrentContext nextMe migrateToNext: self.  

	self ensureIdentity.  "fill context identity" 
	clone allDirtyBit: true.
	clone contextIdentity: self contextIdentity.   
	self nextMe: clone.
	clone prevMe: self.
	
	"CurrentContext prevMe addCapture: self. "
	! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 11/22/2012 14:47'!
migrateToNextIfNecessary
	self isCtxGlobal ifFalse: [ self globalize ].
	self nextMe ifNil: [ self migrateToNext ].
	! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 11/26/2012 13:51'!
migrateToPrev
	| clone |
	clone := CurrentContext nextMe migrateToPrev: self.  
		
	self ensureIdentity.  "fill context identity" 
	clone allDirtyBit: true.
	clone contextIdentity: self contextIdentity. 
	self prevMe: clone.
	clone nextMe: self.
	
"	CurrentContext prevMe addCapture: clone. "! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 11/22/2012 14:47'!
migrateToPrevIfNecessary
	self isCtxGlobal ifFalse: [ self globalize ].
	self prevMe ifNil: [ self migrateToPrev ].
	! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 8/24/2011 15:06'!
nextMe
	^ self contextInfo nextMe! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 8/24/2011 15:07'!
nextMe: anObject
	self contextInfo nextMe: anObject! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 9/14/2011 15:00'!
perform: selector withArguments: argArray inSuperclass: lookupClass
	^ self primPerform: selector withArguments: argArray asNativeArray inSuperclass: lookupClass. ! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 8/24/2011 15:08'!
prevMe
	^ self contextInfo prevMe! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 8/24/2011 15:07'!
prevMe: anObject
	self contextInfo prevMe: anObject! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 11/15/2012 09:27'!
primClassName
	"Answer a string characterizing the receiver's class, for use in list views for example"

	^ self class name asString! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 11/19/2012 17:37'!
primCopyFrom: anotherObject
	"Copy to myself all instance variables I have in common with anotherObject.  This is dangerous because it ignores an object's control over its own inst vars.  "

	| mine his |
	<primitive: 168>
	mine := self class allInstVarNames.
	his := anotherObject class allInstVarNames.
	1 to: (mine size min: his size) do: [:ind |
		(mine at: ind) = (his at: ind) ifTrue: [
			self instVarAt: ind put: (anotherObject instVarAt: ind)]].
	self class isVariable & anotherObject class isVariable ifTrue: [
		1 to: (self basicSize min: anotherObject basicSize) do: [:ind |
			self basicAt: ind put: (anotherObject basicAt: ind)]].! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 9/14/2011 15:00'!
primPerform: selector withArguments: argArray inSuperclass: lookupClass
	"NOTE:  This is just like perform:withArguments:, except that
	the message lookup process begins, not with the receivers's class,
	but with the supplied superclass instead.  It will fail if lookupClass
	cannot be found among the receiver's superclasses.
	Primitive. Essential. See Object documentation whatIsAPrimitive."

	<primitive: 100>
	(selector isSymbol)
		ifFalse: [^ self error: 'selector argument must be a Symbol'].
	(selector numArgs = argArray size)
		ifFalse: [^ self error: 'incorrect number of arguments'].
	(self class == lookupClass or: [self class inheritsFrom: lookupClass])
		ifFalse: [^ self error: 'lookupClass is not in my inheritance chain'].
	self primitiveFailed! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 11/19/2012 16:48'!
printOn: aStream
	"Append to the argument, aStream, a sequence of characters that  
	identifies the receiver."

	| title |
	title := self class name.
	aStream
		nextPutAll: (title first isVowel ifTrue: ['an '] ifFalse: ['a ']);
		nextPutAll: title ;
		nextPutAll: ' (' ;
		nextPutAll: self primIdentityHash printString ;
		nextPutAll: ')'.! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 10/11/2012 16:11'!
secure
	self ! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 10/12/2012 15:12'!
synchronize: indexOfField
		"self dirty: QuanticBoolean new.. "
		"Transcript show: ('Synchronize ', self class, '@', self identityHash ); cr."
		self prevMe ifNotNil: [
			CurrentContext nextMe synchronizeFromPrev: self index: indexOfField .     
		] 
		ifNil: [
			CurrentContext nextMe synchronizeFromNext: self index: indexOfField.   
		].
		self dirtyBit: indexOfField set: false. ! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 12/3/2012 14:36'!
synchronizeIfNecessary: indexOfField
	self contextIdentityLock critical: [ 
		
		"double-checked locking idiom" 
		self isCtxGlobal ifFalse: [ ^self ].
		
		(self dirtyBit: indexOfField ) ifTrue: [
			self synchronize: indexOfField.
		]
	]! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 12/4/2012 16:11'!
track
	"ContextStatistics trackInvocation: self. "
	^ self. ! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 12/3/2012 12:07'!
traverseAndDo: aBlock exclude: visited 
	
	self isPrimitive ifTrue: [ ^ self ].  
	( visited includes: self ) ifTrue: [ ^ self ].  
	visited add: self. 	
	aBlock value: self. 
	self class isVariable ifTrue: [ self halt. ].
	self allContextInstVarsDo: [ :name :pos |
		 ( self instVarAt: pos ) traverseAndDo: aBlock exclude:  visited  ].! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 7/6/2011 11:44'!
uuid
	^ self contextInfo uuid! !

!Object methodsFor: '*ActiveContext' stamp: 'ewe 7/7/2011 12:10'!
uuid: aUuid

	Abort signal: 'Only global object have UUID and it must be set only when initially globalized with globalize:'! !

Object subclass: #QuanticBoolean
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Core'!

!QuanticBoolean methodsFor: 'as yet unclassified' stamp: 'ewe 8/12/2011 13:19'!
ifFalse: a 
Abort signal: 'In unknown state'. ! !

!QuanticBoolean methodsFor: 'as yet unclassified' stamp: 'ewe 8/12/2011 13:19'!
ifFalse: a ifTrue: b 
Abort signal: 'In unknown state'. ! !

!QuanticBoolean methodsFor: 'as yet unclassified' stamp: 'ewe 8/12/2011 13:19'!
ifTrue: a 
Abort signal: 'In unknown state'. ! !

!QuanticBoolean methodsFor: 'as yet unclassified' stamp: 'ewe 8/12/2011 13:19'!
ifTrue: a ifFalse:  b
Abort signal: 'In unknown state'. ! !

Object subclass: #VirtualField
	instanceVariableNames: 'binding'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActiveContext-Core'!

VirtualField class
	instanceVariableNames: 'instance'!

VirtualField class
	instanceVariableNames: 'instance'!

!VirtualField class methodsFor: 'as yet unclassified' stamp: 'ewe 5/19/2011 15:25'!
instance
	instance isNil ifTrue: [ 
		instance := self new.
	].
	^ instance .! !

!VirtualField class methodsFor: 'as yet unclassified' stamp: 'ewe 7/5/2011 17:12'!
reset
	instance:= nil.! !

!VirtualField methodsFor: 'default-field' stamp: 'ewe 11/23/2012 11:29'!
bind: anObject to: aContextInfo
	self bind: anObject to: aContextInfo field: #default  ! !

!VirtualField methodsFor: 'virtual-field' stamp: 'ewe 11/23/2012 11:51'!
bind: anObject to: aContextInfo field: aField
	aContextInfo isNil ifTrue:[
		self unbind: anObject field: aField .  
	] ifFalse: [
		| fields | 
		fields := binding at: anObject ifAbsent: [ binding at: anObject put: Dictionary new].
		fields at: aField put: aContextInfo. 
	].! !

!VirtualField methodsFor: 'accessing' stamp: 'ewe 8/8/2011 11:26'!
binding
	^binding! !

!VirtualField methodsFor: 'default-field' stamp: 'ewe 11/23/2012 11:30'!
for: anObject
	^self for: anObject field: #default! !

!VirtualField methodsFor: 'virtual-field' stamp: 'ewe 11/23/2012 11:48'!
for: anObject field: aField
	| fields | 
	fields := binding at: anObject ifAbsent: [ ^nil ].
	^ fields at: aField ifAbsent: [ nil ].! !

!VirtualField methodsFor: 'initialize-release' stamp: 'ewe 5/19/2011 15:26'!
initialize 
	binding := WeakIdentityKeyDictionary new.! !

!VirtualField methodsFor: 'default-field' stamp: 'ewe 11/23/2012 11:30'!
unbind: anObject 
	self unbind: anObject field: #default
! !

!VirtualField methodsFor: 'virtual-field' stamp: 'ewe 11/23/2012 11:49'!
unbind: anObject field: aField
	| fields | 
	fields := binding at: anObject ifAbsent: [ ^self ].
	fields removeKey: aField ifAbsent:   [ ].
! !

!ClassDescription methodsFor: '*ActiveContext' stamp: 'ewe 5/23/2011 10:15'!
isClass
	^ true! !

!ClassDescription methodsFor: '*ActiveContext' stamp: 'ewe 10/12/2012 11:39'!
trimDigitRight: aString
	(aString last isDigit ) ifTrue: [
		^ self trimDigitRight: (aString copyFrom: 1 to: aString size - 1) asSymbol.
	].
	^ aString. ! !

!ClassDescription methodsFor: '*ActiveContext' stamp: 'ewe 11/6/2012 13:49'!
trimLorS: aString
	(aString last = $L or: [aString last = $S]  ) ifTrue: [
		^ aString copyFrom: 1 to: aString size - 1.
	].
	^ aString. 
	! !
CurrentContext initialize!
